Attribute VB_Name = "Components"
'''''''''''''''''''''''''''
''' Component Machinery '''
'''''''''''''''''''''''''''

Const MaxComponents = 300
Public Cnames(MaxComponents) As String
Public Components(MaxComponents) As Queue
Public CurrentComponent(MaxComponents) As String
Public NumComponents As Integer

Public V2 As Boolean 'Include Version 2 objects?

Public InDefineComponent As Boolean

Sub Install_Components_Library()
    ''Define all components which might be used by models.
    
    Dim i As Integer
    
    Init_Component_System
    
'    define_component "Test object"
'        Box 0, 0, 10, 0, 20, 20, 20, "Center Block"
'        For i = 1 To 4
'            Box i * 50, i * 50, 0, i * 90, 10, 10, 10, "Corner Block"
'        Next i
'    end_component
    
    Const bWidth = 10
    Const bLength = 45
    
    define_component "Test Component"
        Box 0, 0, 0, 45, 100, 200, 300
    end_component

    
    define_component "Anduin Bridge"
    
        Box 0, 0, 5, 0, bLength, bWidth, 3, "Main bridge surface"
        
        'Towers
        Box -bLength, bWidth, 0, 0, 2, 2, 15
        Pyramid -bLength, bWidth, 15, 0, 3, 3, 3
        
        Box -bLength, -bWidth, 0, 0, 2, 2, 15
        Pyramid -bLength, -bWidth, 15, 0, 3, 3, 3
        
        Box bLength, bWidth, 0, 0, 2, 2, 15
        Pyramid bLength, bWidth, 15, 0, 3, 3, 3
        
        Box bLength, -bWidth, 0, 0, 2, 2, 15
        Pyramid bLength, -bWidth, 15, 0, 3, 3, 3
        
        'End areas
        Box -bLength - bWidth * 1.5, 0, 0, 0, bWidth * 1.5, bWidth * 1.5, 5
        Box bLength + bWidth * 0.15, 0, 0, 0, bWidth * 1.5, bWidth * 1.5, 5
        
    end_component

    define_component "Dihedral structure"
        'Pyramid 0, 0, 0, 0, 20, 20, 20
        'Pyramid 0, 0, 20, 0, 15, 15, -10
        'box x, y, z, theta, sX, sY, sZ
        Box 0, 0, 0, 45, 1, 20, 16
        Box 0, 0, 0, 135, 1, 20, 16
        'top
        Box 0, 0, 16, 0, 20, 20, 2
    end_component
    
    define_component "Minigarage"
            Const gwidth = 40
            Const doorsize = 12
            Const gborder = 5
            Const dsize = 2
            
            Dim smallLength, smalloffset
            smallLength = (gwidth - doorsize / 2) / 2#
            smalloffset = gwidth - smallLength
            Box 0, 0, 8, 0, gwidth + gborder, gwidth + gborder, 2
            Box 0, 0, 18, 0, gwidth + gborder, gwidth + gborder, 2
            
            Box -gwidth, smalloffset, 0, 0, dsize, smallLength, 8
            Box gwidth, smalloffset, 0, 0, dsize, smallLength, 8
            Box -gwidth, -smalloffset, 0, 0, dsize, smallLength, 8
            Box gwidth, -smalloffset, 0, 0, dsize, smallLength, 8

            Box -smalloffset, gwidth, 0, 0, smallLength, dsize, 8
            Box smalloffset, gwidth, 0, 0, smallLength, dsize, 8
            Box -smalloffset, -gwidth, 0, 0, smallLength, dsize, 8
            Box smalloffset, -gwidth, 0, 0, smallLength, dsize, 8

            Box -gwidth, smalloffset, 10, 0, dsize, smallLength, 8
            Box gwidth, smalloffset, 10, 0, dsize, smallLength, 8
            Box -gwidth, -smalloffset, 10, 0, dsize, smallLength, 8
            Box gwidth, -smalloffset, 10, 0, dsize, smallLength, 8

            Box -smalloffset, gwidth, 10, 0, smallLength, dsize, 8
            Box smalloffset, gwidth, 10, 0, smallLength, dsize, 8
            Box -smalloffset, -gwidth, 10, 0, smallLength, dsize, 8
            Box smalloffset, -gwidth, 10, 0, smallLength, dsize, 8
            
            Const gpsize = 3
            Const gpdelta = 6
            Const gpheight = 50
            Pyramid -gwidth - gpdelta, -gwidth - gpdelta, 0, 0, gpsize, gpsize, gpheight
            Pyramid -gwidth - gpdelta, gwidth + gpdelta, 0, 0, gpsize, gpsize, gpheight
            Pyramid gwidth + gpdelta, -gwidth - gpdelta, 0, 0, gpsize, gpsize, gpheight
            Pyramid gwidth + gpdelta, gwidth + gpdelta, 0, 0, gpsize, gpsize, gpheight
            
    end_component

        'Let's define a fort
    define_component "Minor fort"
        Const FundamentalUnitSize = 3
        Dim UnitSize As Integer
        Dim OneWidth As Integer
        Dim TwoWidth As Integer
        Dim FourWidth As Integer
        Dim EightWidth As Integer
        Dim SixteenWidth As Integer
        Dim BlockHeight As Integer
        Dim BlockWidth As Integer
        Dim Wallheight As Integer
        Dim ptemp As Integer
        
        ''Initialization
        UnitSize = FundamentalUnitSize '3
        OneWidth = UnitSize             '3 - Single pillar width
        TwoWidth = 2 * OneWidth         '6 - Small square block
        FourWidth = 2 * TwoWidth        '12 - Basic workhorse block
        EightWidth = 2 * FourWidth      '24 - Medium long block
        SixteenWidth = 2 * EightWidth   '48 - Long block
        BlockHeight = TwoWidth
        BlockWidth = OneWidth

        Box 0, 0, FourWidth, 0, 10 * UnitSize, 10 * UnitSize, UnitSize
        'Four corner supports
        bsize = FourWidth 'twowidth
        Box -8 * UnitSize, -8 * UnitSize, 0, 0, bsize, bsize, EightWidth
        Box -8 * UnitSize, 8 * UnitSize, 0, 0, bsize, bsize, EightWidth
        Box 8 * UnitSize, -8 * UnitSize, 0, 0, bsize, bsize, EightWidth
        Box 8 * UnitSize, 8 * UnitSize, 0, 0, bsize, bsize, EightWidth
        
        'Pyramids
        Pyramid -15 * UnitSize, 0, 0, 45, TwoWidth, TwoWidth, 4 * FourWidth
        Pyramid 15 * UnitSize, 0, 0, 45, TwoWidth, TwoWidth, 4 * FourWidth
        
        'Fillets by corners
        Fheight = EightWidth
        Box -9 * UnitSize, -4 * UnitSize, FourWidth + UnitSize, 0, UnitSize, TwoWidth, Fheight
        Box -9 * UnitSize, 4 * UnitSize, FourWidth + UnitSize, 0, UnitSize, TwoWidth, Fheight
        Box 9 * UnitSize, -4 * UnitSize, FourWidth + UnitSize, 0, UnitSize, TwoWidth, Fheight
        Box 9 * UnitSize, 4 * UnitSize, FourWidth + UnitSize, 0, UnitSize, TwoWidth, Fheight
   
        Box -4 * UnitSize, -9 * UnitSize, FourWidth + UnitSize, 0, TwoWidth, UnitSize, Fheight
        Box 4 * UnitSize, -9 * UnitSize, FourWidth + UnitSize, 0, TwoWidth, UnitSize, Fheight
        Box -4 * UnitSize, 9 * UnitSize, FourWidth + UnitSize, 0, TwoWidth, UnitSize, Fheight
        Box 4 * UnitSize, 9 * UnitSize, FourWidth + UnitSize, 0, TwoWidth, UnitSize, Fheight
   
        'Second platform
        Box 0, 0, 30, 0, 9 * UnitSize, 9 * UnitSize, UnitSize
    end_component
        
    define_component "Tower with bands"
        Box -70, 40, 0, 0, 40, 40, 60
        comment "Border at lower height around main block"
        'Border_Block x, y, z, width, length, theta, borderwidth, borderheight
        Border_Block -70, 40, 0, 40, 40, 0, 8, 11
        comment "Border at heighter height around main block"
        Border_Block -70, 40, 0, 40, 40, 0, 6, 45
        comment "Block on top of larger main block"
        Box -70, 40, 60, 0, 20, 20, 18
    end_component
End Sub

Sub Init_Component_System()
    NumComponents = -1 'Means that the first one will be zero.
End Sub

Sub define_component(CName As String)
    Dim nQ As New Queue
    CurrentQueue = CurrentQueue + 1
    Set GQueue(CurrentQueue) = nQ
    ''Now, all block draw, etc. will be in the new queue.
    CurrentComponent(CurrentQueue) = CName
End Sub

Sub end_component()
    'Take the current queue and save it to the Components array.
    NumComponents = NumComponents + 1
    Set Components(NumComponents) = GQueue(CurrentQueue)
    Cnames(NumComponents) = CurrentComponent(CurrentQueue)
    CurrentQueue = CurrentQueue - 1
End Sub

Function Find_Component(inName As String) As Long
    Dim i As Long
    For i = 0 To MaxComponents
        If LCase(Cnames(i)) = LCase(inName) Then
            Find_Component = i
            Exit Function
        End If
    Next i
    Find_Component = -1
End Function

Sub Place_Component(name As String, destX, destY, destZ, _
        destTheta, Optional Scalefactor = 1#)
    Dim i_comp As Long
    Dim ResultX As Double
    Dim ResultY As Double
    Dim ResultZ As Double
    Dim resultTheta As Double
    Dim BZobj As BZFlagObject
    Dim objQ As Queue
    Dim i As Long
    Dim BZtype As String
    Dim x, y, z, theta, xSize, ySize, zSize, bsize
    Dim subobjName As String
    Dim NewName As String
    Dim sTh As Boolean
    Dim dTh As Boolean
    Dim Flipz As Boolean
    
    If Scalefactor = 0 Then
        MsgBox "Scalefactor is zero!  Can't do infinitely small objects."
        Error 1
    End If
    
    icomp = Find_Component(name)
    If icomp = -1 Then
        MsgBox "Could not find component named """ & name & """"
        Error 1
        Exit Sub
    End If
    
    Set objQ = Components(icomp)
    
    'Now, run through the Queue, processing it by transforming each object.
    For i = objQ.FirstEntry To objQ.NumEntries
        ''On Error GoTo trynext 'This is where things fail.
        Set BZobj = objQ.GetEntry(i)
        'Destructure
        BZtype = BZobj.ObjectType
        subobjName = BZobj.name
        x = BZobj.x * Scalefactor
        y = BZobj.y * Scalefactor
        z = BZobj.z * Scalefactor
        bsize = BZobj.bsize * Scalefactor
        theta = BZobj.theta
        xSize = BZobj.xSize * Scalefactor
        ySize = BZobj.ySize * Scalefactor
        zSize = BZobj.zSize * Scalefactor
        sTh = BZobj.ShootThrough
        dTh = BZobj.DriveThrough
        Flipz = BZobj.Flipz
        NewName = name & "/" & subobjName
        'Transform to new coordinates
        set_transform_values x, y, -destTheta
        ResultX = transform_result_x() + destX
        ResultY = transform_result_y() + destY
        ResultZ = destZ + z
        
        resultTheta = theta + destTheta
        
        'Dispatch to normal drawing in new location
         Select Case LCase(BZtype)
            Case "string"
                emit "# " & name
            Case "box"
                Box ResultX, ResultY, ResultZ, resultTheta, xSize, ySize, zSize, NewName
            Case "pyramid"
                Pyramid ResultX, ResultY, ResultZ, resultTheta, xSize, ySize, zSize, sTh, dTh, Flipz, NewName
            Case "teleporter"
                Teleporter ResultX, ResultY, ResultZ, resultTheta, xSize, ySize, zSize, bsize, name
        End Select
trynext:
    Next i
End Sub

