Attribute VB_Name = "FileParsing"
Public Tokens(10)
Public NumTokens As Integer

Dim objType As String
Dim pos_x As String
Dim pos_y As String
Dim pos_z As String
Dim theta As String
Dim size_x As String
Dim size_y As String
Dim size_z As String
Dim linkfrom As String
Dim linkto As String
Dim bsize As String
Dim ShootThrough As Boolean
Dim DriveThrough As Boolean
Dim Flipz As Boolean
Dim Prefix

Sub start_file_parse()
    Dim fnum_in As Integer
    Dim fnum_out As Integer
    Dim inFile As String
    Dim outFile As String
    Dim commentBody As String
    
    Dim inLine As String
    Dim FirstToken As String
    
    Dim LineNumber
    Dim nstrings, nboxes, npyramids, nteleporters, ntotal, nlinks, nelse
    nstrings = 0
    nboxes = 0
    npyramids = 0
    nteleporters = 0
    ntotal = 0
    nlinks = 0
    
    Prefix = Chr(9) 'tab
    
    inFile = Form1.inMapFile.Text
    outFile = Form1.OutMapDir & Form1.inModule.Text & ".bas"
    fnum_in = FreeFile
    
    'On Error GoTo open_error
    Open inFile For Input As #fnum_in
    fnum_out = FreeFile
    Open outFile For Output As #fnum_out
    
    'Write header
    Print #fnum_out, "sub Write_" & Form1.inModule.Text & " ()"
        Randomize
    
    Print #fnum_out, Prefix & "'' Try to open the output file; exit if error."
    Print #fnum_out, Prefix & "If Not Open_Output_File(""P_" & Form1.inModule.Text & """) Then"
    Print #fnum_out, Prefix & "    Exit Sub"
    Print #fnum_out, Prefix & "End If"
    
    Call Write_Parsed_Header(fnum_out, Form1.inMapFile.Text, Form1.inModule.Text)

        
    LineNumber = 0
    Do While Not EOF(fnum_in)
        LineNumber = LineNumber + 1
        Line Input #fnum_in, inLine
    
        'Dispatch based on this line.
        If Mid(inLine, 1, 1) = "#" Then
            nstrings = nstrings + 1
            commentBody = Mid(inLine, 2)
            Print #fnum_out, Prefix & "comment """ & commentBody & """"
            GoTo looppt
        End If
        
        
        'Break line apart into tokens
        tokenize_line (inLine)
        
        'Could be nothing; just whitespace.
        If NumTokens = 0 Then GoTo looppt
        
        'Check first token
        FirstToken = Tokens(1)
        
        Select Case LCase(FirstToken)
            Case "box"
                nboxes = nboxes + 1
            Case "pyramid"
                npyramids = npyramids + 1
            Case "teleporter"
                nteleporters = nteleporters + 1
            Case "link"
                nlinks = nlinks + 1
            Case "position", "end", "rotation", "size", "from", "to", "border", "drivethrough", "shootthrough", "flipz"
                'These are internal tags, we don't count them.
            Case Else
                nelse = nelse + 1
                MsgBox "Did not know how to count: " & FirstToken
                Error 1
        End Select
        
        Select Case LCase(FirstToken)
            Case "box", "pyramid", "teleporter", "link"
                objType = LCase(FirstToken)
            
            Case "end"

                'Write out statement!
                Call write_out_statement(fnum_out)
                
                'Re-init state variables
                ShootThrough = False
                DriveThrough = False
                Flipz = False
                
            Case "position"
                'Consume next 3 tokens
                pos_x = Tokens(2)
                pos_y = Tokens(3)
                pos_z = Tokens(4)
            
            Case "rotation"
                theta = Tokens(2)
            
            Case "size"
                size_x = Tokens(2)
                size_y = Tokens(3)
                size_z = Tokens(4)
            
            Case "from"
                linkfrom = Tokens(2)
            
            Case "to"
                linkto = Tokens(2)
            
            Case "border"
                bsize = Tokens(2)
                
            Case "shootthrough"
                ShootThrough = True
                
            Case "drivethrough"
                DriveThrough = True
                
            Case "flipz"
                Flipz = True
                
            Case Else
                MsgBox "Error, line " & CStr(LineNumber) & ", """ & inLine & """" & ": unknown token """ & FirstToken & """"
                Error 1
        End Select
looppt:
        
    Loop
    
    Print #fnum_out, "end sub"
    GoTo getout
    
    ''' error handling
open_error:
    MsgBox "Could not open file """ & inFile & """; error: " & Err.Description

getout:
    Close #fnum_in
    Close #fnum_out
    
    Form1.nstrings = nstrings
    Form1.nboxes = nboxes
    Form1.npyramids = npyramids
    Form1.nteleporters = nteleporters
    Form1.TotalRendered = nboxes + npyramids + nteleporters
    Form1.ntotal = nstrings + nboxes + npyramids + nteleporters + nelse
    Form1.nUnknown = nelse
    Form1.nlinks = nlinks

    Exit Sub

End Sub


Sub tokenize_line(inLine As String)
    Dim i1 As Integer, i2 As Integer, iSmallest As Integer
    Dim t1_str As String
    Dim SpaceChar As String
    Dim TabChar As String
    Dim FirstChar As String
    Dim WorkString As String
    Dim Token As String
    
    SpaceChar = Chr(32)
    TabChar = Chr(9)
    WorkString = inLine
    NumTokens = 0       'What we've already found
    
grab_next_token:
    
    'Termination condition
    If WorkString = "" Then
        Exit Sub
    End If

    'Strip off leading spaces
    FirstChar = Mid(WorkString, 1, 1)
    If FirstChar = SpaceChar Or FirstChar = TabChar Then
        WorkString = Mid(WorkString, 2)
        GoTo grab_next_token
    End If
    
    'Find first whitespace to deliminate token
    i1 = InStr(1, WorkString, SpaceChar)
    i2 = InStr(1, WorkString, TabChar)
    
    If i1 = 0 Then
        If i2 = 0 Then
            iSmallest = Len(WorkString) + 1
        Else
            iSmallest = i2
        End If
    Else
        If i2 = 0 Then
            iSmallest = i1
        Else
            'both are non-zero
            If i1 < i2 Then
                iSmallest = i1
            Else
                iSmallest = i2
            End If
        End If
    End If
    
    Token = Mid(WorkString, 1, iSmallest - 1)
    WorkString = Mid(WorkString, iSmallest + 1)
    NumTokens = NumTokens + 1
    Tokens(NumTokens) = Token
    GoTo grab_next_token
    
End Sub


Sub write_out_statement(fnum As Integer)
    Dim tString As String
    'Use the parsed fragments to build a call
    Select Case objType
        Case "box"
            'box x, y, z, theta, sizeX, sizeY, sizeZ
            Print #fnum, Prefix & "box " & pos_x & ", " & pos_y & ", " & pos_z & ", " & _
                theta & ", " & size_x & ", " & size_y & ", " & size_z
        
        Case "pyramid"
            'pyramid x, y, z, theta, sizeX, sizeY, sizeZ
            tString = Prefix & "pyramid " & pos_x & ", " & pos_y & ", " & pos_z & ", " & _
                theta & ", " & size_x & ", " & size_y & ", " & size_z
            If ShootThrough Then
                tString = tString & ", true"
            Else
                tString = tString & ", false"
            End If
            If DriveThrough Then
                tString = tString & ", true"
            Else
                tString = tString & ", false"
            End If
            If Flipz Then
                tString = tString & ", true"
            Else
                tString = tString & ", false"
            End If
            Print #fnum, tString
        
        Case "teleporter"
            'Teleporter x, y, z, Rotation, sizeX, sizeY, sizeZ
            Print #fnum, Prefix & "teleporter " & pos_x & ", " & pos_y & ", " & pos_z & ", " & _
                theta & ", " & size_x & ", " & size_y & ", " & size_z & ", " & bsize
                
        
        Case "link"
            'makelink startT, endT
            Print #fnum, Prefix & "makelink " & linkfrom & ", " & linkto
        
        Case Else
            MsgBox "Unknown object type: """ & objType & """"
            Error 1
    End Select
End Sub

Sub Write_Parsed_Header(fnum As Integer, inFilename As String, outModule As String)
    Print #fnum, Prefix & "comment ""Module """ & outModule & """, parsed from """ & inFilename & """"""
    Print #fnum, Prefix & "comment "" """
    Print #fnum, Prefix & "comment """ & Date & " " & Time() & """"
    Print #fnum, Prefix & "comment "" """
    Print #fnum, Prefix & "comment ""Parser, code support system by"""
    Print #fnum, Prefix & "comment "" """
    Print #fnum, Prefix & "comment "" Bryan A. Bentz"""
    Print #fnum, Prefix & "comment ""       a.k.a. ""The Purple Panzer"""
    Print #fnum, Prefix & "comment ""       Email:"""
    Print #fnum, Prefix & "comment ""            bentz@bentz-engineering.com, or """
    Print #fnum, Prefix & "comment ""            bentz@; ai.mit.edu; """
    Print #fnum, Prefix & "comment ""       URLs:"""
    Print #fnum, Prefix & "comment ""            Personal URL: http://www-swiss.ai.mit.edu/~bentz/"""
    Print #fnum, Prefix & "comment ""            Business URL: http://www.bentz-engineering.com/"""
    Print #fnum, Prefix & "comment "" """
    Print #fnum, Prefix & "comment "" """
End Sub
