Attribute VB_Name = "File_IO"
Public Const MapExtension = ".bzw"

''''''''''''''''''''''''''''''''''''
''' Manipulating the Output File '''
''''''''''''''''''''''''''''''''''''
Public FileNum As Integer  'Output file ID, found using FREEFILE

Function Open_Output_File(mapname As String, Optional CTF As Boolean = False) As Boolean
    Dim fname As String
    '' Read the output file from the startup form.
    fname = Form1.OutMapDir.Text & mapname & MapExtension
    'MsgBox "Creating file " & fname
    Call Write_Batch_File(mapname, CTF)
    
    '' If it exists, delete it.
    If Dir(fname) <> "" Then
        Kill fname
    End If
    
    '' Determine a file ID number to use, open the file.
    FileNum = FreeFile
'    On Error GoTo Couldnot_Open_File
    Open fname For Output As #FileNum
    Open_Output_File = True
    initialize_queues
    NumBoxes = 0
    NumPyramids = 0
    NumTeleporters = 0
    
    Exit Function
    
    '' Error handling - file could not be opened.
Couldnot_Open_File:
    MsgBox ("Couldn't open output file """ & fname & """; " & Err.Description)
    Open_Output_File = False
End Function


Sub raw_emit(inarg As String)
    '' A raw write to the output file.
    NumDirect = NumDirect + 1
    Print #FileNum, inarg
End Sub


Sub emit_File_Info()
    raw_emit " "
    raw_emit "####### File Information #######"
    raw_emit "#  Total number of objects: " & CStr(GQueue(0).NumEntries)
    raw_emit "#  Number of boxes: " & CStr(NumBoxes)
    raw_emit "#  Number of pyramids: " & CStr(NumPyramids)
    raw_emit "#  Number of teleporters: " & CStr(NumTeleporters)
    raw_emit "#  Number of links: " & CStr(NumLinks)
    raw_emit "#  Number of comments (not including these File Information comments): " & CStr(NumComments)
    raw_emit " "
End Sub

Sub section(inName As String)
    '' Write out a distinctive section title that will be easy to
    '' spot in the world file.
    Dim ilength As Integer
    Dim iOutlength As Integer
    Dim iBar As String
    Const CommentChars = "########################################################"
    
    ilength = Len(inName)
    iOutlength = ilength + 8 ' There will be a leading "### ", and a trailing " ###"
    iBar = Mid(CommentChars, 1, iOutlength)
    comment " "
    comment iBar
    comment "### " & inName & " ###"
    comment iBar
    comment " "
End Sub

Sub Close_Output_File()
    'Do the queue processing (here for now, for backwards compatibility)
        'File info
    

    ProcessQueue GQueue(0)
    Close #FileNum
    
End Sub


'''''''''''''''''''''''''''
''' Batch file creation '''
'''''''''''''''''''''''''''

Sub Write_Batch_File(inName As String, Optional CTF As Boolean = False)

    Dim fname As String
    Dim fnum As Integer
    Dim MapFile As String
    Dim sStr As String
    Dim ServerExe As String
    MapFile = Form1.OutMapDir.Text & inName & MapExtension
    
    'ServerExe = "C:\Program Files\BZFlag1.10.8\bzfs.exe"
    ServerExe = "C:\Program Files\" & Form1.BZVersion & "\bzfs.exe"
    fname = Form1.OutMapDir.Text & inName & ".bat"
    If Dir(fname) <> "" Then
        Kill fname
    End If
    fnum = FreeFile
    Open fname For Output As #fnum
    Print #fnum, "@ECHO OFF"
    Print #fnum, "ECHO BZFlag Server [TIRYNS:5156], " & MapFile
'    Print #fnum, """" & ServerExe & """" & _
'        " -j" & _ 'allows jumping
'        " -mp 15" & _ 'max number of players
'        " -ms 7" & _ 'max number of shots
'        " -passwd donitz" & _
'        " -public """ & fname & """ &" _
'        ; " -s 200" & _ 'max number of flags
'        " -publicaddr 64.252.0.191" & _
'        " +r" & _ 'most shots ricochet
'        " +s 50" & _ 'have an extra 50 flags
'        " +f L" & _  'forces laser
'        " -fb " & _ 'flags on buildings
'        " -f R" & _  'removes ricochet
'        " -f JP" & _ 'removes jumping
'        " -fb" & _
'        " -r" & _  'Allows rogues
'        " -sa" & _ 'antidote flags
'        " -st 3" & _ 'bad flag drop time
'        " -sw 1" & _ 'bad flag drop win count
'        " -ttl 255" & _
'        " -srvmsg ""Purple Panzer Map: " & fname & """ -world " & fname
     
     sStr = """" & ServerExe & """" & _
        " -d -d " & _
        " -j" & _
        " -mp 15" & _
        " -ms 7" & _
        " -passwd donitz" & _
        " -public ""Purple Panzer code-based map: " & inName & """" & _
        " -s 200" & _
        " -p 5156" & _
        " -publicaddr localhost:5156" & _
        " +s 50" & _
        " +f L" & _
        " -f R" & _
        " +r" & _
        " -f JP" & _
        " -fb" & _
        " -sa" & _
        " -st 3" & _
        " -sw 1" & _
        " -srvmsg ""PP-Gen Map: " & inName & """ -world " & MapFile
    If CTF Then sStr = sStr & " -c "
     Print #fnum, sStr
   Close #fnum
End Sub
