Attribute VB_Name = "JumpBox_Module"
Dim JumpBoxNum As Integer
Const JumpBoxColor = "GreenYellow"
Dim jumpbox_material_done As Integer

Public Sub tJumpBox(x, y, z, theta, dx, dy, dz)
    JumpBoxNum = JumpBoxNum + 1
    Call jumpbox_physics(JumpBoxNum, dx, dy, dz)
    Call jumpbox_material
    
    'Build a mesh, and associate the faces with the driver.
    raw_emit ("mesh")
'    raw_emit ("vertex 10 12 0")
'    raw_emit ("vertex 12 10 0")
'    raw_emit ("vertex 14 10 0")
'    raw_emit ("vertex 5 12, 0")
'    raw_emit ("vertex")
    
    raw_emit ("vertex 10.0 5.0 0.0")
    raw_emit ("vertex 14.0 4.0 0.0")
    raw_emit ("vertex 16.0 8.0 0.0")
    raw_emit ("vertex 8.0 16.0 0.0")

    raw_emit ("vertex 4.0 14.0 0.0")
    raw_emit ("vertex 5.0 10.0 0.0")
    raw_emit ("vertex -10.0 -5.0 0.0")
    raw_emit ("vertex -14.0 -4.0 0.0")

    raw_emit ("vertex -16.0 -8.0 0.0")
    raw_emit ("vertex -8.0 -16.0 0.0")
    raw_emit ("vertex -4.0 -14.0 0.0")
    raw_emit ("vertex -5.0 -10.0 0.0")
    raw_emit ("normal 0.0 0.0 1.0")
    
    raw_emit ("   face")
     raw_emit ("     vertices 0 1 2")
     raw_emit ("     normals 0 0 0")
     raw_emit ("     texcoords 0 1 2")
     raw_emit ("     matref jumpbox_material")
     raw_emit ("     phydrv jumpbox" & CStr(JumpBoxNum))
     raw_emit ("   endface")
     raw_emit ("   face")
     raw_emit ("     vertices 3 4 5")
     raw_emit ("      normals 0 0 0")
     raw_emit ("     texcoords 3 4 5")
     raw_emit ("     matref jumpbox_material")
     raw_emit ("     phydrv jumpbox" & CStr(JumpBoxNum))
     raw_emit ("   endface")
     raw_emit ("   face")
     raw_emit ("     vertices 6 7 8")
     raw_emit ("     normals 0 0 0")
     raw_emit ("     texcoords 6 7 8")
     raw_emit ("     matref jumpbox_material")
     raw_emit ("     phydrv jumpbox" & CStr(JumpBoxNum))
     raw_emit ("   endface")
     raw_emit ("   face")
     raw_emit ("     vertices 9 10 11")
     raw_emit ("     normals 0 0 0")
     raw_emit ("     texcoords 9 10 11")
     raw_emit ("     matref jumpbox_material")
     raw_emit ("     phydrv jumpbox" & CStr(JumpBoxNum))
     raw_emit ("   endface")
     raw_emit (" end")

End Sub


Public Sub JumpBox(x, y, z, theta, dx, dy, dz)
    If Not V2 Then Exit Sub
    JumpBoxNum = JumpBoxNum + 1
    Call jumpbox_physics(JumpBoxNum, dx, dy, dz)
    Call jumpbox_material
    raw_emit ("meshbox")
    raw_emit ("  shift " & nArg(x) & " " & nArg(y) & " " & nArg(z))
    raw_emit ("  phydrv jumpbox" & CStr(JumpBoxNum))
    'raw_emit ("  size 14 500 0.9")
    raw_emit ("  size 15 15 5")
    raw_emit ("  rotation " & nArg(theta + 90))
    raw_emit ("  angle 360")
    raw_emit ("  ratio 1")
    raw_emit ("  divisions 4")
    raw_emit ("  spin 0 0 0 0") 'last digit was 1
    raw_emit ("  shift 0 0 0")
    raw_emit ("  flatshading")
    'raw_emit ("  drivethrough")
    'raw_emit ("  texsize -8 -8 -8 -8")
    'raw_emit ("  color " & JumpBoxColor)
    raw_emit ("  matref jumpbox_material")
    'raw_emit ("  bottom matref highway1")
    'raw_emit ("  inside matref highway1")
    'raw_emit ("  outside matref highway1")
    'raw_emit ("  startside matref highway1")
    'raw_emit ("  endside matref highway1")
    raw_emit ("end")
End Sub

Sub jumpbox_physics(n As Integer, dx, dy, dz)

    If jumpbox_material_done <> 0 Then Exit Sub
    jumpbox_material_done = 5

    'Set up physics
    raw_emit ("physics")
    raw_emit ("  name jumpbox" & CStr(n))
    raw_emit ("  linear " & nArg(dx) & " " & nArg(dy) & " " & nArg(dz))
    raw_emit ("end")
End Sub

Sub jumpbox_material()

    raw_emit ("material")
    raw_emit (" name jumpbox_material")
    raw_emit (" color " & nArg(173# / 255#) & " 1 " & nArg(47# / 255#) & " 0.8")
    raw_emit ("end")
End Sub
