Attribute VB_Name = "Script_MinasTirith"

Const RoadSpikeHeight = 40

Sub Write_Minas_Tirith()

        Dim fname As String
        fname = "MinasTirith"
        
        If Not Open_Output_File(fname) Then
            Exit Sub
        End If
        
       
        Init_Component_System
        Install_Components_Library
        Call MT_Components
        
        comment "Minas Tirith / Minas Ithil"
        comment "   - Bryan Bentz"
        comment " "
        comment "Parser, code support system by"
        comment " "
        comment " Bryan A. Bentz"
        comment "       a.k.a. ""The Purple Panzer"""
        comment "       Email:"
        comment "            bentz@bentz-engineering.com, or "
        comment "            bentz@; ai.mit.edu; "
        comment "       URLs:"
        comment "            Personal URL: http://www-swiss.ai.mit.edu/~bentz/"
        comment "            Business URL: http://www.bentz-engineering.com/"
        comment " "
        comment " "
        
        world (400)
        
        'Evil Eye
        Pyramid 350, 350, 60 + 30, 45, 12, 12, 30, False, True, True
        Pyramid 350, 350, 90 + 30, 45, 12, 12, 30, False, True, False
        Box 350, 350, 90 + 30, 45, 15, 15, 2
        Teleporter 350, 350, 92 + 30, 45, 0.45, 6, 8, 0.45, "Evil Eye"

        nMinasTirith
        nRoadToAnduin
        nAnduin
        nOsgiliath
        nRoadToIthilien
        nMinasIthil
        nOrthanc
        
        Place_Component "Ship", 200 + 40, -300 - 40, 0, 45
        Place_Component "Ship", 156 + 40, -304 - 40, 0, 66
       
        Const sBx = 110
        Const sBy = -340
        Const sbTheta = 45
        Box sBx, sBy, 0, sbTheta, 20, 20, 12
        Box sBx, sBy, 9, sbTheta, 25, 25, 3
        
        Box sBx, sBy, 12, sbTheta, 12, 12, 15
        Box sBx, sBy, 27, sbTheta, 8, 8, 10
        Box sBx, sBy, 37, sbTheta, 4, 4, 8
        
       
        teleporter_platform -320, 50, 85, 0, "West Platform"
        teleporter_platform 320, -240, 85, 0, "East Platform"
        teleporter_platform 0, 0, 85 + 85, 0, "Central"
        Teleporter 250, 250, 0, 45, 0.45, 12, 12, 1, "Corner"
        Teleporter -250, 0, 0, 0, 0.45, 12, 12, 1, "Pelennor"
        
        
        Teleporter 250, 365, 32, 0, 0.45, 6, 6, 0.5, "Minas Ithil"
        
        
        fully_connect_teleporters "Horn", "Central"
        fully_connect_teleporters "West Platform", "Corner"
        fully_connect_teleporters "East Platform", "Pelennor"
        fully_connect_teleporters "Orthanc", "Minas Ithil"
        
        
        do_pyramid_region -330, -80, 180
        do_pyramid_region 0 - 50, 250 - 50, 180
        do_pyramid_region 200, -100, 200
        do_pyramid_region -50 - 50, -300 - 50, 180
       
        'Box for Burrow support
        Box 280 + 50, -280 + 40, 2, 0, 20, 20, 5
        Teleporter 280 + 50, -280 + 40, 7, 0, 0.45, 6, 6, 0.5, "Burrow"
        Pyramid 280 + 50, -280 + 40, 7, 0, 20, 20, 30, False, True, False
        fully_connect_teleporters "Peak", "Burrow"
        
        Close_Output_File
End Sub


Sub do_pyramid_region(x, y, radius)
    Dim area As Double
    Dim mnum As Double
    Const density As Double = 1# / 2800#
    
    area = 3.1415 * radius * radius
    mnum = area * density
    
    Scattered_Pyramids x, y, mnum, radius, radius
End Sub


Sub MT_Components()


        
        define_component "Evil Tower"
            'box x, y, z, rot, sX, sY, sZ
'            Box -1, -2, 0, 0, 60, 60, 15
'            Box -1, -2, 0, 0, 50, 50, 30
            Box 0, 0, 0, 0, 12, 12, 25
            Box 0, 0, 15, 0, 17, 17, 2
            Const py_offset = 20 '64
            Const pWidth = 4
            Pyramid -py_offset, py_offset, 0, 0, pWidth, pWidth, 30
            Pyramid py_offset, -py_offset, 0, 0, pWidth, pWidth, 30
            Pyramid -py_offset, -py_offset, 0, 0, pWidth, pWidth, 30
            Pyramid py_offset, py_offset, 0, 0, pWidth, pWidth, 30
        end_component

        define_component "Ship"
            'Hull
            Box 0, 0, 0, 0, 3, 8, 2
            'Quarterdeck
            Box 0, -7, 0, 0, 3, 2, 4
            'Foredeck
            Box 0, 7, 0, 0, 3, 1, 4
            'Mast
            Box 0, 2, 2, 0, 0.5, 0.5, 12
            'Yard
            Box 0, 2, 11, 45, 8, 0.5, 0.5
            
            'Foredeck
            Box -1.3, 8, 0, 45, 2, 1, 4
            Box 1.3, 8, 0, -45, 2, 1, 4

         end_component
End Sub


Sub nMinasTirith()

    'The seven levels of minas tirith
    Const MT_Storey = 14 '15
    Const mt_offset = 2
    Const MT_X = -380
    Const MT_Y = -380
        
    Minas_Tirith_Level 1, MT_X, MT_Y, 0, MT_Storey + mt_offset
    Minas_Tirith_Level 2, MT_X, MT_Y, MT_Storey * 1 + mt_offset, MT_Storey
    Minas_Tirith_Level 3, MT_X, MT_Y, MT_Storey * 2 + mt_offset, MT_Storey
    Minas_Tirith_Level 4, MT_X, MT_Y, MT_Storey * 3 + mt_offset, MT_Storey
    Minas_Tirith_Level 5, MT_X, MT_Y, MT_Storey * 4 + mt_offset, MT_Storey
    Minas_Tirith_Level 6, MT_X, MT_Y, MT_Storey * 5 + mt_offset, MT_Storey
    Minas_Tirith_Level 7, MT_X, MT_Y, MT_Storey * 6 + mt_offset, MT_Storey
    Minas_Tirith_Level 8, MT_X, MT_Y, MT_Storey * 7 + mt_offset, MT_Storey
    
    Dim pHeight
    Const pStagger = 100
    pHeight = MT_Storey * 7 + mt_offset + pStagger
    'Pyramid -380, -325, pHeight - pStagger, -10, 12, 80, pHeight, False, True, True, "Horn"
    'Pyramid x, y, z, rot, sX, sY, sZ, ShootThrough, DriveThrough, Flipz
    Box -380 + 10, -325 + 40, 0, -15, 12, 50, 107, "Horn"
    Teleporter -390 + 25, -285 + 25, 107, -15 + 90, 0.45, 8, 8, 0.45, "Horn"
    
    tree -340, -372, 107
    'tree 50, 50, 0 '(testing)
    
    Box -395, -250, 0, 0, 10, 50, 50
    Box -200, -395, 0, 0, 50, 10, 50
    
    'Box allowing jump to top
    Box -330, -378, 107 - 15 - 5, 0, 20, 15, 5
    'Box -330 + 20, -378 + 20, 107 - 15 - 5 - 10, 0, 20, 15, 2
    
    Dim yWidth, xWidth
    yWidth = 20
    xWidth = 80
    Box -400 + xWidth, -399 - yWidth, 0, 0, xWidth, yWidth, MT_Storey * 7
    yWidth = 20
    xWidth = 80
    Box -290 + xWidth, -399 - yWidth, 0, 0, xWidth, yWidth, MT_Storey * 4
    
    'Inner pyramids
    Dim theta
    Dim rx, ry
    For theta = 10 To 90 Step 10
        rx = 120 * cosD(theta) - 400
        ry = 120 * sinD(theta) - 400
        Pyramid rx, ry, 0, 180 * Rnd(), 5, 5, 9, False, True, False
    Next theta
    
    
End Sub

Sub re_randomize(i)
    Rnd (-500)
    Select Case i
        Case 1
            Randomize (2000)
        Case 2
            Randomize (1143)
        Case 3
            Randomize (60)
        Case 4
            Randomize (4500)
        Case 5
            Randomize (20)
        Case 6
            Randomize (102)
        Case 7
            Randomize (300)
        Case 8
            Randomize (400)
    End Select
End Sub

Sub tree(x, y, z)
    Const mHeight = 30
    Dim i As Integer
    Dim lowbranch, bdelta, sizeB, sizeZ, cutoff
    
    
    'First, a stalk up the center
    Box x, y, z, 0, 1, 1, mHeight, "Tree stalk"
    
    'Lowbranch is where first branch starts
    lowbranch = 0.1 * mHeight
    cutoff = 0.3 * mHeight
    
    For i = 1 To 4
        sizeB = 2 + i * 1.2
        sizeZ = 6 - i * 0.7
        bdelta = 2
        If lowbranch + bdelta * i > cutoff Then GoTo nextbranch
        Pyramid x, y, z + lowbranch + bdelta * i, 180 * Rnd(), _
            sizeB, sizeB, sizeZ, False, False, True
    Next i
nextbranch:
    For i = 1 To 20
        bdelta = 1
        sizeB = 2 + i * 0.4
        sizeZ = 6 - i * 0.4
        If mHeight - bdelta * i < cutoff Then GoTo getout
        Pyramid x, y, z + mHeight - bdelta * i, 180 * Rnd(), _
            sizeB, sizeB, sizeZ, False, False, False
    Next i
getout:
    
    
End Sub

Sub Minas_Tirith_Level(lnum As Integer, cX, cY, cZ, lheight)
'    Box cX, cY, cZ, 0, mt_Size(lnum), mt_Size(lnum), lheight
'    Box cX, cY, cZ, 45, mt_Size(lnum), mt_Size(lnum), lheight
    Dim wWidth
    Dim AngleGate
    Dim GateRatio
    wWidth = 4 '14
    Const StartAngle = -3
    Const EndAngle = 95
    Dim tx, ty, tsize
    Dim DoCrenels As Boolean
    Dim roffset As Integer
    
    If lnum < 3 Then
        DoCrenels = True
        roffset = 2
    Else
        DoCrenels = False
        roffset = 0
    End If
    
'    Randomize (lnum) 'So that this is replicable
'    Rnd (-1)
    AngleGate = lGate(lnum)
    GateRatio = AngleGate / 90
    
'    circular_wall x, y, startz, radius, _
'        Theta_Start, Theta_End, _
'        height, width, numsegments, numtowers, _
'        crenelation, crenopen, crenclosed, crenside, crenelout
'
    Dim thisSize
    Dim thisX, thisY
    If lnum = 7 Then
        thisSize = 35
        Box -400 + thisSize, -400 + thisSize, 107 - lheight, 0, thisSize, thisSize, lheight
        Exit Sub
    End If

    If lnum = 8 Then
        thisSize = mt_Size(lnum)
        Box cX + thisSize, cY + thisSize, 107, 45, thisSize, thisSize, lheight
        Teleporter cX + thisSize, cY + thisSize, 107 + lheight, 45, 0.45, 6, 6, 0.5, "Peak"
        Exit Sub
    End If

    'Top of wall
    Const TopOffset = 0 '10 '12
'    circular_wall cX, cY, cZ + TopOffset, mt_Size(lnum) + roffset, _
'        0, 95, _
'        lheight - TopOffset, wWidth, lSeg(lnum), 0, False, 6, 3, 1
       
  
    'Underneath part, with gates
    If lnum > 1 Then
        circular_wall cX, cY, cZ - lheight, mt_Size(lnum), _
            StartAngle, AngleGate - sGate(lnum), _
            12 + lheight, wWidth, lSeg(lnum) * GateRatio, 0, False, 10, 5, 1
        If lnum < 8 Then
            circular_wall cX, cY, cZ - lheight, mt_Size(lnum), _
                AngleGate + sGate(lnum), EndAngle, _
                12 + lheight, wWidth, lSeg(lnum) * (1 - GateRatio), 0, False, 10, 5, 1
        End If
    Else
        'Must special case - no drop wall to previous level
        circular_wall cX, cY, cZ, mt_Size(lnum), _
            StartAngle, AngleGate - sGate(lnum), _
            12, wWidth, lSeg(lnum) * GateRatio, 0, False, 10, 5, 1
        If lnum < 8 Then
            circular_wall cX, cY, cZ, mt_Size(lnum), _
                AngleGate + sGate(lnum), EndAngle, _
                12, wWidth, lSeg(lnum) * (1 - GateRatio), 0, False, 10, 5, 1
        End If
    End If
  
    Dim flatwidth
    If lnum > 1 And lnum < 7 Then
        flatwidth = mt_Size(lnum) * 0.5 - (8 - lnum) * 10
        'Base, creating flat surface
        circular_wall cX, cY, cZ - 2, mt_Size(lnum) - flatwidth, _
            StartAngle, EndAngle, 2, flatwidth, lSeg(lnum), 0, False, 5, 5, 1
    End If
    
    'Gate towers
    Dim t1x, t1y, t2x, t2y
    t1x = (mt_Size(lnum) + 2 + wWidth) * cosD(AngleGate - sGate(lnum) / 2.2 - 5) + cX
    t1y = (mt_Size(lnum) + 2 + wWidth) * sinD(AngleGate - sGate(lnum) / 2.2 - 5) + cY
    t2x = (mt_Size(lnum) + 2 + wWidth) * cosD(AngleGate + sGate(lnum) / 2.3 - 5) + cX
    t2y = (mt_Size(lnum) + 2 + wWidth) * sinD(AngleGate + sGate(lnum) / 2.3 - 5) + cY
    
    If lnum = 1 Then
            t1x = (mt_Size(lnum) + 2 + wWidth) * cosD(AngleGate - sGate(lnum) / 2# - 7) + cX
            t1y = (mt_Size(lnum) + 2 + wWidth) * sinD(AngleGate - sGate(lnum) / 2# - 7) + cY
            t2x = (mt_Size(lnum) + 2 + wWidth) * cosD(AngleGate + sGate(lnum) / 2# - 7) + cX
            t2y = (mt_Size(lnum) + 2 + wWidth) * sinD(AngleGate + sGate(lnum) / 2# - 7) + cY
            tower t1x, t1y, cZ, (AngleGate - sGate(lnum) / 2 - 7), 5, lheight + 5, True
            tower t2x, t2y, cZ, AngleGate + sGate(lnum) / 2, 5, lheight + 5, True
                
'            Teleporter (t1x + t2x) * 0.5 - 40, (t1y + t2y) * 0.5 - 40, 0, 45, 0.45, 10, 12, 0.45, "MT First Level"
'            Teleporter cX + mt_Size(lnum) * cosD(80) + 3, cY + mt_Size(lnum) * sinD(80) + 3, lheight, 80 + 90, 0.45, 9, 9, 0.45, "MT First Wall"
            
    Else
        If lnum < 7 Then
            tower t1x, t1y, cZ - lheight - 2, AngleGate - sGate(lnum) / 2, 5, 2 * lheight + 5, True 'DoCrenels
            tower t2x, t2y, cZ - lheight - 2, AngleGate + sGate(lnum) / 2, 5, 2 * lheight + 5, True 'DoCrenels
            
            'Road to center
            If lnum > 2 Then
                straight_wall (t1x + t2x) / 2, (t1y + t2y) / 2, cX, cY, cZ - 2 - lheight, 5, 2, 0, False, 0, 0, 0
            End If
            
'            'Central box
'            tsize = mt_Size(lnum) * 0.7
'            Box cX + tsize / 2 - 10, cY + tsize / 2 - 10, cZ - 2, Rnd(), tsize / 2, tsize / 2, 2
            tsize = 20
            Box -400 + tsize, -400 + tsize, cZ - 2, 0, tsize, tsize, 2
    

            Pyramid -400 + tsize, -400 + tsize, cZ, Rnd() * 360, tsize * 0.2, tsize * 0.2, 10, False, False

        End If
    End If
    
    
    'Buildings at this level
    If lnum > 6 Then GoTo getout
    Dim MinRadius, MaxRadius, floor, Height, width, ArcLength, density
    Dim NumBlocks, NumPyramids
    MinRadius = mt_Size(lnum + 1) + roffset
    MaxRadius = mt_Size(lnum) + roffset
    ArcLength = (2 * 3.1415 * (MaxRadius + MinRadius) / 2#) * (EndAngle - StartAngle) / 360#
    density = 1 / 30
    NumBlocks = density * ArcLength
    NumPyramids = NumBlocks / 4
    
    width = (MaxRadius - MinRadius)
    floor = cZ
    Height = lheight
    
    Dim tAngle, iB, Xb, Yb, rB, sxB, syB, szB
    
    Call re_randomize(lnum)
    For iB = 1 To NumBlocks
        tAngle = Rnd() * (EndAngle - StartAngle) + StartAngle
        rB = Rnd() * (width - 4) + MinRadius
        Xb = rB * cosD(tAngle)
        Yb = rB * sinD(tAngle)
        
        sxB = Rnd() * (width / 3# - 4) + 4
        syB = Rnd() * (width / 3# - 3) + 3
        szB = Rnd() * (lheight - 0) + 2
        Box Xb + cX, Yb + cY, floor, tAngle, sxB, syB, szB
    Next iB
    
    For iB = 1 To NumPyramids
        tAngle = Rnd() * (EndAngle - StartAngle) + StartAngle
        rB = Rnd() * (width - 2) + MinRadius
        Xb = rB * cosD(tAngle)
        Yb = rB * sinD(tAngle)
        
        sxB = Rnd() * (width / 3# - 4) + 4
        syB = Rnd() * (width / 3# - 3) + 3
        szB = Rnd() * (lheight - 0) + 5
        Pyramid Xb + cX, Yb + cY, floor, 180 * Rnd(), sxB, syB, szB
    Next iB
    
        
    
getout:
End Sub

Function lGate(levelnum) As Integer
    'Where the gate occurs, by level
    Select Case levelnum
        Case 1
            lGate = 45
        Case 2
            lGate = 20
        Case 3
            lGate = 65
        Case 4
            lGate = 32
        Case 5
            lGate = 50
        Case 6
            lGate = 22
        Case 7
            lGate = 60
        Case 8
            lGate = 90
    End Select
End Function

Function sGate(levelnum) As Integer
    'size of the gate, in degrees
    Select Case levelnum
        Case 1
            sGate = 6
        Case 2
            sGate = 10
        Case 3
            sGate = 10
        Case 4
            sGate = 12
        Case 5
            sGate = 14
        Case 6
            sGate = 16
        Case 7
            sGate = 16
        Case 8
            sGate = 1
    End Select
End Function
Function lSeg(levelnum As Integer) As Integer
    lSeg = 10 - levelnum
'    Select Case levelnum
'        Case 1
'            lSeg = 4 'was 9
'        Case 2
'            lSeg = 4 'was 8
'        Case 3
'            lSeg = 3 'was 7
'        Case 4
'            lSeg = 4 'was 6
'        Case 5
'            lSeg = 3 'was 5
'        Case 6
'            lSeg = 3 'was 4
'        Case 7
'            lSeg = 1 'was 3
'        Case 8
'            lSeg = 1 ' was 3
'    End Select
End Function

Function lTowers(levelnum As Integer) As Integer
    lTowers = 8 - levelnum
End Function

Function mt_Size(levelnum As Integer)
    Const baseSize = 280 ' 180
    Const SmallestSize = 10
    Const Bordersize = (baseSize - SmallestSize) / 8
    mt_Size = baseSize - Bordersize * levelnum
End Function


''' The Anduin'''

Sub nAnduin()
    Dim i As Integer
    Dim bX As Integer
    Dim bY As Integer
    Dim bMaxSize As Integer
    Dim bLength As Integer
    Dim bWidth As Integer
    Dim bAngle As Integer
    
    Dim lastXMark
    Dim lastYMark
    Const TotalDist = (800 * 1.414) * 1#  'extra
    
    Dim nPyrs As Integer
    
    nPyrs = 10
    
    lastXMark = -400
    lastYMark = 400
    
    Rnd (-1)
    Randomize (5) ' for repeatability
    
    For i = 1 To nPyrs
        bLength = TotalDist / nPyrs
        bWidth = 20 + Rnd() * 50
        bAngle = -50 + (Rnd() * 30) - 15
        bX = lastXMark + (bLength / 2#) * cosD(bAngle)
        bY = lastYMark + (bLength / 2#) * sinD(bAngle)
        Pyramid bX, bY, 0, bAngle, bLength, bWidth, 1, False, False, False
        lastXMark = bX + (bLength / 2#) * cosD(bAngle)
        lastYMark = bY + (bLength / 2#) * sinD(bAngle)
        If lastXMark > 400 Or lastYMark < -400 Then GoTo getout
    Next i
    
getout:
    
    '    bridge
    'Box 10.5, 3.5, 3, 45, 50, 5, 2, "Bridge"
    
    Place_Component "Anduin Bridge", 13 - 45, 8 - 45, 0, 45
    
    'Tower1
    'Box 141, -228, 0, 55, 10, 10, 15, "SouthTower"
    Box 169, -183, 0, 55, 25, 25, 15
    tower 169, -183, 15, 55, 15, 15, True
    Teleporter 169, -183, 15 + 15, 55, 0.45, 8, 8, 0.45, "SouthTower"
    
    'Tower2
    'Box -75, 147, 0, 55, 10, 10, 15, "NorthTower"
    Box -100, 137, 0, 55, 25, 25, 16
    tower -100, 137, 16, 55, 15, 15, True
    Teleporter -100, 137, 18 + 15, 55, 0.45, 8, 8, 0.45, "NorthTower"
    fully_connect_teleporters "SouthTower", "NorthTower"

End Sub


Sub nMinasIthil()

    'Main box in corner
    Box 350, 350, 0, 0, 40, 40, 60
    

    
    'Side boxes
    Const GRadius = 340
    Const GAngle = 10
    Dim gtopX, gtopY, gbottomX, gbottomY, gCenterX, gCenterY
    gCenterX = GRadius * cosD(45)
    gCenterY = GRadius * sinD(45)
    'top gate tower
    gtopX = GRadius * cosD(45 + GAngle)
    gtopY = GRadius * sinD(45 + GAngle)
    Box gtopX, gtopY, 0, 45, 10, 10, 45
    Pyramid gtopX, gtopY, 45, 45, 8, 8, 20, False, True, False
    'Bottom gate tower
    gbottomX = GRadius * (cosD(45 - GAngle))
    gbottomY = GRadius * sinD(45 - GAngle)
    Box gbottomX, gbottomY, 0, 45, 10, 10, 45
    Pyramid gbottomX, gbottomY, 45, 45, 8, 8, 20, False, True, False
    
    'Gates!
    Dim Door1X, Door2X, Door1Y, Door2Y, DoorLength, halfDlength
    DoorLength = Sqr((gtopX - gbottomX) * (gtopX - gbottomX) + (gtopY - gbottomY) * (gtopY - gbottomY)) / 2#
    halfDlength = DoorLength / 2#
    Const DoorAngle = -35 'Angle door is open
    Door1X = gtopX + halfDlength * cosD(45 - DoorAngle)
    Door1Y = gtopY - halfDlength * sinD(45 - DoorAngle)
    Door2X = gbottomX - halfDlength * sinD(45 - DoorAngle)
    Door2Y = gbottomY + halfDlength * cosD(45 - DoorAngle)
    Box Door1X, Door1Y, 0, -45 + DoorAngle, halfDlength, 5, 30
    Box Door2X, Door2Y, 0, 135 - DoorAngle, halfDlength, 5, 30
   
    'Gate wall ends
    Box 160, 360, 0, 45, 17, 22, 47
    Box 360, 160, 0, 45, 25, 18, 52
    
    'connectors
    straight_wall gtopX, gtopY, 160, 360, 0, 12, 35, 0, False, 1, 1, 1
    straight_wall gbottomX, gbottomY, 360, 160, 0, 12, 35, 0, False, 1, 1, 1
    
    'Back walls
    Box 370, 260, 0, 0, 20, 40, 30
    Box 250, 365, 0, 0, 52, 28, 32
    
    'Central box
    Box 275, 275, 0, 45, 20, 20, 15
    
    'Heading to back
    Box 320, 260, 0, 32, 20, 8, 20
    
    'moving toward top
    Box 236, 320, 0, 70, 10, 10, 30
    Box 246, 305, 0, 32, 8, 14, 15
    
    'On top of right flank
    Box 370, 260, 30, 3, 8, 30, 15
    
    Box 386, 145, 0, 0, 15, 10, 15
    Box 150, 380, 10, 0, 17, 22, 5
    
End Sub

Sub nRoadToAnduin()
    Dim x1, y1, x2, y2, x3, y3, x4, y4, x5, y5, x6, y6
    Dim deltaX, deltaY
    
    deltaX = 31
    deltaY = -26
    
    x1 = -167
    y1 = -178 + 10
    x2 = x1 + deltaX
    y2 = y1 + deltaY
    
    x3 = x1 + 20
    y3 = y1 + 30
    x4 = x3 + deltaX
    y4 = y3 + deltaY
    
    x5 = x3 + 20
    y5 = y3 + 30
    x6 = x5 + deltaX
    y6 = y5 + deltaY
        Pyramid x1, y1, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x2, y2, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x3, y3, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x4, y4, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x5, y5, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x6, y6, 0, 45, 6, 6, RoadSpikeHeight

    
End Sub

Sub nRoadToIthilien()
    Dim x1, y1, x2, y2, x3, y3, x4, y4, x5, y5, x6, y6, x7, y7, x8, y8
    Dim deltaX, deltaY
    
    deltaX = 30
    deltaY = 30
    
    x1 = 55 + 15
    y1 = 57 + 20 + 15
    
    x2 = x1 + 30
    y2 = y1 - 30
    
    x3 = x1 + deltaX
    y3 = y1 + deltaY
    
    x4 = x3 + 30
    y4 = y3 - 30
    
    x5 = x3 + deltaX
    y5 = y3 + deltaY
    
    x6 = x5 + 30
    y6 = y5 - 30
    
    x7 = x5 + deltaX
    y7 = y5 + deltaY
    
    x8 = x7 + 30
    y8 = y7 - 30
    
    Pyramid x1, y1, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x2, y2, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x3, y3, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x4, y4, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x5, y5, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x6, y6, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x7, y7, 0, 45, 6, 6, RoadSpikeHeight
    Pyramid x8, y8, 0, 45, 6, 6, RoadSpikeHeight
   
End Sub

'''''''''''''''''
''' Osgiliath '''
'''''''''''''''''


Sub nOsgiliath()

    'Ithilien side
    Box 42, -43, 0, 42.5, 15, 20, 15, "Osgiliath 1"
    Box 42, -43, 12, 42.5, 15 + 9, 20 + 5, 3, "Shelf"
    'Box 43, -43, 15, 42.5, 10, 15, 15, "OS 1 tower"
    Place_Component "Evil Tower", 42, -43, 15, 42.5
    Teleporter 42, -43, 40, 42.5, 0.45, 6, 8, 0.45, "Osgiliath Tower"
    fully_connect_teleporters "Evil Eye", "Osgiliath Tower"
    
    Box 82, -72, 0, 42.5, 15, 20, 15, "Osgiliath 2"
    Box 60, 4, 0, 42.5, 18, 24, 15, "Osgiliath 3"
    Box 60, 4, 15, 42.5, 10, 15, 15
    
    
    Box -22, 38, 0, 42.5, 15, 20, 15, "Osgiliath 4"
    
    'High ramp
    Box 125, -117, 13, 40, 4, 57, 2, "Ramp"
    
    'Anorien side
    Box -31, -111, 0, 42.5, 15, 20, 15, "Osgiliath 5"
    Pyramid -31, -111, 15, 42, 8, 8, 16, True, True, False
    
    Box -101, -28.5, 0, 42.5, 17, 22, 14, "Osgiliath 6"
    Box -101, -28.5, 14, 42.5, 12, 17, 15
    Box -101, -28.5, 29, 42.5, 7, 13, 10
    Pyramid -101, -28.5, 40, 42.5, 4, 7, 20
    
    
End Sub


Sub nOrthanc()
    Dim i As Integer
    Const cX = -200
    Const cY = 350
    Const radius = 42
    Dim angle, rx, ry
    Const bsize = 6
    
    For i = 1 To 10
        angle = i * 36
        rx = radius * sinD(angle) + cX
        ry = radius * cosD(angle) + cY
        Box rx, ry, 0, angle, 3, 3, 15
    Next i
    
    Box cX - bsize, cY + bsize, 0, 0, bsize, bsize, 16
    Box cX + bsize, cY + bsize, 0, 0, bsize, bsize, 2 * 16
    Box cX + bsize, cY - bsize, 0, 0, bsize, bsize, 3 * 16
    
    'Teleporter -195 + 5, 355, 34, 0, 0.45, 6, 6, 0.5, "Orthanc"
    Teleporter cX + bsize + 5, cY - bsize, 3 * 16, 0, 0.45, bsize, 8, 0.1, "Orthanc"
    

    
    Box cX - bsize, cY - bsize, 0, 0, bsize, bsize, 4 * 16
    

    Dim zigx, zigy, zigH
    zigx = cX - 6
    zigy = cY - 6
    zigH = 4 * 16
    
    Const zigr = 5
    jtWidth = 2
    jtHeight = 10
    
    jfort_tower zigx + zigr, zigy + zigr, zigH
    jfort_tower zigx - zigr, zigy + zigr, zigH
    jfort_tower zigx + zigr, zigy - zigr, zigH
    jfort_tower zigx - zigr, zigy - zigr, zigH


End Sub
