Attribute VB_Name = "Ramp"
Public Define_Ramp_Material_Flag As Integer
Public RampNum As Integer

Sub ramp_physics(n As Integer, dx, dy, dz)
    'Set up physics
    raw_emit ("physics")
    raw_emit ("  name ramp" & CStr(n))
    raw_emit ("  linear " & nArg(dx) & " " & nArg(dy) & " " & nArg(dz))
    raw_emit ("end")
End Sub

Public Sub Mramp(b1x, b1y, b2x, b2y, b3x, b3y, b4x, b4y, rHeight)
    ''Build a ramp from the rectangle given above up to the height rHeight
    
    Const zero = -1
    ramp_physics RampNum, b3x - b2x, b3y - b2y, rHeight * 1.2
    Define_Ramp_Material
    raw_emit ("mesh")
    raw_emit "  matref RampMaterial"
    raw_emit ("  phydrv ramp" & CStr(RampNum))
    vertex b1x, b1y, zero          '0
    vertex b2x, b2y, zero          '1
    vertex b3x, b3y, zero          '2
    vertex b4x, b4y, zero          '3
    vertex b3x, b3y, rHeight    '4
    vertex b4x, b4y, rHeight    '5
    
    'clockwise from outside.
    face3 0, 5, 3 '1, 6, 4
    
    face4 0, 1, 4, 5 '1, 2, 5, 6
    raw_emit " face"
    raw_emit "   vertices 0 1 4 5"
    'raw_emit ("  phydrv ramp" & CStr(RampNum))
    raw_emit " endface"
    
    face3 1, 2, 4 '2, 3, 5
    face4 5, 4, 2, 3 ' 6, 5, 3, 4
    
    'counterclockwise from outside
    face3 3, 5, 0
    face4 0, 5, 4, 1
    face3 2, 1, 4
    face4 2, 4, 5, 3
    
    raw_emit ("end")
    RampNum = RampNum + 1

End Sub

Sub Define_Ramp_Material()
    If Define_Ramp_Material_Flag = 3 Then Exit Sub
    Define_Ramp_Material_Flag = 3
    raw_emit ("material")
    raw_emit ("  name RampMaterial")
    'raw_emit ("  texture " & TempleTexture)
    'raw_emit ("  notexalpha")
    raw_emit (" color burlywood")
    'raw_emit ("color 139 115 85 1")
    raw_emit ("end")
End Sub
