Attribute VB_Name = "Script_Firstmap"
'''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''
''' Main Scripting Module '''
'''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''

''' Adjust the subroutine Write_MapFile to create what you'd like,
''' using the tools in the Machinery module.

Public jtWidth, jtHeight, jtPyHeight

Public Const Lite As Boolean = False 'reduce map size!

Sub Write_MapFile()
    Dim i As Integer
    
    '' Try to open the output file; exit if error.
    If Not Open_Output_File("firstmap") Then
        Exit Sub
    End If
    
    'header
    Write_Header
    
    ''''''''''''''''''''''''''
    ''' Main fortress base '''
    ''''''''''''''''''''''''''
    
    Dim fplaza, fborder, fborderHeight
    fplaza = 30
    fborder = 11
    fborderHeight = 16
    
    comment "Sanctorum of castle fort"
    'box x, y, z, rot, sizeX, sizeY, sizeZ
    Box 400 - fplaza, 400 - fplaza, fborderHeight, 0, _
        fplaza, fplaza, 15
        
    ' Base around it
    Box 400 - (fplaza + fborder), 400 - (fplaza + fborder), 0, 0, _
    fplaza + fborder, fplaza + fborder, 16
    
    comment "### Teleporter: Castle fortress sanctorum"
    Teleporter 390, 390, fborderHeight + 15, 45, 0.45, 5, 10, default_bsize
    Box 400 - fplaza - rw, 400 - fplaza, fborderHeight + 15, 0, _
        fplaza / 2, 5, 5
    
'    Sub circular_wall(originX, originY, startZ _
'             radius, thetaStart, thetaEnd, _
'             height, _
'             width, _
'      numsegments, numtowers_
'      crenelation As Boolean, _
'      crenOpenwidth, crenClosedwidth, _
'      crenside, _
'      Optional crenelOut = 0)

    Const WallHeight = 17
    Dim MainTowerHeight
    Dim numsegments
    Dim crenels As Boolean
    If Lite Then
        crenels = False
        numsegments = 9
    Else
        crenels = True
        numsegments = 9
    End If
    circular_wall 270 + 6, 330 + 15, 0, _
        170, 173, 280, _
        WallHeight, 3, _
        numsegments, 3, _
        crenels, _
        10, 5, _
        1, _
        0.2
    MainTowerHeight = AddedTowerHeight
    
'    straight_wall(x1, y1, x2, y2, startz, _
'        width, height, numtowers, crenelation As Boolean, _
'        crenopenwidth, crenclosedwidth, crenside, Optional crenelout = 0)
    
    straight_wall 300, 140, 320, 0, 0, _
        3, WallHeight, 2, crenels, 10, 5, 1
        
    comment "Wall to +X edge"
    straight_wall 320, 0, 400, -10, 0, 4, WallHeight + 1, 0, crenels, 10, 5, 1
    
    comment "Main castle fort arch"
'    'arch(xc, yc, zc, theta, gateHeight, gateWidth, Thickness, Border)
    arch 300, 160, 0, 90, WallHeight - 2, 14, 5, 5, Lite
    
    comment "Tower on each end of the arch"
    'tower x, y, z, theta, width, height
    tower 300, 160 + 18, 0, 90, 10, 35, True
    tower 300, 160 - 18, 0, 90, 10, 35, True
    
    comment "Building behind gate"
    'Box x, y, z, rot, sX, sY, sZ
    Const mb_x = 300 + 70
    Const mb_y = 160
    Box mb_x, mb_y, 0, 0, 25, 25, 15
    Box mb_x, mb_y, 15, 0, 20, 20, 15
    Box mb_x, mb_y, 30, 0, 15, 15, 15
    Pyramid mb_x, mb_y, 45 + 0.1, 0, 13, 13, 13, True, True, False
    
    comment "Inner pyramids, to prevent lots of bounces"
    RoadPyramid 350 - 85, 250 - 20

    
    comment "Teleporter on the ground in the Castle Fort"
    Teleporter 362, 73, 0, 135, 0.45, 8, 10, default_bsize
    
    comment "Building at end of fort"
    Const mj_x = 362
    Const mj_y = 19
    'Box x, y, z, rot, sx, sy, sz
    Box mj_x, mj_y, 0, 45, 8, 8, 33
    Pyramid mj_x, mj_y, 33.01, 45, 8, 8, 8, True, True, False
    
    
    comment "Teleporters up in the air:"
    'teleporter_platform x, y, z, theta
    comment "Teleporter in the north"
    teleporter_platform 30, 297, 100, 0
    comment "Teleporter in the South"
    teleporter_platform 252, -65, 100, 90

    comment "Central circular tower"
    Const CWallheight = 30

    Dim CTowerHeight
    'circular_wall x, y, z,
    ' radius, theta1, theta2,
    ' height, width,
    ' nseg, ntowers, cren?, crenopen, crenclosed, crenside
    Dim ctowersegs
    If Lite Then
        ctowersegs = 10
    Else
        ctowersegs = 16
    End If
'    circular_wall x, y, startz, _
'      radius, thetaStart, thetaEnd, _
'      height, width, _
'      numsegments, numtowers, crenelation, crenopenwidth, crenclosedwidth, crenside, crenelout
    
    circular_wall 200, 340, 0, _
      35, 30, 330, _
      CWallheight, 5, _
      ctowersegs, 0, crenels, 2, 1, 1, 0.2
    CTowerHeight = AddedTowerHeight
    'box x, y, z, rot, sizeX, sizeY, sizeZ
    Box 200, 340, 0, 0, 16, 15, 10
    Box 200, 340, 10, 0, 8, 32, 10
    comment "Tower within this circular tower"
    Const ttowerX = 200 - 25 'Avg of block, center
    Const ttowerY = 340
    'tower x, y, z, theta, width, height
    Dim centercren As Boolean
    If Lite Then
        centercren = False
    Else
        centercren = True
    End If
    tower ttowerX, ttowerY, 10, 0, 9, 24, centercren

'' BUG Below?
    '''''''''''''''''''
    ''' Siege Tower '''
    '''''''''''''''''''

    comment "###################"
    comment "### Siege Tower ###"
    comment "###################"
    Dim sth2
    Const stX = 70
    Const stY = 320
    Const stTheta = 20
    Dim STheight1, STheight2, STheight3, STheight4, STheight5
    STheight1 = fborderHeight + 15 '3
    STheight3 = CTowerHeight '1
    STheight4 = MainTowerHeight '4
    STheight5 = WallHeight '5
    STheight2 = CWallheight '2
'
    comment "4 boxes, backing up each time"
    Const STBack = 5
    Const STWidthAdd = 1
    Const STFirstWidth = 2
    Box stX, stY, 0, 0, STFirstWidth, STFirstWidth, STheight1
    Box stX - 1 * STBack, stY, 0, 0, STFirstWidth + 1 * STWidthAdd, STFirstWidth + 1 * STWidthAdd, STheight2
    Box stX - 2 * STBack, stY, 0, 0, STFirstWidth + 2 * STWidthAdd, STFirstWidth + 2 * STWidthAdd, STheight3
    Box stX - 3 * STBack, stY, 0, 0, STFirstWidth + 3 * STWidthAdd, STFirstWidth + 3 * STWidthAdd, STheight4
    Box stX - 4 * STBack, stY, 0, 0, STFirstWidth + 4 * STWidthAdd, STFirstWidth + 4 * STWidthAdd, STheight5


    '''''''''''''''''''
    ''' Second Fort '''
    '''''''''''''''''''

    comment "Second Fort (JFORT)"

    'Tower
    Dim jtx, jty, jth, jtw
    jtx = -330
    jty = -330
    jth = 50 'height
    jtw = 10
    jtd = 10
    Box jtx, jty, 0, 0, jtw, jtw, jth
    jtWidth = jtw / 4
    jtHeight = jth / 4
    jtPyHeight = jth * (5 / 4)

    'Towers on top
    jfort_tower jtx - jtd, jty - jtd, jth
    jfort_tower jtx - jtd, jty + jtd, jth
    jfort_tower jtx + jtd, jty + jtd, jth
    jfort_tower jtx + jtd, jty - jtd, jth

    jtx = -346
    'jty = -326.5
    jth = 32
    jtw = 35 / 2
    jtl = 80 / 2
    jtdx = jtw
    jtdy = jtl

    Box jtx, jty, 0, 0, jtw, jtl, jth
    jfort_tower jtx - jtdx, jty - jtdy, jth
    jfort_tower jtx - jtdx, jty + jtdy, jth
    jfort_tower jtx + jtdx, jty + jtdy, jth
    jfort_tower jtx + jtdx, jty - jtdy, jth


    comment "Building to allow jump up to first high level."
    Box -273, -369, 0, 0, 40, 10, 17
    Pyramid -273, -369, 17.1, 0, 20, 5, 10, False, True, False

    comment "Inner building, transporter"
    Box -348, -226, 0, 0, 10, 15, 15
    comment "Teleporter on bldg in jfort"
    Teleporter -348, -226, 15, 0, 0.45, 6, 8, default_bsize

    comment "Long bridge into fourth quadrant."
    Box -32, -351, 19, -9, 150, 10, 5

    comment "Ziggurat dividing quadrants 3 and 4."
    Const zigx = 156
    Const zigy = -330
    Const zigW = 65
    Const zigDelta = 9
    Const zigH = 12
    Dim zigRHeight
    For i = 0 To 6
        'comment "# i=" & CStr(i)
        zigRHeight = zigH
        If i = 4 Then zigRHeight = zigH + 3
        If i = 2 Then
            comment "apply band"
            'Border_Block x, y, z, width, lenth, theta, bwidth, bheight
            Border_Block zigx, zigy, i * zigH, _
                zigW - i * zigDelta, zigW - i * zigDelta, 0, _
                9, zigDelta - 2
        End If
        Box zigx, zigy, i * zigH, 0, zigW - i * zigDelta, _
            zigW - i * zigDelta, zigRHeight
    Next i
    comment "Claim this for the jfort side"
    Const zigR = 10
    jfort_tower zigx + zigR, zigy + zigR, 84
    jfort_tower zigx - zigR, zigy + zigR, 84
    jfort_tower zigx + zigR, zigy - zigR, 84
    jfort_tower zigx - zigR, zigy - zigR, 84


    Const jWallHeight = 19
    Const jWallWidth = 8
    Const jx0 = -400
    Const jy0 = -130
    Const jx1 = -320
    Const jy1 = -180
    Const jx2 = jx1
    Const jy2 = -240
    Const jx3 = -260
    Const jy3 = jy2
    Const jx4 = -225
    Const jy4 = -300

    wdelt = jWallWidth / 2

    comment "Walls"
    straight_wall jx0, jy0, jx1, jy1, 0, jWallWidth, jWallHeight, 0, False, 0, 0, 0
    straight_wall jx1, jy1, jx2, jy2, 0, jWallWidth, jWallHeight, 0, False, 0, 0, 0
    straight_wall jx2, jy2, jx3, jy3, 0, jWallWidth, jWallHeight, 0, False, 0, 0, 0
    straight_wall jx3, jy3, jx4, jy4, 0, jWallWidth, jWallHeight, 0, False, 0, 0, 0

    Const jPathWidth = 50
    Const jx5 = jx3 + jPathWidth
    Const jy5 = jy3 + 10
    Const jx6 = jx4 + jPathWidth
    Const jy6 = jy4 + 10
    Const jx7 = -150
    Const jy7 = -400
    straight_wall jx5, jy5, jx6, jy6, 0, jWallWidth, jWallHeight, 0, False, 0, 0, 0
    straight_wall jx6, jy6, jx7, jy7, 0, jWallWidth, jWallHeight, 0, False, 0, 0, 0

    If Not Lite Then
        comment "Towers at wall junction points"
        Const jointsize = jWallWidth * 0.8
    
        Box jx0, jy0, 0, 0, jointsize, jointsize, jWallHeight
        jfort_tower jx0, jy0, jWallHeight
        Box jx1, jy1, 0, 0, jointsize, jointsize, jWallHeight
        jfort_tower jx1, jy1, jWallHeight
        Box jx2, jy2, 0, 0, jointsize, jointsize, jWallHeight
        jfort_tower jx2, jy2, jWallHeight
        Box jx3, jy3, 0, 0, jointsize, jointsize, jWallHeight
        jfort_tower jx3, jy3, jWallHeight
        Box jx4, jy4, 0, 0, jointsize, jointsize, jWallHeight
        jfort_tower jx4, jy4, jWallHeight
        Box jx5, jy5, 0, 0, jointsize, jointsize, jWallHeight
        jfort_tower jx5, jy5, jWallHeight
        Box jx6, jy6, 0, 0, jointsize, jointsize, jWallHeight
        jfort_tower jx6, jy6, jWallHeight
        Box jx7, jy7, 0, 0, jointsize, jointsize, jWallHeight
        jfort_tower jx7, jy7, jWallHeight
    End If
    
    comment "Defensive teleporter."
    'teleporter x, y, z, rotation, sizeX, sizeY, sizeZ
    Teleporter -188, -325 - 3, 0, -78.5, 0.45, jointsize * 1.8, jWallHeight - 1, default_bsize
    'box x, y, z, rotation, sizeX, sizeY, sizeZ
    comment "Roof over defensive teleporter"
    Box -193, -334.5, jWallHeight, -76, 13, 18.5, 5
    comment "Wall next to defensive transporter"
    Box -200, -347.5, 0, 15, 4, 20, 10

    jfort_tower -168, -318.5, 24
    jfort_tower -163, -342.5, 24
'
    ''''''''''''''''''''''''''''
    ''' Central Blocks, Town '''
    ''''''''''''''''''''''''''''

    'Sub Box(x, y, z, rotation, sizeX, sizeY, sizeZ)
    comment "Main block - smaller of the two"
    Box 60, -20, 0, 30, 50, 60, 30

    comment "Main block - larger of the two"
    Box -70, 40, 0, -10, 40, 40, 60
    comment "Border at lower height around main block"
    'Border_Block x, y, z, width, length, theta, borderwidth, borderheight
    Border_Block -70, 40, 0, 40, 40, -10, 8, 11
    comment "Border at heighter height around main block"
    Border_Block -70, 40, 0, 40, 40, -10, 6, 45
    comment "Block on top of larger main block"
    Box -70, 40, 60, -10, 20, 20, 20

    comment "Access block towards castle"
    Box 110, 68, 0, 80, 12, 14, 15
    'Bridge into first bigblock
    Box 94.5, 55, 12, 45, 20, 5, 3

    comment "Access block towards jfort"
    Box -47, -144, 0, 45, 8, 13, 16
    'Bridge into first bigblock
    Box 4.5, -98, 14, 45, 70, 5, 2

    comment "Block to allow jump from lower building to higher one."
    Box 18.5, -5.5, 30, 0, 8, 9, 14
    Box -12.5, 8, 42, -21.5, 36.5, 6, 2

    comment "Blocks at correct height for shooting at main fort"
    Dim cblockrot
    cblockrot = 360 * Rnd()
    Box 51, 30, 0, cblockrot, 14, 8, STheight1
    Pyramid 51, 30, STheight1, cblockrot, 14, 8, 20
    Box 132, 4, 0, 90 * Rnd(), 12, 14, STheight2
    Box 133, -49, 0, 90 * Rnd(), 16, 13, STheight3

    Box 74, -28, 30, 12, 19, 23, 19

    comment "Platform to shoot at skyrise from"
    Box -103, 89.5, 35, 45, 20, 20, 5

    comment "Quadrant 3 box copy"
    Dim t_x, t_y, t_z, t_rot, t_sx, t_sy, t_sz
    t_x = -205
    t_y = 49.5
    t_z = 0
    t_rot = 90
    t_sx = 20
    t_sy = 40
    t_sz = 40
    'box x, y, z, rot, sx, sy, sz
    Box t_x, t_y, t_z, t_rot, t_sx, t_sy, t_sz
    'Border_Block x, y, z, sx, sy, rot, bwidth
    Border_Block t_x, t_y, t_z, t_sx, t_sy, t_rot, 10, 22
    Box t_x, t_y, t_z + t_sz, 0, 10, 10, 5
    Pyramid t_x, t_y, t_z + 45.1, 0, 10, 10, 40, True, True, False

    comment "Pyramid set, river-like flow"
    Call do_random_pyramids

    comment "Roman camp between first and second quadrants"
    Const rrSize = 80
    Const rrGate = 6
    Const rrHeight = 18
    Const rrX = -80
    Const rrY = 320
    Const rrThick = 1

    'derived:
    Const rrD = (rrSize - rrGate) / 4#
    Const rrX1 = rrX + rrD
    Const rrX2 = rrX + rrSize - rrD
    Const rrY1 = rrY - rrD
    Const rrY2 = rrY - rrSize + rrD

    comment "Central tower"
    Const rrXc = (rrX1 + rrX2) / 2#
    Const rrYC = (rrY1 + rrY2) / 2#
    Box rrXc, rrYC, 0, 0, 10, 10, 32

    comment "Roof for missle protection"
    Box rrXc, rrYC, 32, 0, 0.85 * rrSize / 2, 0.85 * rrSize / 2, 5


    'Box x, y, z, rot, sx, sy, sz
    Box rrX1, rrY, 0, 0, rrD, rrThick, rrHeight
    Box rrX2, rrY, 0, 0, rrD, rrThick, rrHeight
    Box rrX1, rrY - rrSize, 0, 0, rrD, rrThick, rrHeight
    Box rrX2, rrY - rrSize, 0, 0, rrD, rrThick, rrHeight

    Box rrX, rrY1, 0, 0, rrThick, rrD, rrHeight
    Box rrX, rrY2, 0, 0, rrThick, rrD, rrHeight
    Box rrX + rrSize, rrY1, 0, 0, rrThick, rrD, rrHeight
    Box rrX + rrSize, rrY2, 0, 0, rrThick, rrD, rrHeight



    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ''' Second quadrant blocks: tower with pyramid floating above it. '''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    comment "Second quadrant blocks: tower with pyramid floating above it."
    Const q2x = -220
    Const q2y = 260
    Const q2bw = 20
    Const q2h = 40
    Box q2x, q2y, 0, 0, q2bw, 2 * q2bw, q2h
    Box q2x, q2y, 0, 90, q2bw, 2 * q2bw, q2h

    Const q2mw = q2bw / 2
    Const q2delta = 2 * q2bw + (q2mw / 2)
    Box q2x + q2delta, q2y, 0, 0, q2mw, q2mw, q2h
    Box q2x, q2y - q2delta, 0, 0, q2mw, q2mw, q2h
    Box q2x - q2delta, q2y, 0, 0, q2mw, q2mw, q2h
    Box q2x, q2y + q2delta, 0, 0, q2mw, q2mw, q2h
    comment "Teleporter: on hirise"
    Teleporter q2x, q2y, q2h, 45, 0.56, 4.48, 8, default_bsize
    Const q2topwidth = q2bw + q2mw
    Box q2x, q2y, q2h + 9, 0, q2topwidth, q2topwidth, 5
    Pyramid q2x, q2y, q2h + 9 + 5 + 0.1, 0, q2topwidth, q2topwidth, 25, True, True, False
    comment "Hidden teleporter inside this"
    Teleporter q2x, q2y, q2h + 9 + 5, 0, 0.56, 4.48, 6, default_bsize


    comment "Fourth quadrant"
    arch 222, -53, 0, 0, 10, 10, 10, 10, Lite
    Box 222, -53, 20, 0, 15, 5, 5

    comment "Pyramids south of the arch"
    Pyramid 210, -93, 0, 360 * Rnd(), 5, 5, 10
    Pyramid 210, -133, 0, 360 * Rnd(), 5, 5, 10
    Pyramid 210, -173, 0, 360 * Rnd(), 5, 5, 10
    Pyramid 210, -213, 0, 360 * Rnd(), 5, 5, 10

    comment "Laser shield teleporter"
    Teleporter 380, -388, 0, 135, 0.45, 15, 20, default_bsize

    comment "Fourth quadrant tower."
    Const q4tx = 300
    Const q4ty = -170
    Const q4td = 8 * 1.414
    Box q4tx, q4ty, 0, 45, 8, 8, 75
    jfort_tower q4tx, q4ty + q4td, 75
    jfort_tower q4tx, q4ty - q4td, 75
    jfort_tower q4tx + q4td, q4ty, 75
    jfort_tower q4tx - q4td, q4ty, 75


    comment "Ramp to get to fourth quadrant"
    Box 215, -255.5, 60, 45, 120, 4, 3

    '''''''''''''''''''
    ''' Teleporters '''
    '''''''''''''''''''

    'teleporter 220, -200, 0, 0, 0.45, 9, 12
    Teleporter -31.5, -242, 0, 0, 0.45, 9, 12, default_bsize

    comment "Teleporter Links"

   
    comment "CastleFort sanctorum to in-Air, North"
    makelink 0, 4
    comment "Castlefort sanctorum to hidden teleporter"
    makelink 1, 14
    comment "Castlefort ground to jfort field"
    makelink 2, 18
    comment "Castlefort ground to in-Air, north"
    makelink 3, 5
    makelink 4, 0 'reverse
    comment "in-air North, to castlefort ground"
    makelink 5, 3
    comment "in-air south, to laser protection"
    makelink 6, 14
    comment "in-air south, to jfort"
    makelink 7, 8
    comment "jfort on bldg"
    makelink 8, 6
    makelink 9, 19
    comment "jfort defensive"
    makelink 10, 11
    makelink 11, 18
    comment "hirise visible"
    makelink 12, 0
    makelink 13, 17
    comment "hidden teleporter"
    makelink 14, 7
    makelink 15, 2
    comment "laser defense shield"
    makelink 16, 3
    makelink 17, 16
    comment "free field near jfort"
    makelink 18, 8
    makelink 19, 3

    

    Close_Output_File
    
End Sub


Sub do_random_pyramids()
    'Road pyramids
    ''RoadPyramid 200, 100
    RoadPyramid 120, 80, Lite
    RoadPyramid 80, 75, Lite
    RoadPyramid 0, 120, Lite
    RoadPyramid -10, 100, Lite
    RoadPyramid 0, 50, Lite
    RoadPyramid -20, -20, Lite
    RoadPyramid -25, -70, Lite
    RoadPyramid -30, -100, Lite
    RoadPyramid -50, -125, Lite
    RoadPyramid -90, -130, Lite
    RoadPyramid -120, -120, Lite
    RoadPyramid -180, -110, Lite
    RoadPyramid -220, -130, Lite
    RoadPyramid -280, -150, Lite
    RoadPyramid -280, -180, Lite
End Sub

''''''''''''''
''' Header '''
''''''''''''''


Sub Write_Header()
    comment "  TWO FORTRESS MAP"
    comment "   "
    comment "     September 26, 2003"
    comment "   "
    comment "     by "
    comment "   "
    comment "       Bryan A. Bentz"
    comment "       a.k.a. ""The Purple Panzer"""
    comment "       Email:"
    comment "            bentz@bentz-engineering.com, or "
    comment "            bentz@ai.mit.edu"
    comment "       URLs:"
    comment "            Personal URL: http://www-swiss.ai.mit.edu/~bentz/"
    comment "            Business URL: http://www.bentz-engineering.com/"
    comment "   "
    comment "   "
    comment "  This is my first map.  The idea was to create several distinct"
    comment "  subspaces for play.  At opposing corners are two fortresses, of "
    comment "  different styles.  In the center is a small town between them."
    comment "   "
    comment "  I tried to use several principles in the design:"
    comment "    1.  Commonality of heights - for every horizontal surface, there"
    comment "        is another within range for attack."
    comment "    2.  Personality - each subarea (basically the 4 quadrants, plus"
    comment "        the center) has a different aesthetic and set of advantages and"
    comment "        disadvantages."
    comment "    3.  For each offensive flag, there are some particularly good (but"
    comment "        vulnerable) positions."
    comment "    4.  There is enough exploring to be of interest, but not so "
    comment "        squirrelly that you have to invest a lot of time to master the map."
    comment "   "
    comment "  I created the map using BZEdit, and wrote some Visual Basic code"
    comment "  to autogenerate some structures, such as the towers and wall fragments."
    comment "  Anyone is welcome to the code, just email me.  The environment was"
    comment "  Microsoft Visual Basic 6, running on Windows 2000."
    comment "   "
    comment "   "
    
End Sub

