Attribute VB_Name = "Script_Arena"
Sub Write_Arena_Map()

    Randomize
    
    '' Grab the components library
    Install_Components_Library
    
    '' Try to open the output file; exit if error.
    If Not Open_Output_File("Arena") Then
        Exit Sub
    End If
    
    Write_Arena_Header

    'Upper-right quadrant: highlands
    Const height1 = 15
    Box 200, 200, 0, -30, 140, 140, height1
    Box 200, 175, height1, 0, 80, 80, height1
    Box 220, 175, 2 * height1, 45, 30, 30, height1
    Pyramid 220, 175, 3 * height1, 0, 10, 10, 100
    
    'Lower-right quadrant: box
    Const height2 = 17
    Box 225, -275, 0, -5, 100, 100, height2
    Pyramid 225, -275, 0, -5, 20, 20, 150
    Teleporter 300, -340, height2, 50, 0.45, 8, 8, default_bsize, "Southeast"
    'Floating box
    Box 225, -275, 33.5, -5, 60, 60, 10
    'Walls on floating box
    Box 230, -216, 38.5, -5, 40, 3, 15
    Box 167, -270.5, 38.5, -96.5, 40, 3, 15
    
    'Ramp south
    Box 180, -60, height1 - 5, -5, 10, 250, 18.5 'Not reachable!
    
    'ramp west
    Box 0, 175, 3 * height1 - 5, 0, 200, 10, 5
    Box 0, 175 - 10, 3 * height1 - 5, 0, 180, 2, 15
    
    'Box at end of west ramp.
    Box -200, 175, 0, 75, 20, 20, 3 * height1 - 5 + 15
    'Pyramid on top
    Pyramid -200, 175, 3 * height1 - 5 + 15 + 1, 75, 19, 19, 30
    'Shelf
    Box -200, 175, 15, 75, 30, 30, 2
    
    'Lower-left quadrant tower
    Box -260, -250, 0, 45, 30, 30, 75
    Teleporter -250, -240, 75, 45, 0.45, 8, 8, default_bsize, "Lower left"
    Box -270, -260, 75, 45, 8, 8, 8
    
    'Upper right teleporter
    Teleporter 360, 360, 0, 45, 0.45, 10, 10, default_bsize, "Upper right"
    
    Const nccX = -280
    Const nccY = 40
    Const nccZ = 100 + 50
    Const nccTheta = -45
    NCC_1701 nccX, nccY, nccZ, nccTheta
    Teleporter nccX - 12, nccY - 12, nccZ + 10, nccTheta, 0.45, 6, 6, default_bsize, "Enterprise"
    
    ''Walls, around center
    straight_wall 50, 0, -130, 0, 0, 10, 36, 0, False, 0, 0, 0
    straight_wall -130, 0, -130, -130, 0, 10, 36, 0, False, 0, 0, 0
    Box -90, -40, 0, 0, 20, 20, 18
    Box -135, 5, 36, 45, 5, 5, 18 - 5
    Box -135, 5, 36 + (18 - 5), 45, 20, 20, 5
    Pyramid -151, 5, 36 + 18, 45, 8, 8, 80
    
    
    Place_Component "Dihedral structure", -300, 300, 0, 90

    'southern pyramids
    Scattered_Pyramids -80, -300, 30, 100, 100
    
    'western pyramids
    Scattered_Pyramids -350, -100, 30, 100, 100

    'northern pyramids
    Scattered_Pyramids -120, 280, 30, 100, 100
    
    Const front = 1
    Const back = 2
    
    make_teleporter_link "Southeast", front, "Enterprise", front
    make_teleporter_link "Southeast", back, "Upper right", front
    
    make_teleporter_link "Upper right", front, "Lower left", front
    make_teleporter_link "Upper right", back, "Southeast", front
    
    make_teleporter_link "Lower left", front, "Upper right", front
    make_teleporter_link "Lower left", back, "Enterprise", back
    
    make_teleporter_link "Enterprise", front, "Southeast", front
    make_teleporter_link "Enterprise", back, "Lower left", back
    
    
    Close_Output_File
End Sub

Sub Write_Arena_Header()
    comment "  Jules The Jackal Arena"
    comment "   "
    comment "     OCtober 14, 2003"
    comment "   "
    comment "     by "
    comment "   "
    comment "       Bryan A. Bentz"
    comment "       a.k.a. ""The Purple Panzer"""
    comment "       Email:"
    comment "            bentz@bentz-engineering.com, or "
    comment "            bentz@ai.mit.edu"
    comment "       URLs:"
    comment "            Personal URL: http://www-swiss.ai.mit.edu/~bentz/"
    comment "            Business URL: http://www.bentz-engineering.com/"
    comment "   "
    comment "   "
End Sub

