Attribute VB_Name = "Script_GeorgesMap"
Sub Write_Georges_Map()

    Randomize
    
    '' Grab the components library
    Install_Components_Library
    
    '' Try to open the output file; exit if error.
    If Not Open_Output_File("georgemap") Then
        Exit Sub
    End If
    
    Write_Georges_Header

    comment "Upper-right box"
    Box 150, 240, 0, 0, 120, 120, 15
    
    Const b1size = 40
    Const b2size = 20
    Dim x1, x2, y1, y2, y3
    comment "Southern little boxes"
    y1 = 240 - 120 - b1size
    Box 150, y1, 0, 0, b1size, b1size, 10
    y2 = y1 - b1size - b2size
    Box 150, y2, 0, 0, b2size, b2size, 5
    
    comment "Western little boxes"
    x1 = 150 - 120 - b1size
    Box x1, 240, 10, 0, b1size, b1size, 10
    x2 = x1 - b1size - b2size
    Box x2, 240, 5, 0, b2size, b2size, 5
    
    comment "Middle clump"
    Dim mx, my, rx, ry
    mx = 300
    my = -50
    Box mx, my, 0, 0, 80 / 2, 220 / 2, 15
    Box mx, my, 15, 0, 40 / 2, 100 / 2, 14
    ry = my + 80 / 2 + 30 / 2
    Box mx, ry, 25 - 5, 0, 5 / 2, 50, 5
    
    
    comment "Lower-right box"
    Box 150, -280, 0, 45, 150, 150, 15
    
    comment "Ramp1"
    Box -85, -16, 10, 45, 200, 10, 5, "Ramp1"
    
    Teleporter -85, -16, 15, 45, 0.45, 8, 8, default_bsize, "Ramps"
    
    'Ramps around outside
    Box 0, 390, 10, 0, 400, 10, 5
    Box 0, -390, 10, 0, 400, 10, 5
    Box 390, 0, 10, 0, 10, 400, 5
    Box -390, 0, 10, 0, 10, 400, 5
    
    Teleporter 0, -390, 15, 0, 0.45, 8, 8, default_bsize, "Bottom"
    
    
    comment "Upper-left box"
    Box -350, 170, 0, 45, 150, 150, 15
    
    comment "Lower-left box"
    Box -270, -250, 0, 10, 100, 100, 15
    
    comment "Ramp2"
    Box -100, -50, 10, 135, 200, 10, 5, "Ramp2"
    
    make_teleporter_link "Ramps", 1, "Bottom", 1
    make_teleporter_link "Ramps", 2, "Bottom", 2
    make_teleporter_link "Bottom", 1, "Ramps", 1
    make_teleporter_link "Bottom", 2, "Ramps", 2
    
    Close_Output_File
End Sub

Sub Write_Georges_Header()
    comment "  George's Map"
    comment "   "
    comment "     October 16, 2003"
    comment "   "
    comment "     by "
    comment "   "
    comment "       George B. & Bryan A. Bentz"
    comment "       a.k.a. ""The Purple Panzer"""
    comment "       Email:"
    comment "            bentz@bentz-engineering.com, or "
    comment "            bentz@ai.mit.edu"
    comment "       URLs:"
    comment "            Personal URL: http://www-swiss.ai.mit.edu/~bentz/"
    comment "            Business URL: http://www.bentz-engineering.com/"
    comment "   "
    comment "   "
End Sub


