Attribute VB_Name = "Script_MiniMap"
Const HDelta = 50

Const L1_height = 0 + HDelta
Const L1_width = 100
Const L1_X = 0
Const L1_Y = 0

Const L2_Height = L1_height + HDelta
Const L2_width = 75
Const L2_X = 10
Const L2_Y = 10

Const L3_height = L2_Height + HDelta
Const L3_width = 50
Const L3_X = 50
Const L3_Y = 50

Const T_hGround = 6
Const T_hL1 = 8
Const T_hL2 = 10
Const T_hL3 = 12
Const tsep = 25

Dim tName(4) As String



Sub Write_MiniMap()

        
        '' Teleporter parameters
        Dim i As Integer
        Dim Tele_X, Tele_Y, Tele_Z

        If Not Open_Output_File("MiniMap") Then
            Exit Sub
        End If
        
        Init_Component_System
        
        comment "Experiment in Smaller Map"
        comment "   - The Purple Panzer"
        comment "1/23/2004"
        comment " "
        comment "Parser, code support system by"
        comment " "
        comment " Bryan A. Bentz"
        comment "       a.k.a. ""The Purple Panzer"""
        comment "       Email:"
        comment "            bentz@bentz-engineering.com, or "
        comment "            bentz@; ai.mit.edu; "
        comment "       URLs:"
        comment "            Personal URL: http://www-swiss.ai.mit.edu/~bentz/"
        comment "            Business URL: http://www.bentz-engineering.com/"
        comment " "
        comment " "
        
        world (150)
        
        ''' TELEPORTERS
        tName(0) = "Ground"
        tName(1) = "L1"
        tName(2) = "L2"
        tName(3) = "L3"
        
        
        'Create teleporter sets on each level (1 through 4)
        TeleDo 0, 0, 0, 0
        TeleDo 1, L1_height + 5, L1_X, L1_Y
        TeleDo 2, L2_Height + 5, L2_X, L2_Y
        TeleDo 3, L3_height + 5, L3_X, L3_Y
        
        TeleConnect
        
        '''' Zeroth level (ground)
        ''Temporary border walls
'        Box 0, 100, 0, 0, 150, 1, 10
'        Box 0, -100, 0, 0, 150, 1, 10
'        Box 100, 0, 0, 0, 1, 150, 10
'        Box -100, 0, 0, 0, 1, 150, 10
        
        'GoTo level3
        
        Randomize (3)
        Uniform_Random_Pyramids 0, 0, 10, 150, 150, 8.2, 10.25

        Box -60, 0, 0, 0, 15, 50, 14
        
        define_component "Aux Tower"
            Box 0, 0, 0, 0, 47.5, 47.5, 24
            Box 0, 0, 0, 0, 35, 35, 34
            Box 0, 0, 0, 0, 20, 20, 44
            Box 0, 0, 0, 0, 10, 10, 54
        end_component
        
        Place_Component "Aux Tower", -80, 90, 0, 0

        Box -100, -100, 0, 0, 40, 40, 15
        Box -110, -100, 15, 0, 15, 15, 15
        Border_Block -110, -100, 15, 15, 15, 0, 12, 6, 3
        
        'little tower
        Box -75, -123, 15, 0, 10, 10, 28
        
        
        'intermediate box
        Box 0, -100, 0, 45, 15, 15, 12
        
        '1st quadrant similar
        Box 50, 50, 0, 45, 16, 16, 12
        Box 50, 50, 0, 45, 8, 8, 32
        
        
        'Long ramp
        Box 0, -105, 28, 0, 95, 6, 2
        Box 95, -100, 0, 45, 10, 20, 30
        
        Box 60, -30, 0, 0, 30, 25, 20
        Box 60, -30, 20, 45, 18, 14, 15
        
        Box 117, -75, 0, 0, 20, 20, 17
        Box 110, -70, 17, 0, 5, 5, 30
        
        define_component "MiniMapGarage"
            Const gwidth = 20
            Const doorsize = 12
            Const gborder = 5
            Const dsize = 2
            Dim smallLength, smalloffset
            smallLength = (gwidth - doorsize / 2) / 2#
            smalloffset = gwidth - smallLength
            Box 0, 0, 8, 0, gwidth + gborder, gwidth + gborder, 2
            Box 0, 0, 18, 0, gwidth + gborder, gwidth + gborder, 2
            
            Box -gwidth, smalloffset, 0, 0, dsize, smallLength, 8
            Box gwidth, smalloffset, 0, 0, dsize, smallLength, 8
            Box -gwidth, -smalloffset, 0, 0, dsize, smallLength, 8
            Box gwidth, -smalloffset, 0, 0, dsize, smallLength, 8

            Box -smalloffset, gwidth, 0, 0, smallLength, dsize, 8
            Box smalloffset, gwidth, 0, 0, smallLength, dsize, 8
            Box -smalloffset, -gwidth, 0, 0, smallLength, dsize, 8
            Box smalloffset, -gwidth, 0, 0, smallLength, dsize, 8

            Box -gwidth, smalloffset, 10, 0, dsize, smallLength, 8
            Box gwidth, smalloffset, 10, 0, dsize, smallLength, 8
            Box -gwidth, -smalloffset, 10, 0, dsize, smallLength, 8
            Box gwidth, -smalloffset, 10, 0, dsize, smallLength, 8

            Box -smalloffset, gwidth, 10, 0, smallLength, dsize, 8
            Box smalloffset, gwidth, 10, 0, smallLength, dsize, 8
            Box -smalloffset, -gwidth, 10, 0, smallLength, dsize, 8
            Box smalloffset, -gwidth, 10, 0, smallLength, dsize, 8
            
            Const gpsize = 3
            Const gpdelta = 6
            Const gpheight = 50
            Pyramid -gwidth - gpdelta, -gwidth - gpdelta, 0, 0, gpsize, gpsize, gpheight
            Pyramid -gwidth - gpdelta, gwidth + gpdelta, 0, 0, gpsize, gpsize, gpheight
            Pyramid gwidth + gpdelta, -gwidth - gpdelta, 0, 0, gpsize, gpsize, gpheight
            Pyramid gwidth + gpdelta, gwidth + gpdelta, 0, 0, gpsize, gpsize, gpheight
            
       end_component
        Place_Component "MiniMapGarage", 110, 100, 0, 0
        'ramp to it.
        Box 95, 33, 8, -18, 5, 50, 2
        
        ''Intermediate
        Box 34, 110, 0, 45, 12, 12, 30
        
        Pyramid 60, -30, 35, 45, 12, 9, 15, False, True
        
    
    
        '''' Three levels above
        
        '' Level 1
level1:
        
        Box L1_X, L1_Y, L1_height, 20, L1_width, L1_width, 5
       

        ''Do this all as a component
        define_component "Level1"
            Randomize (145)
            Uniform_Random_Pyramids 0, 0, 8, 86, 86, 6#, 14#
            
            Box -80, -80, 0, 0, 12, 12, 15
            Box -71 - 5, -68 - 5, 15, 45, 5, 5, 10
            
            
            Box -45, 55, 0, 45, 15, 15, 16
            Box -45, 55, 16, 35, 10, 10, 14
            Box -45, 55, 30, 25, 6, 6, 12
            
            Box 45, -45, 0, 0, 30, 40, 16
            Box 45, -45, 16, 0, 20, 30, 16
            Box -10, -60, 30, 170, 50, 6, 2 'ramp
            Box -53, -50, 0, 50, 12, 12, 32
            
            'Wall
            Box -80, 20, 0, 0, 5, 40, 15
            
            Box 60, 40, 0, 135 + 90, 2, 24, 12
            Box 80, 70, 0, 135 + 90, 12, 12, 18
            
            
        end_component
        Place_Component "Level1", L1_X, L1_Y, L1_height + 5, 20
        'Place_Component "Level1", 0, 0, 0, 0
        
        
        
        
        
        '' Level 2
level2:
        Const bsize = 15
        deltaX = bsize * 3
        deltaY = deltaX
        
        Box L2_X, L2_Y, L2_Height, 40, L2_width, L2_width, 5
        define_component "Level2"
            Randomize (795)
            Uniform_Random_Pyramids 0, 0, 14, 70, 70, 6#, 14#
            Box 0, deltaY, 0, 0, bsize, bsize, 15
            Box 0, -deltaY, 0, 0, bsize, bsize, 15
            Box deltaX, 0, 0, 0, bsize, bsize, 15
            Box -deltaX, 0, 0, 0, bsize, bsize, 15
            
            Pyramid 0, deltaY, 15, 0, 8, 8, 20, True, True, False
            Pyramid 0, -deltaY, 15, 0, 8, 8, 20, False, True, False
            Pyramid deltaX, 0, 15, 0, 8, 8, 20, True, True, False
            Pyramid -deltaX, 0, 15, 0, 8, 8, 20, False, True, False
            
            
            Box -50, 50, 0, 45, 8, 8, 30
            
        end_component
        Place_Component "Level2", L2_X, L2_Y, L2_Height + 5, 40
        
        
        '' Level 3
level3:
    Box L3_X, L3_Y, L3_height, 60, L3_width, L3_width, 5
    define_component "Level3"
        'Place_Component "Aux Tower", 40, 40, 0, 0
            Const tx1 = 30
            Const ty1 = -30
            Box tx1, ty1, 0, 0, 20, 20, 14
            Box tx1, ty1, 0, 0, 15, 15, 24
            Box tx1, ty1, 0, 0, 10, 10, 34
            Box tx1, ty1, 0, 0, 5, 5, 44
        'Place_Component "Aux Tower", -40, -40, 0, 0
            Const tx2 = -30
            Const ty2 = 30
            Box tx2, ty2, 0, 0, 20, 20, 14
            Box tx2, ty2, 0, 0, 15, 15, 24
            Box tx2, ty2, 0, 0, 10, 10, 34
            Box tx2, ty2, 0, 0, 5, 5, 44
'        Randomize (416)
'        Uniform_Random_Pyramids 25, 25, 3, 25, 25, 5, 44
'        Uniform_Random_Pyramids -25, -25, 3, 25, 25, 5, 44
            Pyramid -30, -35, 0, 0, 3, 3, 44
            Pyramid 30, 37, 0, 0, 3, 3, 44
            
            Pyramid -12, -29, 0, 0, 3, 3, 44
            
            Pyramid 20 - 5, 18 + 14, 0, 0, 3, 3, 44
            
            Pyramid 0, -20, 0, 0, 3, 3, 44
            
            Const trad = 10 + 2
            Pyramid trad, -trad, 0, 0, 5, 5, 54
            Pyramid -trad, trad, 0, 0, 5, 5, 54
            
            
    end_component
    Place_Component "Level3", L3_X, L3_Y, L3_height + 5, 60
        
        

    Close_Output_File
    
End Sub

Sub TeleDo(inIndex As Integer, inZ, inX, RawinY)
    Dim inName As String
    Dim i As Integer
    Dim inY
    inY = RawinY - 38
    inName = tName(inIndex)
    Teleporter inX, inY, inZ, 0, 0.45, 10, T_hGround, 1, tName(inIndex) & "To" & tName(0)
    Teleporter inX, inY + tsep, inZ, 0, 0.45, 10, T_hL1, 1, tName(inIndex) & "To" & tName(1)
    Teleporter inX, inY + 2 * tsep, inZ, 0, 0.45, 10, T_hL2, 1, tName(inIndex) & "To" & tName(2)
    Teleporter inX, inY + 3 * tsep, inZ, 0, 0.45, 10, T_hL3, 1, tName(inIndex) & "To" & tName(3)
End Sub

Sub TeleConnect()
    Dim i As Integer
    Dim j As Integer
    Dim StartName As String
    Dim EndName As String
    For i = 0 To 3
        For j = 0 To 3
            StartName = tName(i) & "To" & tName(j)
            EndName = tName(j) & "To" & tName(i)
            make_teleporter_link StartName, 1, EndName, 1
            make_teleporter_link StartName, 2, EndName, 2
            make_teleporter_link EndName, 1, StartName, 1
            make_teleporter_link EndName, 2, StartName, 2
        Next j
    Next i
End Sub
