Attribute VB_Name = "Script_Two_Towers"
'New constants

Const TX1 = 50
Const TY1 = 80
Const Theta1 = 60
Const Theta2 = 40
Const Tele1X = -100
Const Tele1Y = 200

Const TX2 = -80
Const TY2 = -120
Const Tele2X = 50
Const Tele2Y = -250

Dim Tower_Distance As Double

Const NumFloorsPerChamber = 3
Const NumChambers = 6
Const Floor_Height = 15
Const Chamber_Height = NumFloorsPerChamber * Floor_Height

Dim tName(50) As String
Const NumTeleporters = NumChambers
Dim Height(50) As Double
Dim ChamberFloor(20) As Integer

Dim ComponentName As String
Dim ComponentNumber As Integer
Sub Write_Two_Towers()

        '' Teleporter parameters
        Dim i As Integer
        Dim Z, xSize, ySize
        Dim Tele_X, Tele_Y, Tele_Z
        Dim temp1 As Long
        Dim temp2 As Long
        Dim ifloor As Integer
        Dim BaseIndex As Integer

        If Not Open_Output_File("TwoTowers") Then
            Exit Sub
        End If
        
        Init_Component_System
        
        comment "Two Towers"
        comment "   - The Purple Panzer"
        comment CStr(Date)
        comment " "
        comment "Parser, code support system by"
        comment " "
        comment " Bryan A. Bentz"
        comment "       a.k.a. ""The Purple Panzer"""
        comment "       Email:"
        comment "            bentz@bentz-engineering.com, or "
        comment "            bentz@; ai.mit.edu; "
        comment "       URLs:"
        comment "            Personal URL: http://www-swiss.ai.mit.edu/~bentz/"
        comment "            Business URL: http://www.bentz-engineering.com/"
        comment " "
        comment " "
        
        world (400)
       
       
        'Tower platforms
        ifloor = 1
        For i = 1 To NumChambers
            For j = 1 To NumFloorsPerChamber
                'j=3, default case
                xSize = 35
                ySize = 35
                If j = 1 Then
                    xSize = 60
                    ySize = 60
                End If
                If j = 2 Then
                    xSize = 45
                    ySize = 45
                End If
                
                Z = ((NumFloorsPerChamber * (i - 1)) + (j - 1)) * Floor_Height
                Height(ifloor) = Z
                If j = 1 Then
                    ChamberFloor(i) = ifloor
                End If
                ifloor = ifloor + 1
                'Debug.Print "I, J, Z: " & CStr(i) & ", " & CStr(j) & ", " & CStr(Z)
                If Z <> 0 Then
                    Box TX1, TY1, Z, Theta1, xSize, ySize, 2
                    Decorate_Floor TX1, TY1, Z + 2, Theta1, xSize, ySize, Floor_Height
                    Box TX2, TY2, Z, Theta2, xSize, ySize, 2
                    Decorate_Floor TX2, TY2, Z + 2, Theta2, xSize, ySize, Floor_Height
                   End If
            Next j
        Next i
        
        'Corner posts, side walls
        define_component "Corners and Walls"
            Const PyrBaseSize = 12
            Dim mSize
            mSize = Height(ChamberFloor(NumChambers) + 2) + 20
            Pyramid -60, -60, 0, 0, PyrBaseSize, PyrBaseSize, mSize + 20
            Pyramid -60, 60, 0, 0, PyrBaseSize, PyrBaseSize, mSize + 20
            Pyramid 60, -60, 0, 0, PyrBaseSize, PyrBaseSize, mSize + 20
            Pyramid 60, 60, 0, 0, PyrBaseSize, PyrBaseSize, mSize + 20
            
            'Side1
            Box -60, 10, 5, 0, 2, 8, mSize - 20
            Box -60, -30, 140, 0, 2, 12, mSize / 2#
            
            'Side 2
            Box 60, 40, 40, 0, 2, 12, mSize * 0.8
            Box 60, -30, mSize * 0.4, 0, 2, 20, mSize * 0.4
            
            'Side 3
            Box 10, 60, 0, 0, 25, 2, mSize * 0.9
            
            
        end_component
        Place_Component "Corners and Walls", TX1, TY1, 0, Theta1 + 180
        Place_Component "Corners and Walls", TX2, TY2, 0, Theta2
        
        'Ground decorations
        Box -280, 220, 0, 0, 20, 110, 15
        Box -240, -240, 0, 45, 30, 60, 16
        Box 250, 250, 0, 45 + 90, 100, 14, 16
        Box 220, -100, 0, 0, 30, 110, 15
        
        Pyramid -250, 0, 0, 0, 20, 20, 30
        Pyramid -300, -280, 0, 0, 20, 20, 30
        Pyramid 0, -300, 0, 0, 30, 30, 40
        Pyramid 280, -280, 0, 0, 25, 25, 30
        Pyramid 200, 200, 0, 45, 20, 20, 50
        Pyramid -50, 340, 0, 0, 40, 40, 80
        
            
        ''' TELEPORTERS
        Rnd (-10)
        Randomize (20)
        For i = 1 To NumChambers
            'Debug.Print "I: " & CStr(i) & ", Z: " & CStr(Tele_Z)
            BaseIndex = (i - 1) * 4 + 1
            Tele_Z = Height(ChamberFloor(i))
            tName(BaseIndex) = "Tower 1 Chamber " & CStr(i) & " Down"
            tName(BaseIndex + 1) = "Tower 1 Chamber " & CStr(i) & " Up"
            tName(BaseIndex + 2) = "Tower 2 Chamber " & CStr(i) & " Down"
            tName(BaseIndex + 3) = "Tower 2 Chamber " & CStr(i) & " Up"
            TowerTeleporterSet BaseIndex, Tele_Z, Tele1X, Tele1Y, Tele2X, Tele2Y
        Next i

        TeleConnect
    
    Close_Output_File
    
End Sub

Sub TowerTeleporterSet(inIndex As Integer, inZ, Tele1X, Tele1Y, Tele2X, Tele2Y)
    'Old Constants (Teleporter Parameters)
    
    Const T_hL1 = 7
    Const T_hL2 = 12
    Const tsep = 14
    Const pw = 30
    Const theta = 0
    Const sY = 6
    Const Sy2 = 6
    
    Dim inName As String
    Dim i As Integer
    Dim inY
    inY = RawinY - 38
    Dim midX, midY, lenX, lenY
    
    If inZ > 0 Then
        'Platforms under teleporters
        If inZ <> 0 Then
            Box Tele1X, Tele1Y, inZ, 45, pw, pw, 2
            Box Tele2X, Tele2Y, inZ, 45, pw, pw, 2
        End If
        
        'Ramps to main tower points
        straight_wall Tele1X, Tele1Y, TX1 + ABSrnd(40, 20), TY1 + ABSrnd(50, 20), inZ, 9, 2, 0, False, 0, 0, 0
        straight_wall Tele2X, Tele2Y, TX2 + ABSrnd(40, 20), TY2 + ABSrnd(50, 20), inZ, 9, 2, 0, False, 0, 0, 0
    End If
    
    'Teleporters
    'Down teleporters
    If inZ > 0 Then 'Don't do this on the ground
        'Debug.Print "Creating teleporter " & tName(inIndex)
        Teleporter Tele1X, Tele1Y - tsep, inZ + 2, theta, 0.45, sY, T_hL1, 1, tName(inIndex)
        'Debug.Print "Creating teleporter " & tName(inIndex + 2)
        Teleporter Tele2X, Tele2Y - tsep, inZ + 2, theta, 0.45, sY, T_hL1, 1, tName(inIndex + 2)
    End If
    'Up Teleporters
    If inZ < Height(ChamberFloor(NumChambers)) Then 'Don't do this on the top.
        'Debug.Print "Creating teleporter " & tName(inIndex + 1)
        If inZ = 0 Then inZ = -2
        Teleporter Tele1X, Tele1Y + tsep, inZ + 2, theta, 0.45, Sy2, T_hL2, 1, tName(inIndex + 1)
        'Debug.Print "Creating teleporter " & tName(inIndex + 3)
        Teleporter Tele2X, Tele2Y + tsep, inZ + 2, theta, 0.45, Sy2, T_hL2, 1, tName(inIndex + 3)
    End If
End Sub

Function ABSrnd(inabs As Double, Optional minvar = 0) As Double
    Dim t1 As Double
    t1 = (inabs - minvar) * Rnd() + minvar
    If Rnd() > 0.5 Then
        ABSrnd = -t1
    Else
        ABSrnd = t1
    End If
    ''Debug.Print "ABSrnd returns: " & CStr(ABSrnd)
End Function

Sub TeleConnect()
    Dim i As Integer
    Dim j As Integer
    Dim StartName As String
    Dim EndName As String
    Dim StartBaseIndex As Integer
    Dim EndBaseIndex As Integer
    Dim Tower1Down As String
    Dim Tower1Up As String
    Dim Tower2Down As String
    Dim Tower2Up As String
    
    For i = 1 To NumChambers
            StartBaseIndex = (i - 1) * 4 + 1
            EndBaseIndex = i * 4 + 1
            Tele_Z = Height(ChamberFloor(i))
            If Tele_Z < Height(ChamberFloor(NumChambers)) Then
                'Only connect up, but do so fully (installing the down links too)
                '' First tower
                StartName = tName(StartBaseIndex + 1) 'up one on this level
                EndName = tName(EndBaseIndex) 'down one on next level
                'Debug.Print "i=" & CStr(i) & ", Connecting " & StartName & ", " & EndName
                fully_connect_teleporters StartName, EndName
                
                '' Second tower
                StartName = tName(StartBaseIndex + 3) 'up one on this level
                EndName = tName(EndBaseIndex + 2) 'down one on next level
                'Debug.Print "i=" & CStr(i) & ", Connecting " & StartName & ", " & EndName
                fully_connect_teleporters StartName, EndName
            End If
            
        Next i
End Sub


''''''''''''''''''''''''
''' Floor decoration '''
''''''''''''''''''''''''

Sub Decorate_Floor(Xc, Yc, Zc, theta, xSize, ySize, zSize)
    'This function threatens to be a good place to put logic to
    'configure a good rectangle of play.
    
    'First, choose a style:
    '  1.  Loosely walled, with some internal structure;
    '  2.  Sparse blocks/pyramids
    '  3.  Corner blocks/internal cross
    '  4.  pyramid corner supports, central block
    
    Const NumStyles = 4
    Dim StylePick As Integer
    Dim bXsize, bYsize
    StylePick = ChooseStyle(NumStyles)
    
    'Floors will be defined components, later moved into place.
    ComponentNumber = ComponentNumber + 1
    ComponentName = "Floor" & CStr(ComponentNumber)
    ''Inline code the styles, so we can easily reference pieces
    Select Case StylePick
    
        Case 1
            '1.  Loosely walled, with some internal structure
            define_component ComponentName
                Dim gwidth, doorsize, gborder, dsize
                gwidth = xSize - 15
                doorsize = 16
                gborder = 5
                dsize = 2
                Dim smallLength, smalloffset
                smallLength = (gwidth - doorsize / 2) / 2#
                smalloffset = gwidth - smallLength
                
                If Rnd() > 0.5 Then Box -gwidth, smalloffset, 0, 0, dsize, smallLength, zSize
                If Rnd() > 0.5 Then Box gwidth, smalloffset, 0, 0, dsize, smallLength, zSize
                If Rnd() > 0.5 Then Box -gwidth, -smalloffset, 0, 0, dsize, smallLength, zSize
                If Rnd() > 0.5 Then Box gwidth, -smalloffset, 0, 0, dsize, smallLength, zSize
    
                If Rnd() > 0.5 Then Box -smalloffset, gwidth, 0, 0, smallLength, dsize, zSize
                If Rnd() > 0.5 Then Box smalloffset, gwidth, 0, 0, smallLength, dsize, zSize
                If Rnd() > 0.5 Then Box -smalloffset, -gwidth, 0, 0, smallLength, dsize, zSize
                If Rnd() > 0.5 Then Box smalloffset, -gwidth, 0, 0, smallLength, dsize, zSize
    
               
            end_component
            Place_Component ComponentName, Xc, Yc, Zc, theta

        Case 2
            '  2.  Sparse blocks/pyramids
            Const MaxBlocks = 8
            Const MinBlocks = 2
            Dim NumBlocks
            Const MaxPyramids = 5
            Const MinPyramids = 2
            Dim NumPyramids
            NumBlocks = Rnd(MaxBlocks - MinBlocks) + MinBlocks
            NumPyramids = Rnd(MaxPyramids - MinPyramids) + MinPyramids
            define_component ComponentName
                For i = 1 To NumBlocks
                   bXsize = Rnd(10) + 5
                   bYsize = Rnd(10) + 5
                   Box ABSrnd(xSize - bXsize), ABSrnd(ySize - bYsize), 0, 0, bXsize, bYsize, (zSize - 5) * Rnd() + 5
                Next i
                For i = 1 To NumPyramids
                    bXsize = Rnd(6) + 6
                    Pyramid ABSrnd(xSize - bXsize), ABSrnd(ySize - bXsize), 0, 360 * Rnd, bXsize, bYsize, zSize
                Next i
            end_component
            Place_Component ComponentName, Xc, Yc, Zc, theta
            
        
        Case 3
            '  3.  Corner blocks/internal cross
            Dim AvenueHalfWidth
            AvenueHalfWidth = Abs(ABSrnd(0.4 * xSize, 10))
            Dim remainingXSize, remainingYsize, xoffset, yoffset
            remainingXSize = xSize - AvenueHalfWidth - 8
            remainingYsize = ySize - AvenueHalfWidth - 8
            bXsize = remainingXSize / 2#
            bYsize = remainingYsize / 2#
            xoffset = xSize - bXsize - 8
            yoffset = ySize - bYsize - 8
            define_component ComponentName
                Box xoffset, yoffset, 0, 0, bXsize, bYsize, zSize
                Box -xoffset, yoffset, 0, 0, bXsize, bYsize, zSize
                Box xoffset, -yoffset, 0, 0, bXsize, bYsize, zSize
                Box -xoffset, -yoffset, 0, 0, bXsize, bYsize, zSize
            end_component
            Place_Component ComponentName, Xc, Yc, Zc, theta
       
        Case 4
            '  4.  pyramid corner supports, central block
            
        
        Case Else
'            MsgBox "error here."
'            Error 35
    End Select
End Sub


Function ChooseStyle(maxStyle) As Integer
    Dim t1 As Double
    Dim lowlimit As Double
    Dim highlimit As Double
    Dim i As Integer
    t1 = Rnd()
    For i = 1 To maxStyle
        lowlimit = CDbl(i - 1) * (1# / maxStyle)
        highlimit = CDbl(i) * (1# / maxStyle)
        If t1 > lowlimit And t1 <= highlimit Then
            ChooseStyle = i
            Exit Function
        End If
    Next i
    MsgBox "Error in ChooseStyle."
End Function
