Attribute VB_Name = "Script_UnitBlocks"
''' Define a block structure to hold existing block information.
Public Type Block
    x As Integer
    y As Integer
    z As Integer
    width As Integer
    Height As Integer
    length As Integer
    theta As Integer
End Type

Public Blocks(1000) As Block
Public iNextBlock As Integer


Sub Write_UnitBlocks()
    Dim i As Integer
    Dim Fheight As Integer
    Dim bsize As Integer
    Dim Delta As Integer
    
    Const FundamentalUnitSize = 3
    Dim UnitSize As Integer
    Dim OneWidth As Integer
    Dim TwoWidth As Integer
    Dim FourWidth As Integer
    Dim EightWidth As Integer
    Dim SixteenWidth As Integer
    Dim BlockHeight As Integer
    Dim BlockWidth As Integer
    Dim Wallheight As Integer
    Dim ptemp As Integer
    
    ''Initialization
    UnitSize = FundamentalUnitSize '3
    OneWidth = UnitSize             '3 - Single pillar width
    TwoWidth = 2 * OneWidth         '6 - Small square block
    FourWidth = 2 * TwoWidth        '12 - Basic workhorse block
    EightWidth = 2 * FourWidth      '24 - Medium long block
    SixteenWidth = 2 * EightWidth   '48 - Long block
    BlockHeight = TwoWidth
    BlockWidth = OneWidth
    
    If Not Open_Output_File("UnitBlocks") Then
        Exit Sub
    End If

    world 400
    
    
    
    
    'Minor fort guarding the road
    Place_Component "Minor fort", 50, -225, 0, 0
    'Road from bottom
    Box 50, -320, FourWidth, 0, TwoWidth, 100, UnitSize
    '   supports
        Box 50, -320, 0, 0, UnitSize, UnitSize, FourWidth
    'Road up to main form
    Box 80, -80, FourWidth, -15, TwoWidth, 120, UnitSize
    '   supports
        Box 80, -80, 0, -15, UnitSize, UnitSize, FourWidth
    
    'Main fort
    Box 125, 125, FourWidth, 0, 100, 100, UnitSize
    
    'Do pyramids underneath
    Dim pAngle As Double
    Dim pRadius As Integer
    pRadius = 80
    For pAngle = 0 To 360 Step 45
        Pyramid pRadius * cosD(pAngle) + 125, pRadius * sinD(pAngle) + 125, 0, pAngle, FourWidth, FourWidth, FourWidth + UnitSize
    Next pAngle
    '  Four corners
        i = 15
        Box 125 - 100 + bsize, 125 + 100 - bsize, 0, 0, bsize, bsize, i * UnitSize
        Box 125 - 100 + bsize, 125 - 100 + bsize, 0, 0, bsize, bsize, i * UnitSize
        Box 125 + 100 - bsize, 125 - 100 + bsize, 0, 0, bsize, bsize, i * UnitSize
        'Box 125 + 100, 125 + 100, 0, 0, BSize, BSize, i*unitsize
        'Split this last one.
        Delta = 30
        Box 125 + 100 - Delta, 125 + 100, 0, 0, bsize * 0.8, bsize * 0.8, i * UnitSize
        Box 125 + 100, 125 + 100 - Delta, 0, 0, bsize * 0.8, bsize * 0.8, i * UnitSize
    '  Walls
    Wallheight = FourWidth 'eightwidth
     Box 125 - 10, 125 + 100 - UnitSize, FourWidth + UnitSize, 0, 100 - 15, UnitSize, Wallheight
     Box 125 + 100 - UnitSize, 125 - 10, FourWidth + UnitSize, 0, UnitSize, 100 - 15, Wallheight
'   wall with southern gate
''    Box 125, 125 - 100, FourWidth + UnitSize, 0, 100, UnitSize, Wallheight
    Box 160, 125 - 100 + UnitSize, FourWidth + UnitSize, 0, 45, UnitSize, Wallheight
    Box 70, 125 - 100 + UnitSize, FourWidth + UnitSize, 0, 32, UnitSize, Wallheight
    'well with Western gate
''    Box 125 - 100, 125, FourWidth + UnitSize, 0, UnitSize, 100, Wallheight
    Box 125 - 100 + UnitSize, 100, FourWidth + UnitSize, 0, UnitSize, 55, Wallheight
    Box 125 - 100 + UnitSize, 190, FourWidth + UnitSize, 0, UnitSize, 20, Wallheight
    
    '  Higher areas
    Box 90, 100, FourWidth + UnitSize, 0, 40, 40, FourWidth
    Box 90, 100, 2 * FourWidth + UnitSize, 0, 27, 27, FourWidth
    Box 90, 100, 3 * FourWidth + UnitSize, 0, 18, 18, FourWidth
    ' Additional
    Box 150, 190, FourWidth + UnitSize, 0, 25, 25, FourWidth
    Box 150, 190, 2 * FourWidth + UnitSize, 0, 20, 20, FourWidth
    Box 150, 190, 3 * FourWidth + UnitSize, 0, 15, 15, FourWidth
    Box 150, 190, 4 * FourWidth + UnitSize, 0, 10, 10, FourWidth
    Box 150, 190, 5 * FourWidth + UnitSize, 0, 5, 5, FourWidth
    Pyramid 150, 190, 6 * FourWidth + UnitSize, 0, 5, 5, 10, False, True
    'pyramid
    Pyramid 180, 100, FourWidth + UnitSize, 0, 20, 20, 100
    
    'junction pyramid
    Pyramid 90, 100, 39 + 12, 0, 7, 7, 40, False, True
    
    'minor pyramid
    Pyramid 58, 168, FourWidth + UnitSize, 0, 10, 10, 60
    'Major routes out of there
    Box -37, 20.5, 4 * FourWidth, 32, 150, TwoWidth, UnitSize
    Box -37, 20.5, 0, 32, UnitSize, UnitSize, 17 * UnitSize
    
    Box 238, 63, 4 * FourWidth, -14.5, 150, TwoWidth, UnitSize
    Box 238, 63, 0, -14.5, UnitSize, UnitSize, 17 * UnitSize
    
    Box 54, 235, 4 * FourWidth, 108, 155, TwoWidth, UnitSize 'to north
    Box 54, 235, 0, 108, UnitSize, UnitSize, 17 * UnitSize
    
    'Tower at end
    'Box -174, -65, 0, 45, 20, 20, 4 * FourWidth + UnitSize
    ptemp = 6
    define_component "Intermediate Box"
        Box 0, 0, 0, 0, 20, 20, 4 * FourWidth + UnitSize
        Pyramid 18, 18, 4 * FourWidth + UnitSize, 0, ptemp, ptemp, 30
        Pyramid 18, -18, 4 * FourWidth + UnitSize, 0, ptemp, ptemp, 30
        Pyramid -18, 18, 4 * FourWidth + UnitSize, 0, ptemp, ptemp, 30
        Pyramid -18, -18, 4 * FourWidth + UnitSize, 0, ptemp, ptemp, 30
        ptemp = 12
        Box 18, 18, 4 * FourWidth + UnitSize - 10, 0, ptemp, ptemp, 10
        Box 18, -18, 4 * FourWidth + UnitSize - 10, 0, ptemp, ptemp, 10
        Box -18, 18, 4 * FourWidth + UnitSize - 10, 0, ptemp, ptemp, 10
        Box -18, -18, 4 * FourWidth + UnitSize - 10, 0, ptemp, ptemp, 10
        
        'Steps up (need to fix)
        ptemp = 10
        Box -18 - ptemp, -18 - ptemp - 8, 44 - UnitSize, 0, ptemp, ptemp, UnitSize
        Box -18 - 2 * ptemp, -18 - 2 * ptemp - 8, 30 - UnitSize, 0, ptemp, ptemp, UnitSize
        Box -18 - 3 * ptemp, -18 - 3 * ptemp - 8, 15 - UnitSize, 0, ptemp, ptemp, UnitSize
        
        Box -18 - ptemp, -18 - ptemp - 8, 0, 0, UnitSize, UnitSize, 44 - UnitSize
        Box -18 - 2 * ptemp, -18 - 2 * ptemp - 8, 0, 0, UnitSize, UnitSize, 30 - UnitSize
        Box -18 - 3 * ptemp, -18 - 3 * ptemp - 8, 0, 0, UnitSize, UnitSize, 15 - UnitSize
        
        'Box -18 - 4 * ptemp, -18 - 4 * ptemp, 0 * FourWidth + UnitSize - 10, 0, ptemp, ptemp, UnitSize
        
    end_component
    Place_Component "Intermediate Box", -174, -65 + 8, 0, 30 '45

    
    
    
    'Roadway away
    Box -267, -77, 4 * FourWidth, 9.5, 110, TwoWidth, UnitSize
    Box -267, -77, 0, 9.5, UnitSize, UnitSize, 17 * UnitSize
    
    
    'Second minor fort
    Place_Component "Minor fort", -200, 200, 0, 90
    'Road into main fort
    Box -76.5, 179.5, FourWidth, -10, 110, TwoWidth, UnitSize
    '   Supports
        Box -76.5, 179.5, 0, -10, UnitSize, UnitSize, FourWidth
    'Road to edge
    Box -312, 300, FourWidth, -50, 145, TwoWidth, UnitSize
    '   Supports
        Box -312, 300, 0, -50, UnitSize, UnitSize, FourWidth
        
    'Road to upper right from main fort
    Box 308.5, 295.5, FourWidth, 40, 120, TwoWidth, UnitSize
    '   Supports
        Box 308.5, 295.5, 0, 40, UnitSize, UnitSize, FourWidth
        
        
    'Terminal centers - define a general structure
    define_component "Path Terminal"
        Box 0, 0, 0, 0, 30, 30, UnitSize
        Box 20, 20, UnitSize, 0, 8, 8, TwoWidth
        Box 20, -20, UnitSize, 0, 7, 7, TwoWidth * 1.5
        Box -20, 20, UnitSize, 0, 8, 8, FourWidth
        Box -20, -20, UnitSize, 0, 4, 4, EightWidth
    
    end_component
    Place_Component "Path Terminal", -360, -100, 48, 0
    Teleporter -360, -100, 48 + UnitSize, 90, 0.45, 10, 10, 1, "West Central"
    
    Box -360, -100, 0, 0, 12, 12, 15
    Box -360, -100 + 12 + 10, 18, 0, 16, 12, 12
    Box -360, -100 - 15 - 10, 18, 0, 16, 12, 12
    
    Box -360, -100 + 12 + 10 + 16 + 10, 32, 0, 12, 12, 12
    Box -360, -100 - 15 - 10 - 16 - 10, 32, 0, 12, 12, 12
    
    
    'Northern block, unique
    define_component "Northern Terminal"
        Box 0, 0, 0, 0, 30, 30, UnitSize
        Box -20 + 2, -28, UnitSize, 0, 10 + 2, UnitSize, 2
        Box 20 - 2, -28, UnitSize, 0, 10 + 2, UnitSize, 2
    end_component
    Place_Component "Northern Terminal", 23, 360, 48, 0
    Teleporter 23, 360, 48 + UnitSize, 0, 0.45, 10, 10, 1, "North Central"
    
    'Now, underneath
    Box 22 + 50, 360, 48 + UnitSize - 4 * UnitSize, 0, 15, 8, 1
    Box 22 + 70, 340, 24, 40, 8, 15, 1
    Box 22 + 40, 330, 12, 0, 8, 15, 1
    
    Pyramid 22 + 50, 360, 0, 0, 5, 5, 48 + UnitSize - 4 * UnitSize
    Pyramid 22 + 70, 340, 0, 40, 5, 5, 24
    Pyramid 22 + 40, 330, 0, 0, 5, 5, 12
    
    fully_connect_teleporters "West Central", "North Central"
    
    Teleporter -350, -350, 0, 45, 0.45, 10, 10, 1, "SouthWest"
    
    Box -310, -310, 0, 45, 25, 25, FourWidth
    Box -310, -310, FourWidth, 45, 12, 12, 15
    Pyramid -310, -310, 2 * FourWidth, 45, 12, 12, EightWidth, False, True
    
    Teleporter 380, 370, 0, 0, 0.45, 10, 10, 1, "Out"
    fully_connect_teleporters "SouthWest", "Out"
    
    'Rightmost block
    Box 388 - 4, 23, 0, 0, 12 + 4, 12 + 4, 51
    'road in lower
    Box 320.5, -41, 36, 45, 90, TwoWidth, UnitSize
    Box 320.5, -41, 0, 45, UnitSize, UnitSize, 36 'support
    
    'Intermediate box
    Box 267, -101, 0, 45, 12, 12, 36 + UnitSize
    
    'Extra platform
    define_component "Extra Platform"
        Box 0, 0, 0, 0, 15, 15, 5
        Pyramid -13, 13, 5, 0, 2, 2, 20
        Pyramid -13, -13, 5, 0, 2, 2, 20
        Pyramid 13, 13, 5, 0, 2, 2, 20
        ptemp = 8 + 4
        Box 13 - ptemp, -13 - 3, 0, 0, 5, UnitSize, 10
        Box 13 + 3, -13 + ptemp, 0, 0, UnitSize, 5, 10
    end_component
    Place_Component "Extra Platform", 267 - 25, -101, 34, 45
    'Box 267 - 25, -101, 38, 45, 15, 15, 5
    
    Box 292, -164, 22, 203.5, TwoWidth, 70, UnitSize 'next lower road
    Box 292, -164, 0, 203.4, UnitSize, UnitSize, 22 'support
    Box 320, -228.5, 0, 0, 8, 8, 22 + UnitSize
    Box 320, -228.5, 0, 0, 18, 18, 12
    
    Pyramid 320 + 20, -228.5 + 20, 0, 0, 5, 5, 50
    Pyramid 320 - 20, -228.5 + 20, 0, 0, 5, 5, 50
    Pyramid 320 + 20, -228.5 - 20, 0, 0, 5, 5, 50
    Pyramid 320 - 20, -228.5 - 20, 0, 0, 5, 5, 50
    
    ''Stonehenge
    define_component "LintelPair"
        Box 0, 3, 0, 0, 1, 2, 12
        Box 0, -3, 0, 0, 1, 2, 12
        Box 0, 0, 12, 0, 1, 4, 2
    end_component
    
    define_component "Stonehenge"
        comment "Stonehenge!"
        Const pRadius2 = 40
        Const plinthHeight = 12
        Const plinthWidth = 2
        Const plinthLength = 1
        Const numPlinths = 30
        Const plinthAngle = 360# / numPlinths
        Dim pAngle2 As Double
        Dim pX As Double
        Dim pY As Double
        Dim tempX1 As Double
        Dim tempX2 As Double
        Dim tempY1 As Double
        Dim tempY2 As Double
        Dim tempXtop As Double
        Dim tempYtop As Double
        
        For i = 0 To numPlinths
            pAngle2 = i * plinthAngle
            pX = pRadius2 * cosD(pAngle2)
            pY = pRadius2 * sinD(pAngle2)
            'Verticals
            Select Case i
                Case 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 15, 16, 17, 22, 27, 28
                    Box pX, pY, 0, pAngle2, plinthLength, plinthWidth, plinthHeight
                Case 12, 13, 19, 24, 26, 29, 30
                    Pyramid pX, pY, 0, pAngle2, plinthLength, plinthLength, plinthHeight / 2#
            End Select
            
            'Top blocks
            Select Case i
                Case 1, 3, 6, 7, 8, 9, 16
                    pAngle2 = (i + 0.5) * plinthAngle
                    pX = pRadius2 * cosD(pAngle2)
                    pY = pRadius2 * sinD(pAngle2)
                    Box pX, pY, plinthHeight, pAngle2, plinthLength, plinthHeight / 2#, plinthWidth
            End Select
               
        Next i
        
        'Central blocks
        'Box 22, 10, 0, 0, plinthLength, plinthWidth, plinthHeight
        Place_Component "LintelPair", 19, 8, 0, 0
        Box -19, 8, 0, 0, plinthLength, plinthWidth, plinthHeight
        
        Pyramid -19, 3, 0, 0, plinthLength, plinthWidth, plinthHeight
        
        'alter
        Box 0, -10, 0, 0, 10, 2, UnitSize
        
        Place_Component "LintelPair", 18, -5, 0, -15
        Place_Component "LintelPair", -18, -5, 0, 15
        
        
    end_component
    Place_Component "Stonehenge", -180, -280, 0, 0
    Teleporter -180, -280, 0, 90, 0.45, 8, 10, 0.5, "Stonehenge"
    
    'Teleporter on high block
    Teleporter 388, 23, 51, 0, 0.45, 8, 10, 0.5, "HighBlock"
    fully_connect_teleporters "Stonehenge", "HighBlock"
    
    
    'Big pyramids
    Pyramid -263, 65, 0, 45, 30, 30, 100
    
    Pyramid 220, 330, 0, 0, 25, 25, 80
    
    Pyramid 198, -290, 0, 0, 30, 30, 100
    
    Close_Output_File

End Sub


'''''''''''''''''''''''
''' Block Placement '''
'''''''''''''''''''''''

''' Want to be able to place blocks on locations, and get back
''' handles or names.  Then place other blocks adjacent to existing
''' blocks, lined up in a variety of ways.

Sub add_block(x, y, z, width, Height, length, theta)
    Dim nBlock As Block
    Set nBlock = New Block
    nBlock.x = x
    nBlock.y = y
    nBlock.z = z
    nBlock.width = width
    nBlock.Height = Height
    nBlock.length = length
    nBlock.theta = theta
    Call Save_Block_Data(nBlock)
    
    ''Now, draw the real block
    Box x, y, z, theta, length, width, Height
End Sub

Sub Save_Block_Data(inBlock As Block)
    Blocks(iNextBlock) = inBlock
    iNextBlock = iNextBlock + 1
End Sub
