Attribute VB_Name = "Script_V2"
Sub Write_First_V2_Map()
    Const xc = 0
    Const yc = 0
    Const Offset = 10

    V2 = True 'do just V1 for BZEdit fixes!

    If Not Open_Output_File("V2Map1", False) Then
        Exit Sub
    End If

    Call setOptions
    world 500

    Install_Components_Library
    
    'Highways first.
    Call highway_material    'Define the highway material


'    raw_emit ("physics")
'    raw_emit ("  name JP1")
'    raw_emit ("  linear -10 0 46")
'    raw_emit ("End")

    
    'highway z, p1x, p1y, p2x, p2y
    highway 12, -400, 400, xc - Offset, yv + Offset
    Box -400, 400, 0, 0, 4, 4, 12

    Const xh2 = 50 '' -150
    Const yh2 = -400
    
    highway 12, xc - Offset, yc - Offset, xh2, yh2
    Box xh2, yh2, 0, 0, 4, 4, 12

    highway 12, xc + Offset, yc - Offset, 420, -180
    Box 420, -180, 0, 0, 4, 4, 12

    Box xc, yc, 0, 0, 8, 8, 12
    
    
    'Some hills
    Call hill_material

    ''' Major ridge to the left:
    'hill rndSeed, x, y, xLength, yLength, xSteps, ySteps, Height
    hill 3.14, -200, -20, 400, 180, 40, 15, 50
    '' Platform on top
    'Box x, y, z, theta, sX, sY, sZ
    Box -200, -20, 40, 0, 30, 20, 15
    'Ramp up to this point
    'Mramp -200, -190, -220, -190, -220, -40, -200, -40, 55
    Box -200, -60, 0, 0, 15, 15, 45
    Box -220, -90, 0, 0, 15, 15, 35
    Box -250, -110, 0, 0, 15, 15, 20
    Box -290, -120, 0, 0, 15, 15, 15


    ''' Temple won't fit: do another hill
    Dim xct As Double, yct As Double
    xct = 300
    yct = -350

    ''' Mesa Hill
    hill 5.67, xct, yct, 130, 180, 15, 15, 12, True
    Box xct, yct, 10, 0, (80 + 5) / 2#, (130 + 5) / 2#, 3
    '' Temple on box
    myTemple xct, yct, 13, 1, 1, 1

    ' Pair of hills on the right, with road left between them:
    
    ''' Bridge
    Do_Simple_Bridge 200, 40, 85, 260, 40
    
    ''' Hill 1
    hill 9.45, 200, 40, 280, 130, 10, 10, 40
    'Boxes going up to this one.
    Dim xdelta, ydelta
    xdelta = 25
    ydelta = 15
    

    Box 200, 40, 0, 0, 30, 20, 42 ', "SlateGray4"
    ColorMeshBox 200 + 1 * xdelta, 40 + 1 * ydelta, 0, 0, 12, 12, 32, "SlateGray4"
    ColorMeshBox 200 + 2 * xdelta, 40 + 2 * ydelta, 0, 0, 12, 12, 22, "SlateGray4"
    ColorMeshBox 200 + 3 * xdelta, 40 + 3 * ydelta, 0, 0, 12, 12, 12, "SlateGray4"
    ColorMeshBox 200 + 4 * xdelta, 40 + 4 * ydelta, 0, 0, 12, 12, 5, "SlateGray4"
    
    
    
    '' Hill 2
    hill 11.1, 85, 260, 180, 270, 10, 12, 60
    'Teleporter platform on this hill
    Box 85, 260, 0, 0, 20, 20, 60
    ColorMeshBox 85, 260, 0, 45, 40, 40, 50, "slategray4"
    
    'new, along bridge line
    ColorMeshBox 85 + 40, 260 + 30, 0, 45, 20, 20, 40, "slategray3"
    Teleporter 85, 260, 60, 0, 0.45, 8, 8, 1, "Hilltop"
   
    'box and teleporter in the center of the fort
    Box -440, 440, 0, 0, 10, 10, 10
    Teleporter -440, 440, 10, 45, 0.45, 8, 8, 1, "CornerFort"
    
    
    Collaborator_Corner
    
    Dim eBoxSize
    eBoxSize = 16
    Box -400 + eBoxSize, -400 + eBoxSize, 25, 0, 14, 14, 5
    Box -400 + eBoxSize, -400 + eBoxSize, 0, 0, 5, 5, 25
    Teleporter -400 + eBoxSize, -400 + eBoxSize, 30, 0, 0.45, 10, 8, 1, "TBox"
   
    make_teleporter_link "Hilltop", 1, "CornerFort", 1
    make_teleporter_link "Hilltop", 2, "TBox", 1
    make_teleporter_link "TBox", 1, "CornerFort", 1
    make_teleporter_link "TBox", 2, "Hilltop", 1
    make_teleporter_link "CornerFort", 1, "Hilltop", 1
    make_teleporter_link "CornerFort", 2, "TBox", 1
   
   
    'Empty area near cornerfort
    Box -350, 200, 0, 45, 40, 30, 12
    Box -350, 200, 12, 45, 20, 15, 17
    Pyramid -350, 200, 29, 45, 3, 3, 20, False, True
    
    'Empty area in upper-right
    Box 350, 350, 0, 45, 60, 60, 12
    Place_Component "Minor Fort", 350, 350, 12, 45
    'Run a highway in towards the hill
    Box 223, 301, 25, 15.5, 114.5, 9, 2
    
    
    
    'Empty area near temple
    Box 420, -400, 0, 45, 25, 25, 15
    Pyramid 420, -400, 15, 45, 15, 15, 40, False, True
    
    'On y=x (x axis) out near the highway end
    'Box 450, 0, 0, 0, 30, 30, 15
    Place_Component "Minigarage", 450, 0, 0, 0, 1#
    'Road to highway end:
    BoxConnect 450, 5, 420, -180, 8, 8, 2
    
    
    'Some pyramids
    Pyramid 300, 200, 0, 50, 10, 10, 30
    Pyramid -300, -200, 0, 50, 10, 10, 30
    Pyramid -100, -100, 0, 50, 10, 10, 30
    Pyramid -300 - 75, 300, 0, 50, 10, 10, 30
    Pyramid -20, 458, 0, 50, 20, 20, 40
    Pyramid -82, 217, 0, 50, 15, 15, 35
    Pyramid 200, -200, 0, 50, 20, 20, 40
    
    'Box in town (make big for now)
    Box -133, -355, 0, 0, 30, 30, 55 '15
    
   ' Box 95, -324, 20, 0, 2, 2, 50
    
    'The springboard
    'JumpBox(x, y, z, theta, dx, dy, dz)
    JumpBox 95, -324, 0, 0, -25, 0, 46
    
    Close_Output_File
    End
End Sub


Sub Do_Simple_Bridge(x1, y1, x2, y2, z)
    Dim xc As Double
    Dim yc As Double
    Dim theta As Double
    Dim dy As Double
    Dim dx As Double
    Dim dLength As Double
    Dim i As Integer
    Dim dHeight As Double
    
    xc = (x2 + x1) / 2#
    yc = (y2 + y1) / 2#
    dy = y2 - y1
    dx = x2 - x1
    theta = my_atan(dy, dx)
    If dx > dy Then
        dLength = dx / 2#
    Else
        dLength = dy / 2#
    End If
    dHeight = 10
    
    'Make up the component:
    Dim NumVerticals As Integer
    Dim xSizePerVertical As Double
    NumVerticals = 6
    xSizePerVertical = 2 * dLength / NumVerticals
    define_component "Bridge"
        Box 0, 0, 0, 0, dLength, dHeight, 2
        For i = -NumVerticals / 2# To NumVerticals / 2#
            Box i * xSizePerVertical, dHeight, 0, 0, 6, 2, 6
            Box i * xSizePerVertical, -dHeight, 0, 0, 6, 2, 6
        Next i
    end_component
    Place_Component "Bridge", xc, yc, z, theta
End Sub


Sub Collaborator_Corner()
    Const HouseWidth = 20
    Const HouseDepth = 15
    Const Baseheight = 12
    Const level1 = Baseheight
    Const level2 = 2 * Baseheight
    Const level3 = 3 * Baseheight
    Const Level4 = 4 * Baseheight

    Dim HouseN As Integer
    Dim shrink As Integer
    
    define_component "Portcullis Gate"
        Dim GlobalWidth, GlobalHeight, iwidth, ilength, numports, pspace, psize
        Dim halfport, p2size, p2height
        
        Const GateHeight = 20
        GlobalWidth = 32 - 9
        GlobalHeight = 20
        shrink = 10
        
        'MinArch   x, y, z, theta, gateheight, gatewidth, thickness, border
        MinArch 0, 0, GlobalHeight, 0, GateHeight, GlobalWidth, 10, 5
        
        'Towers on either side
        Const side_tower_height = 40
        Box GlobalWidth - 2, 0, 0, 0, 10, 5, side_tower_height
        Box -GlobalWidth + 2, 0, 0, 0, 10, 5, side_tower_height
        'Box on top
        Dim tbox_height
        tbox_height = GateHeight + GlobalWidth / 2#
        Box 0, 0, tbox_height, 0, 12, 5, side_tower_height - tbox_height
        
        'Portcullis grating itself
        pspace = 2
        psize = 0.1
        p2height = 1.9
        p2size = psize * 2.7
        numports = GlobalWidth / pspace
        halfports = CInt(numports / 2#)
        For i = -halfports To halfports
            Box i * pspace, 0, GlobalHeight * 1.1 - 2 * pspace, 45, psize, psize, GlobalHeight * 0.7 + 2 * pspace
            Pyramid i * pspace, 0, GlobalHeight * 1.2 - 3.5 * pspace, 45, p2size, p2size, -p2height
        Next i
            
        numports = GlobalHeight / pspace
        halfports = CInt(numports / 2#)
        For i = 0 To numports - 2
            Box 0, 0, GlobalHeight + i * pspace, 0, GlobalWidth / 2#, psize, psize
        Next i
        
        'Shooting platform
        iwidth = 10
        ilength = 8
        Box 0, -iwidth, 24, 0, ilength, iwidth, psize
        
        'Box towers near gate
        
        Box 40, -20, 0, 45 + 90, 18, 6 + 0.5, 20
        Box -40, -20, 0, 45, 18, 6 + 0.5, 20
          
        'Fill in box
         ''new into gate
        'Double Pyramid-topped platforms
        Const xP = -55
        Const yP = -40
        Box xP, yP, 13, 0, 15, 15, 2
        Pyramid xP, yP, 15, 0, 15, 15, 72 - 15, False, True
        Pyramid xP, yP, 0, 0, 20, 20, 40, False, True
        
        Box -xP, yP, 13, 0, 15, 15, 2
        Pyramid -xP, yP, 15, 0, 15, 15, 72 - 15, False, True
        Pyramid -xP, yP, 0, 0, 20, 20, 40, False, True
        
    end_component
    Place_Component "Portcullis Gate", -420, 420, 0, 45 + 180
    
    
        
    define_component "BigMadCity Tower"
        Const mt_W = 6 * 12     'Base width
        Const mt_Z = 15         'Floor heights
        Dim fullsize, dx, dy, dsizeX, dsizeY
        Dim twidth
        
        'Tower Base
        Box 0, 0, 0, 0, mt_W - 4, mt_W - 4, mt_Z
        
        'Hollow this layer (1)
        twidth = mt_W - 12
        
        fullsize = mt_W - (1 * 12)
        hallsize = 12
        dsizeX = (fullsize - hallsize) / 2
        dsizeY = dsizeX
        dx = dsizeX + (hallsize / 2#)
        dy = dsizeX + (hallsize / 2#)
        Box 0 + dx, 0 + dy, mt_Z, 0, dsizeX, dsizeX, 15
        Box 0 + dx, 0 - dy, mt_Z, 0, dsizeX, dsizeX, 15
        Box 0 - dx, 0 + dy, mt_Z, 0, dsizeX, dsizeX, 15
        Box 0 - dx, 0 - dy, mt_Z, 0, dsizeX, dsizeX, 15
        
        'Roof this
        Dim rsize
        rsize = 12
        Box 0, 0, mt_Z + 13, 0, dx + dsizeX, dy + dsizeX, 2
        
        'Make this triple tunneled
        i = 2
        'Box 0, 0, i * mt_Z, 0, mt_W - (i * 12), mt_W - (i * 14), mt_Z
        twidth = mt_W - 12
        
        fullsize = mt_W - (i * 12) - 9
        hallsize = 18 + 4
        dsizeX = (fullsize - hallsize) / 2
        dsizeY = dsizeX
        dx = dsizeX + hallsize '(hallsize / 2#)
        dy = dsizeX + hallsize '(hallsize / 2#)
        Box 0 + dx, 0 + dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        Box 0 + dx, 0 - dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        Box 0 - dx, 0 + dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        Box 0 - dx, 0 - dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        
        Box -dx, 0, i * mt_Z, 0, dsizeX, dsizeX, 15
        Box dx, 0, i * mt_Z, 0, dsizeX, dsizeX, 15
        Box 0, dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        Box 0, -dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        
        
        'Roof this
        rsize = 12
        Box 0, 0, i * mt_Z + 13, 0, dx + dsizeX, dy + dsizeY, 2
        
        
        i = 3
        
        '            Box 0, 0, i * mt_Z, 0, mt_W - (i * 12), mt_W - (i * 14), mt_Z
        'Instead, do a hollow floor again!
            'Hollow this layer (1)
        twidth = mt_W - 12
        
        fullsize = mt_W - (i * 12)
        hallsize = 18
        dsizeX = (fullsize - hallsize) / 2
        dsizeY = dsizeX
        dx = dsizeX + (hallsize / 2#)
        dy = dsizeX + (hallsize / 2#)
        Box 0 + dx, 0 + dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        Box 0 + dx, 0 - dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        Box 0 - dx, 0 + dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        Box 0 - dx, 0 - dy, i * mt_Z, 0, dsizeX, dsizeX, 15
        
        'Roof this
        rsize = 12
        Box 0, 0, i * mt_Z + 13, 0, dx + dsizeX, dy + dsizeY, 2
        
        i = 4
        Box 0, 0, i * mt_Z, 0, mt_W - (i * 14), mt_W - (i * 14), mt_Z
        
        'Top pyramid
        Pyramid 0, 0, 5 * mt_Z, 0, 16, 16, 20, True, True, False
        
        
        
    end_component
    Place_Component "BigMadCity Tower", -200, -200, 0, 0
    
    'roadway linkup
    Box -70, -200, 13, 0, 70, 4, 2
    
    'tower, roadway
    Box -195, -79, 0, 0, 15, 17, 45 'big box
    Box -195, -140, 43, 0, 6, 60, 2 'roadway
    
    Box -195 + 5, -125, 43, 0, 1, 33, 6 'wall1
    Box -195 - 5, -125, 43, 0, 1, 33, 6 'wall2
    
    Pyramid -200 - 2, -92.5, 45, 0, 3, 3, 20 'pyramids gate1
    Pyramid -190 + 2, -92.5, 45, 0, 3, 3, 20
    
    Pyramid -200 - 2, -125 - 32.5, 45, 0, 3, 3, 20 'pyramids gate2
    Pyramid -190 + 2, -125 - 32.5, 45, 0, 3, 3, 20
    'support
    Box -85, -200, 0, 0, 2, 2, 13
    Pyramid -85, -200, -3 + 6, 0, 4, 4, -10, False, False, False
    
    'destination (north west block)
    Box -325, -77, 0, 0, 25, 25, 30
    Box -325 - 7, -77 + 7, 30, 0, 12, 12, 15
    Box -325 - 7 - 14, -77 + 7 + 14, 0, 0, 16, 16, 15
    
    'roadway
    Box -280, -120, 28, 45 + 90, 42, 6, 2
    Box -280 + 4 + 2, -120 + 4 - 2, 28, 45 + 90, 40, 1, 6
    Box -280 - 4 + 2, -120 - 4 - 2, 28, 45 + 90, 40, 1, 6
    
    Pyramid -304.5 + 2, -89.5 + 2, 30, 135, 3, 3, 20
    Pyramid -310.5 - 2, -96 - 2, 30, 135, 3, 3, 20
    
    Pyramid -247 + 2, -147 + 2, 30, 135, 3, 3, 20
    Box -247 + 2, -147 + 2, 15, 135, 3, 3, 30 - 15
    Pyramid -253.5 - 2, -153 - 2, 30, 135, 3, 3, 20
    Box -253.5 - 2, -153 - 2, 15, 135, 3, 3, 30 - 15
    

    ''' Internal pyramids (just inside gate)
    Pyramid -137, -90, 0, 0, 10, 10, 20
    Pyramid -90, -137, 0, 0, 10, 10, 20
    Box -156, -60, 0, 0, 15, 10, 15
    Box -156, -55, 15, 0, 8, 8, 15
    
    'Intermediate structure
    'Box -325, -200, 40, 0, 20, 30, 2
    Box -325, -200, 0, 0, 20, 30, 15
    Box -325, -200, 15, 0, 10, 15, 15
    Pyramid -325 - 20, -200 - 30, 0, 0, 4, 4, 50
    Pyramid -325 - 20, -200 + 30, 0, 0, 4, 4, 50
    Pyramid -325 + 20, -200 - 30, 0, 0, 4, 4, 50
    Pyramid -325 + 20, -200 + 30, 0, 0, 4, 4, 50
    
    Pyramid -325 - 10, -200 - 15, 15, 0, 4, 4, 50
    Pyramid -325 - 10, -200 + 15, 15, 0, 4, 4, 50
    Pyramid -325 + 10, -200 - 15, 15, 0, 4, 4, 50
    Pyramid -325 + 10, -200 + 15, 15, 0, 4, 4, 50
    Box -283, -199, 13, -90, 5, 30, 2
    

    Rnd (-10)
    Randomize 10
    Rnd (32)
'    collaborator_build_town -130, -335 - 7
    'straight_wall x1, y1, x2, y2, startz, width, Height, numtowers, crenelbool, crenopenwidth, crenclosedwidth, crensize


    'straight_wall x1, y1, x2, y2, startz, width, Height, numtowers, crenelation, cremopen, crenclosedwidth, crendside
    straight_wall -50, -250, -50, -360, 0, 2, 20, 2, True, 3, 1, 0, 0
    decaying_wall -50, -250, -50, -150, 0, 2, 20
    
    'tower y, x, startz, theta, width, height
    tower -50, -390, 0, 0, 8, 26, True
    Box -50, -360 - 15, 17, 0, 3, 15, 5
    
    'Other piece of wall, out to -500, from tower at -390
    decaying_wall -50, -390, -50, -450, 0, 2, 20
    decaying_wall -50, -500, -50, -450, 0, 2, 20
    
    'my garage link thing
    Box -252, -345, 12, 0, 30, 30, 2
    Box -252, -345, 24, 0, 20, 20, 2
    Box -252, -345, 36, 0, 10, 10, 2
    'Corner supports
    Box -252 - 30, -345 - 30, 0, 0, 4, 4, 16
    Box -252 - 30, -345 + 30, 0, 0, 4, 4, 16
    Box -252 + 30, -345 - 30, 0, 0, 4, 4, 16
    Box -252 + 30, -345 + 30, 0, 0, 4, 4, 16
    
    Box -252 - 20, -345 - 20, 12, 0, 4, 4, 16
    Box -252 - 20, -345 + 20, 12, 0, 4, 4, 16
    Box -252 + 20, -345 - 20, 12, 0, 4, 4, 16
    Box -252 + 20, -345 + 20, 12, 0, 4, 4, 16
   
    Box -252 - 10, -345 - 10, 24, 0, 4, 4, 16
    Box -252 - 10, -345 + 10, 24, 0, 4, 4, 16
    Box -252 + 10, -345 - 10, 24, 0, 4, 4, 16
    Box -252 + 10, -345 + 10, 24, 0, 4, 4, 16
'    Pyramid -242, -366, 0, 45, 4, 4, 65
'    Box -242, -366, 55, 45, 2, 2, 4
   
    Box -235, -290, 12, 0, 5, 30, 2
    
    Box -138, -267.5, 58, -139, 4, 60, 2
    Box -83, -327, 58, 0, 20, 20, 2
    Pyramid -346, -286, 0, 0, 10, 10, 20
    Pyramid -368, -126, 0, 0, 10, 10, 20
End Sub

