Attribute VB_Name = "Script_ValleyMap"
Type Point
    x As Double
    y As Double
End Type

Const ContourHeight = 14
Const ctx = 180
Const cty = 0

Const WaterHeight = 0.5


Sub Write_Valley_Header()
    comment "  VALLEY OF THE DAMMED"
    comment "   "
    comment "     September 26, 2003"
    comment "   "
    comment "     by "
    comment "   "
    comment "       Bryan A. Bentz"
    comment "       a.k.a. ""The Purple Panzer"""
    comment "       Email:"
    comment "            bentz@bentz-engineering.com, or "
    comment "            bentz@ai.mit.edu"
    comment "       URLs:"
    comment "            Personal URL: http://www-swiss.ai.mit.edu/~bentz/"
    comment "            Business URL: http://www.bentz-engineering.com/"
    comment "   "
    comment "   "
End Sub

Sub Write_Valley_Mapfile()
    Const tFront = 1
    Const tBack = 2
    Rnd (-1)
    Randomize
    
    '' Grab the components library
    Install_Components_Library
    
    '' Try to open the output file; exit if error.
    If Not Open_Output_File("Valley") Then
        Exit Sub
    End If
    
    Write_Valley_Header
    
   '' Valley tower
   Box 120, -90, 2 * ContourHeight, 30, 10, 10, 7 * ContourHeight, "Tower"
   straight_wall 120, -90, 163, 31, 9 * ContourHeight - 5, 4, 5, 0, False, 0, 0, 0
   Teleporter 120 - 2.5, -90 - 2, 28 + 98, 110, 0.45, 5, 6, default_bsize, "Tower"
    
    ''Dam
    draw_dam
    Const dwidth = 55
    'Const theta2 = 90 + (90 - 60)
    straight_wall -126.52 - dwidth, 180.16, -200 - dwidth, 400, 0, dwidth, _
        150, 0, False, 0, 0, 0
   
    'inner box
    Box 253, 84, 0, 0, 80, 120, ContourHeight
    Box 251, 44, ContourHeight, 45, 35, 50, ContourHeight
    Box 251, 44, 2 * ContourHeight, 70, 20, 30, ContourHeight
    Box ctx, cty, 0, 40, 10, 15, 3 * ContourHeight
    
    ''Right-side hill: spawn prevention
    Dim i
    Dim j
    Const minX = 253 - 80
    Const maxX = 253 + 80
    Const minY = 84 - 120
    Const maxY = 84 + 120
    Const Xoffset = 20
    Dim inBlock As Boolean
'    For i = 115 To 400 - 18 Step 35 * 2 'x
'        For j = -80 To 400 - 8 Step 35 * 2 'y
    
''    For i = 400 - (18 + Xoffset) To 110 Step -(35 * 2)
''        For j = 400 - (18 + Xoffset) To -90 Step -(35 * 2)
'''            If ((i < minX) Or (i > maxX)) Or ((j < minY) Or (j > maxY)) Then
''            'bad
''            inBlock = (i > minX) And (i < maxX) And (j > minY) And (j < maxY)
''            If (Not inBlock) Then
''                Pyramid i, j, 0, 360 * Rnd(), 18, 18, 18, "Anti-spawn pyramids."
''            End If
''        Next j
''    Next i
''
    ''Terrain.
    Call contour1
    Call contour2
    Call contour3
    Call contour4
    Call contour5
    Call contour6
    Call contour7
    Call contour8
    Call contour9
    Call contour10
    Call contour11
    
    openbox 250, 230, ContourHeight * 11, 10, 10, 100, 100, ContourHeight
    'Fill in
    Box 265, 110, ContourHeight * 11, 0, 71, 24, ContourHeight
    Box 134, 222, ContourHeight * 11, 0, 17, 57, ContourHeight

    'Construct building around hole
    Box 250, 230, ContourHeight * 13, 0, 12, 12, 5
    Teleporter 250, 230, ContourHeight * 13 + 5, 45, 8, 8, 12, default_bsize, "Top Right Hill"
    
    
    'cave Teleporter
    Teleporter 332, 332, 0, 45, 0.45, 8, 12, default_bsize, "In Cave"
    
    'corners
    Const offset = 8
    Const colsize = 2
    Box 250 + offset, 230 + offset, ContourHeight * 12, 0, colsize, colsize, ContourHeight
    Box 250 - offset, 230 - offset, ContourHeight * 12, 0, colsize, colsize, ContourHeight
    Box 250 + offset, 230 - offset, ContourHeight * 12, 0, colsize, colsize, ContourHeight
    Box 250 - offset, 230 + offset, ContourHeight * 12, 0, colsize, colsize, ContourHeight
    
    ''Town on top
    'BuildTown x, y, z, Theta, Xsize, Ysize, Seed, MaxNumberObjects
    BuildTown 250, 230, ContourHeight * 12, 0, 80, 80, -2006, 20
    
    'Lower-right town
    BuildTown 320, -320, 0, 45, 50, 70, -5007, 25
    'Teleporter x, y, z, Theta, sX, sY, sZ, bsize, Name
    Teleporter 320, -320, 0, 135, 0.45, 12, 20, default_bsize, "Lower town teleporter"
    
    ''Valley water
    'Pyramid x, y, z, Theta, sX, sY, sZ, Name
    Pyramid -50, 100, WaterHeight, 0, 83.5, 177, 1, True, True, False, "River in chasm (base)"
    Pyramid -50, 100, 4, 0, 83.5, 177, 1, True, True, False, "River in chasm (surface)"
    Pyramid -46.5, -134, WaterHeight, -26, 60, 100, 1, True, True, False, "River south #1"
    Pyramid -59, -296, WaterHeight, 200.5, 40, 120, 1, True, True, False, "River south #2"
    
    'Walls around river
    Box 7, -164, 0, 63, 80, 10, 12
    Box -117, -143, 0, 63, 56, 10, 12
    Box -104, -294, 0, 113 - 2, 115, 10, 12
    Box -5 + 6, -317, 0, 113 - 2, 92, 10, 12
    
 
    'Lower bridge
    Box -45, -328, 12, 22, 44, 8.5, 5
    Teleporter -45, -328, 0, 22 + 90, 0.45, 44, 13, default_bsize, "Bridge"

    '' Hill on left
    Dim sx1, sx2, sy1, sy2, sdx, sdy, sx3, sy3
    sx1 = -126.52 - dwidth
    sy1 = 180.16
    sx2 = -200 - dwidth
    sy2 = 400
    sdx = sx2 - sx1
    sdy = sy2 - sy1
    sx3 = sx1 - sdx * 0.2
    sy3 = sy1 - sdy * 0.2
    
    straight_wall sx1 - 10, sy1 + 10, sx3 - 0, sy3, 0, dwidth, _
        160, 0, False, 0, 0, 0
   
   Box -109, 144, 0, 0, 20, 30, 60
   
   Teleporter -240, 350, 150, 90, 0.45, 10, 10, default_bsize, "Left over dam"
   'wall heading south
   straight_wall -109, 144, -109, -100, 0, 30, 28, 0, False, 0, 0, 0
   
   Box -201, 236, 150, 109.5, 67, 25, 18
    
    'Boxes out to edge
    Const bWidth = 15
    Box -350, 0, 0, 360 * Rnd(), bWidth, bWidth, 17
    Box -300, 0, 0, 360 * Rnd(), bWidth, bWidth, 17 * 2
    Box -250, 0, 0, 360 * Rnd(), bWidth, bWidth, 17 * 3
    Box -200, 0, 0, 360 * Rnd(), bWidth, bWidth, 17 * 4
    Box -150, 0, 20, 360 * Rnd(), bWidth, bWidth, 17 * 5 - 20
    
    ''Two big towers
    Box -150, 50, 0, 45, 25, 25, 150
    Box -150, -50, 0, 45, 25, 25, 150
    'Teleporter on south tower
    Teleporter -150, -50, 150, 135, 0.45, 10, 8, default_bsize, "South Tower"
    
    ' (join these by a ramp)
    Box -150, 0, 150 - 5, 0, 8, 50, 5
    
    ''Lower boxes, at coincident heights
    Const NumLBoxes = 10
    Dim lheight, lX, lY, lSize, yrange, ystart
    ystart = -100
    yrange = 200
    'Randomize
    lX = -109 - 5 + Rnd(-8000) 'Width of tank to drive by.
    For i = 1 To 12 - 3
        lheight = 3 + i * ContourHeight
        lY = yrange * Rnd() + ystart
        lSize = 10 + 15 * Rnd()
        Box lX, lY, 0, 360 * Rnd(), lSize, lSize, lheight
    Next i
    
    ''Pyramids in lower-left
    Scattered_Pyramids -350, -350, 20, 150, 150
    Scattered_Pyramids -375, -375, 10, 100, 100
    
    ''Pyramids in upper-left
    Scattered_Pyramids -380, 200, 30, 100, 100
    Teleporter -385, -385, 0, 45, 0.45, 6, 8, default_bsize, "Southwest Corner"
    Teleporter -385, 385, 0, 135, 0.45, 6, 8, default_bsize, "Northwest Corner"
    
    ''Teleporter links
    make_teleporter_link "Northwest Corner", tBack, "Southwest Corner", tFront
    make_teleporter_link "Northwest Corner", tFront, "Northwest Corner", tBack
    
    make_teleporter_link "Southwest Corner", tFront, "Northwest Corner", tBack
    make_teleporter_link "Southwest Corner", tBack, "Southwest Corner", tFront
    
    make_teleporter_link "Lower town teleporter", tBack, "Top Right Hill", tBack
    make_teleporter_link "Lower town teleporter", tFront, "South Tower", tBack
    
    make_teleporter_link "Tower", tFront, "Tower", tBack
    make_teleporter_link "Tower", tBack, "Top Right Hill", tFront
    
    make_teleporter_link "In Cave", tFront, "South Tower", tFront
    make_teleporter_link "In Cave", tBack, "Left over dam", tBack
    
    make_teleporter_link "Top Right Hill", tFront, "Lower town teleporter", tBack
    make_teleporter_link "Top Right Hill", tBack, "Southwest Corner", tBack
    
    make_teleporter_link "Bridge", tBack, "Left over dam", tFront
    make_teleporter_link "Bridge", tFront, "In Cave", tBack
    
    make_teleporter_link "South Tower", tFront, "Bridge", tBack
    make_teleporter_link "South Tower", tBack, "Northwest Corner", tBack
    
    make_teleporter_link "Left over dam", tBack, "In Cave", tBack
    make_teleporter_link "Left over dam", tFront, "Southwest Corner", tFront
    
    Close_Output_File

End Sub

Sub draw_dam()
    Dim nlayers, zc
    Const dlayer = 18
    Const total_height = 100
    Dim i As Integer
    Dim theight
    Const xc = -50
    Const yc = 125 - 100
    Const radiusDelta = 8
    Const radius = 125 - radiusDelta 'because i astarts at 1
    Const dwidth = 8
    Const theta1 = 60
    Const theta2 = 90 + (90 - theta1)
    nlayers = CInt(total_height / dlayer) + 1
    For i = 1 To nlayers
        zc = i * dlayer
        circular_wall xc, yc, zc, radius + i * radiusDelta, _
            theta1, theta2, dlayer, dwidth, 8, 0, False, 0, 0, 0
        theight = zc
    Next i
    
    'Base
    'Box x, y, Z, Theta, sX, sY, sZ, "Name"
    Box -90.18, 143.37, 0, (theta2 + theta1) / 2#, 35, 5, 18
    Box -41.82, 149.73, 0, (theta2 + theta1) / 2#, 35, 5, 18
    Box 5.29, 137.11, 0, (theta2 + theta1) / 2#, 35, 5, 18
    
    
    ''Towers
    Const tsize = 8
    Const tvert = 30
    'Box x, y, Z, Theta, sX, sY, sZ
    Box -82.19, 186.83, 126, 101.25, tsize, tsize, tvert, "Dam Tower 1"
    Box 2.04, 181.24, 126, 71.25, tsize, tsize, tvert, "Dam Tower 2"
    
    ''side walls
    Const twidth = 10
    'Rightside
    straight_wall 46.11, 168.84, 100#, 400#, 0, twidth, theight, 0, False, 0, 0, 0
    'Leftside
    straight_wall -126.52, 180.16, -200, 400, 0, twidth, theight, 0, False, 0, 0, 0
    
    'Fillets
'    Box 32.78, 148.89, 0, 56.25, 30, 10, theight 'Right
'    Box -115.9, 158.63, 0, 116.25, 30, 10, theight 'Left

    'Floating Island
    Box xc, 280, 118, 0, 15, 15, 15, "Island Platform"
    
    'Water; height = 120
    Const WHeight = 120
    
    'Flat surfaces
    Pyramid xc, 290, WHeight, (theta2 + theta1) / 2#, 105, 150, 1, True, True, False, "Water!"
    For i = 0 To nlayers - 1 Step 2
        zc = i * dlayer + WaterHeight
        Pyramid xc, 290, zc, (theta2 + theta1) / 2#, 105, 150, 1, True, True, False, "Water!"
    Next i

    'At constant X (for different X values)
    For i = 0 To 4
        Pyramid xc - 50 + i * (100 / 3), 290, 1, 0, 1, 100, WHeight - 1, True, True, False
        Pyramid xc - 50 + i * (100 / 3), 290, 0, 0, 1, 100, WHeight - 1, True, True, True 'invert
    Next i
    'At constant Y (for different Y values)
    For i = 0 To 4
        Pyramid xc, 290 - 50 + i * (100 / 3), 1, 0, 200, 1, WHeight - 1, True, True, False
        Pyramid xc, 290 - 50 + i * (100 / 3), 0, 0, 200, 1, WHeight - 1, True, True, True 'invert
    Next i
    
    'Sides
    Const xa = 50 + 10
    Const ya = 300 - 10
    Const xb = -140
    Const yb = 300 - 10
    Const ws = 110
    Pyramid xa, ya, 1, theta1 + 18, ws, 1, WHeight - 1, True, True, False
    Pyramid xa, ya, 0, theta1 + 18, ws, 1, WHeight - 1, True, True, True 'invert
    
    Pyramid xb, yb, 1, theta2 - 15, ws, 1, WHeight - 1, True, True, False
    Pyramid xb, yb, 0, theta2 - 15, ws, 1, WHeight - 1, True, True, True 'invert

    'Edges of inside cave
    
    Box 250, 395, 0, 0, 150, 5, 154
    Box 395, 200, 0, 0, 5, 200, 154
    
End Sub

Sub contour1()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    'Contour(1) = New Point
    Contour(1).x = 80
    Contour(1).y = 400
    
    Contour(2).x = 70 '60
    Contour(2).y = 300
    
    Contour(3).x = 80 '50
    Contour(3).y = 250
    
    Contour(4).x = 40 '20
    Contour(4).y = 200
    
    Contour(5).x = 20 ''-60
    Contour(5).y = 150
    
    Contour(6).x = 20 '0
    Contour(6).y = 100
    
    Contour(7).x = 20 '-40
    Contour(7).y = 50
    
    Contour(8).x = -5
    Contour(8).y = 0
    
    Contour(9).x = 0.25
    Contour(9).y = -10
    
    Contour(10).x = 45
    Contour(10).y = -100
    
    Contour(11).x = 60
    Contour(11).y = -150
    
    Contour(12).x = 100
    Contour(12).y = -200
    
    Contour(13).x = 120
    Contour(13).y = -250
    
    Contour(14).x = 150
    Contour(14).y = -275
    
    Contour(15).x = 200
    Contour(15).y = -250
    
    
    Contour(16).x = 250
    Contour(16).y = -200
    
    Contour(ExtraPt).x = 270
    Contour(ExtraPt).y = -180
    
    Contour(17).x = 300
    Contour(17).y = -168
    
    Contour(18).x = 350
    Contour(18).y = -150
    
    Contour(19).x = 400
    Contour(19).y = -158
    
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 18
        If i = 16 Then
            'Draw top piece as normal
         corner_straight_wall Contour(i).x, _
             Contour(i).y, _
             Contour(i + 1).x, _
             Contour(i + 1).y, _
             0.75 * height, width, 0.25 * height, 1
            StartPt = ExtraPt
        Else
            StartPt = i
        End If
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             0, width, height, 1
        
    Next i
End Sub

Sub contour2()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    'Contour(1) = New Point
    Contour(1).x = 40
    Contour(1).y = 163
    
    Contour(2).x = 20 '60
    Contour(2).y = 100
    
    Contour(3).x = 30 '50
    Contour(3).y = 0
    
    Contour(4).x = 40 '20
    Contour(4).y = -75
    '''
    Contour(5).x = 80 ''-60
    Contour(5).y = -140
    
    Contour(6).x = 120 '0
    Contour(6).y = -170
    
    Contour(7).x = 130 '-40
    Contour(7).y = -200
    
    Contour(8).x = 140
    Contour(8).y = -220
    
    Contour(9).x = 270
    Contour(9).y = -160
    
    Contour(10).x = 400
    Contour(10).y = -129
    
    Contour(ExtraPt).x = 270
    Contour(ExtraPt).y = -180
    
    
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 9
'        If i = 16 Then
'            StartPt = ExtraPt
'        Else
            StartPt = i
'        End If
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height, width, height, 1
        
    Next i
End Sub

Sub contour3()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    'Contour(1) = New Point
    Contour(1).x = 10 '23
    Contour(1).y = 163
    
    Contour(2).x = 30 '60
    Contour(2).y = 100
    
    Contour(3).x = 40 '50
    Contour(3).y = 0
    
    Contour(4).x = 80 '20
    Contour(4).y = -75
    '''
    Contour(5).x = 130 ''-60
    Contour(5).y = -140
    
    Contour(6).x = 140 '0
    Contour(6).y = -150
    
    Contour(7).x = 140 '-40
    Contour(7).y = -160
    
    Contour(8).x = 180
    Contour(8).y = -155
    
    Contour(9).x = 200
    Contour(9).y = -140
    
    Contour(10).x = 400
    Contour(10).y = -100
    
    Contour(ExtraPt).x = 270
    Contour(ExtraPt).y = -180
    
    
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 9
'        If i = 16 Then
'            StartPt = ExtraPt
'        Else
            StartPt = i
'        End If
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height * 2, width, height, 1
        
    Next i
End Sub


Sub contour4()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    'Contour(1) = New Point
    Contour(1).x = 23
    Contour(1).y = 163
    
    Contour(2).x = 30 '60
    Contour(2).y = 100
    
    Contour(3).x = 60 '50
    Contour(3).y = 0
    
    Contour(ExtraPt).x = 80
    Contour(ExtraPt).y = -40
    
    Contour(4).x = 120 '20
    Contour(4).y = -75
    '''
    Contour(5).x = 140 ''-60
    Contour(5).y = -100
    
    Contour(6).x = 180 '0
    Contour(6).y = -115
    
    Contour(7).x = 200 '-40
    Contour(7).y = -130
    
    Contour(8).x = 250
    Contour(8).y = -105
    
    Contour(9).x = 300
    Contour(9).y = -80
    
    Contour(10).x = 400
    Contour(10).y = -60
    
    
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 9
        If i = 3 Then
            'Draw top piece as normal, but high
         corner_straight_wall Contour(i).x, _
             Contour(i).y, _
             Contour(i + 1).x, _
             Contour(i + 1).y, _
             3.75 * height, width, 0.25 * height, 1
            StartPt = ExtraPt
        Else
            StartPt = i
        End If
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height * 3, width, height, 1
        
    Next i
    ''Do inner ramp
    Dim x1, y1
    x1 = Contour(ExtraPt).x
    y1 = Contour(ExtraPt).y + 5
    
    straight_wall x1, x2, ctx, cty, _
        height * 3 - 5, 6, 5, 0, False, 0, 0, 0
        
End Sub


Sub contour5()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    Contour(1).x = 100
    Contour(1).y = 400
    
    Contour(2).x = 75
    Contour(2).y = 300
    
    Contour(3).x = 20
    Contour(3).y = 153
    
    Contour(4).x = 45 '60
    Contour(4).y = 90
    
    Contour(5).x = 80 '50
    Contour(5).y = 10
    
    Contour(6).x = 130 '20
    Contour(6).y = -65
    '''
    Contour(7).x = 145 ''-60
    Contour(7).y = -80
    
    Contour(8).x = 180 '0
    Contour(8).y = -85
    
    Contour(9).x = 200 '-40
    Contour(9).y = -80
    
    Contour(10).x = 250
    Contour(10).y = -75
    
    Contour(11).x = 300
    Contour(11).y = -70
    
    Contour(12).x = 400
    Contour(12).y = -30
    
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 11
         StartPt = i
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height * 4, width, height, 1
        
    Next i
End Sub

Sub contour6()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    Contour(1).x = 100
    Contour(1).y = 400
    
    Contour(2).x = 75
    Contour(2).y = 300
    
    Contour(3).x = 40
    Contour(3).y = 153
    
    Contour(4).x = 65 '60
    Contour(4).y = 95
    
    Contour(5).x = 90 '50
    Contour(5).y = 15
    
    Contour(6).x = 150 '20
    Contour(6).y = -40
    '''
    Contour(7).x = 165 ''-60
    Contour(7).y = -75
    
    Contour(8).x = 200 '0
    Contour(8).y = -70
    
    Contour(9).x = 220 '-40
    Contour(9).y = -65
    
    Contour(10).x = 270
    Contour(10).y = -40
    
    Contour(11).x = 400
    Contour(11).y = -25
    
    
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 3 To 10
         StartPt = i
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height * 5, width, height, 1
        
    Next i
End Sub


Sub contour7()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    Contour(1).x = 100
    Contour(1).y = 400
    
    Contour(2).x = 75
    Contour(2).y = 300
    
    Contour(ExtraPt).x = 95
    Contour(ExtraPt).y = 280
    
    Contour(3).x = 45
    Contour(3).y = 153
    
    Contour(4).x = 75 '60
    Contour(4).y = 100
    
    Contour(5).x = 98 '50
    Contour(5).y = 20
    
    Contour(6).x = 160 '20
    Contour(6).y = -20
    '''
    Contour(7).x = 175 ''-60
    Contour(7).y = -55
    
    Contour(8).x = 230 '0
    Contour(8).y = -50
    
    Contour(9).x = 300 '-40
    Contour(9).y = -20
    
    Contour(10).x = 350
    Contour(10).y = 0
    
    Contour(11).x = 400
    Contour(11).y = -20
    
   
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 10
        If i = 2 Then
            'Draw top piece as normal
         corner_straight_wall Contour(i).x, _
             Contour(i).y, _
             Contour(i + 1).x, _
             Contour(i + 1).y, _
             0.75 * height, width, 0.25 * height, 1
            StartPt = ExtraPt
        Else
            StartPt = i
        End If
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height * 6, width, height, 1
        
    Next i
    teleporter_platform ctx + 100, cty + 100, height * 6, 0, "Contour7"
    
End Sub


Sub contour8()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    Contour(1).x = 110
    Contour(1).y = 400
    
    Contour(2).x = 45
    Contour(2).y = 300
    
    Contour(3).x = 50
    Contour(3).y = 145
    
    Contour(ExtraPt).x = 90
    Contour(ExtraPt).y = 115
    
    Contour(4).x = 100 '60
    Contour(4).y = 80
    
    Contour(5).x = 118 '50
    Contour(5).y = 30
    
    Contour(6).x = 180 '20
    Contour(6).y = -10
    '''
    Contour(7).x = 220 ''-60
    Contour(7).y = -30   'annoying
    
    Contour(8).x = 250 '0
    Contour(8).y = -15
    
    Contour(9).x = 320 '-40
    Contour(9).y = 20
    
    Contour(10).x = 400
    Contour(10).y = 10
    
   
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 9
        If i = 3 Then
            'Draw top piece as normal
         corner_straight_wall Contour(i).x, _
             Contour(i).y, _
             Contour(i + 1).x, _
             Contour(i + 1).y, _
             7.75 * height, width, 0.25 * height, 1
            StartPt = ExtraPt
        Else
            StartPt = i
        End If
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height * 7, width, height, 1
        
    Next i
     ''Do inner ramp
     
    Dim x1, y1
    x1 = Contour(ExtraPt).x
    y1 = Contour(ExtraPt).y + 5
    
    straight_wall 82, 135 - 20, 300, 300, _
        height * 7 - 5, 10, 5, 0, False, 0, 0, 0
    Box 300, 300, height * 7 - 5, 40, 20, 20, 5
    Pyramid 294, 294, height * 7, 0, 7, 7, 7
    
   
    
End Sub


Sub contour9()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    Contour(1).x = 110
    Contour(1).y = 400
    
    Contour(2).x = 75
    Contour(2).y = 300
    
    Contour(3).x = 55
    Contour(3).y = 155
    
    Contour(ExtraPt).x = 90
    Contour(ExtraPt).y = 115
    
    Contour(4).x = 110 '60
    Contour(4).y = 100
    
    Contour(5).x = 130 '50
    Contour(5).y = 50
    
    Contour(6).x = 210 '20
    Contour(6).y = 0
    '''
    Contour(7).x = 250 ''-60
    Contour(7).y = 0   'annoying
    
    Contour(8).x = 300 '0
    Contour(8).y = 20
    
    Contour(9).x = 400 '-40
    Contour(9).y = 40
    
    Contour(10).x = 400
    Contour(10).y = 10
    
   
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 8
'        If i = 3 Then
'            'Draw top piece as normal
'         corner_straight_wall Contour(i).x, _
'             Contour(i).y, _
'             Contour(i + 1).x, _
'             Contour(i + 1).y, _
'             7.75 * height, width, 0.25 * height, 1
'            StartPt = ExtraPt
'        Else
            StartPt = i
'        End If
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height * 8, width, height, 1
        
    Next i
End Sub


Sub contour10()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    
    
    Contour(1).x = 120
    Contour(1).y = 400
    
    Contour(2).x = 90
    Contour(2).y = 320
    
    Contour(3).x = 60
    Contour(3).y = 175
    
    Contour(ExtraPt).x = 95
    Contour(ExtraPt).y = 115
    
    Contour(4).x = 120 '60
    Contour(4).y = 110
    
    Contour(5).x = 140 '50
    Contour(5).y = 70
    
    Contour(6).x = 240 '20
    Contour(6).y = 10
    '''
    Contour(7).x = 270 ''-60
    Contour(7).y = 20   'annoying
    
    Contour(8).x = 330 '0
    Contour(8).y = 40
    
    Contour(9).x = 400 '-40
    Contour(9).y = 70
    
   
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 8
'        If i = 3 Then
'            'Draw top piece as normal
'         corner_straight_wall Contour(i).x, _
'             Contour(i).y, _
'             Contour(i + 1).x, _
'             Contour(i + 1).y, _
'             7.75 * height, width, 0.25 * height, 1
'            StartPt = ExtraPt
'        Else
            StartPt = i
'        End If
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height * 9, width, height, 1
        
    Next i

    straight_wall Contour(1).x, Contour(1).y - 20, 400, 400 - 20, height * 9, _
    20, height, 0, False, 0, 0, 0
    
    straight_wall Contour(9).x - 20, Contour(9).y, 400 - 20, 400, height * 9, 20, height, 0, False, 0, 0, 0
    
End Sub

Sub contour11()
    Dim i As Integer
    Dim j As Integer
    Dim height As Integer
    Dim width As Integer
    Dim Contour(20) As Point
    Const delta = 2
    Const ExtraPt = 20
    
    Contour(1).x = 140
    Contour(1).y = 370
    
    Contour(2).x = 120
    Contour(2).y = 330
    
    Contour(3).x = 80
    Contour(3).y = 200
    
    Contour(ExtraPt).x = 95
    Contour(ExtraPt).y = 115
    
    Contour(4).x = 140 '60
    Contour(4).y = 120
    
    Contour(5).x = 160 '50
    Contour(5).y = 90
    
    Contour(6).x = 260 '20
    Contour(6).y = 30
    '''
    Contour(7).x = 300 ''-60
    Contour(7).y = 50   'annoying
    
    Contour(8).x = 330 '0
    Contour(8).y = 65
    
    Contour(9).x = 380 '-40
    Contour(9).y = 90
    
    Contour(10).x = 375
    Contour(10).y = 150
    
    Contour(11).x = 360
    Contour(11).y = 250
    
    Contour(12).x = 370
    Contour(12).y = 300
    
    Contour(13).x = 362
    Contour(13).y = 362
    
    Contour(14).x = 360
    Contour(14).y = 375
    
    Contour(15).x = Contour(1).x
    Contour(15).y = Contour(1).y
    
    
   
    height = ContourHeight
    width = 50
    
    Dim StartPt As Integer
    Dim EndPt As Integer
    Dim PreviousPt As Integer
    PreviousPt = 1
    For i = 1 To 14
'        If i = 3 Then
'            'Draw top piece as normal
'         corner_straight_wall Contour(i).x, _
'             Contour(i).y, _
'             Contour(i + 1).x, _
'             Contour(i + 1).y, _
'             7.75 * height, width, 0.25 * height, 1
'            StartPt = ExtraPt
'        Else
            StartPt = i
'        End If
         EndPt = i + 1
         corner_straight_wall Contour(StartPt).x, _
             Contour(StartPt).y, _
             Contour(EndPt).x, _
             Contour(EndPt).y, _
             height * 10, width, height, 1
        
    Next i

End Sub


Sub openbox(x, y, z, inX, inY, outX, outY, Zsize)
    ''Draw a box at x, y, z, with a hole in the center with (inx, iny size)
    Dim x1, x2, x3, y1, y2, y3
    Dim bandwidthX, bandwidthY
    
    bandwidthX = outX - inX
    bandwidthY = outY - inY
    
    x1 = x - (inX + bandwidthX / 2#)
    x2 = x
    x3 = x + (inX + bandwidthX / 2#)
    y1 = y - (inY + bandwidthY / 2#)
    y2 = y
    y3 = y + (inY + bandwidthY / 2#)
    
    Box x1, y2, z, 0, bandwidthX / 2, outY / 1, Zsize
    Box x3, y2, z, 0, bandwidthX / 2, outY / 1, Zsize
    
    Box x2, y1, z, 0, inX / 1, bandwidthY / 2, Zsize
    Box x2, y3, z, 0, inX / 1, bandwidthY / 2, Zsize
End Sub


Sub corner_straight_wall(x1, y1, x2, y2, startz, _
        width, height, cornermult)
    
    Dim xcenter, ycenter, xdelta, ydelta, wallLength, theta
    Dim hypotenuse, dx, dy, halfwidth, halflength, Phi, delta
    delta = 4
    
    halfwidth = width / 2#
'    xcenter = (x1 + x2) / 2#
'    ycenter = (y1 + y2) / 2#
    xdelta = x2 - x1
    ydelta = y2 - y1
    theta = my_find_angle(xdelta, ydelta)
    wallLength = Sqr(xdelta * xdelta + ydelta * ydelta)
    halflength = wallLength / 2#
    Phi = my_find_angle(wallLength, width)
    
    hypotenuse = Sqr(wallLength * wallLength + width * width) / 2#
    
    dx = hypotenuse * cosD(theta + Phi) * cornermult
    dy = hypotenuse * sinD(theta + Phi) * cornermult
    ''Remember, X, Y are half of the real width in the BZWorld.
    Box x1 + dx, y1 + dy, startz, theta, halflength + delta, halfwidth, height
    
End Sub


Sub BuildTown(x, y, z, theta, Xsize, Ysize, Seed, Optional MaxNumberObjects = 30)
    '' Create a small town with a central forum
    Const MinHeight = 5
    Const maxsize = 12
    Const MaxZSize = 18 - MinHeight
    Const forumsize = 40
    Dim NumberObjects As Integer
    Dim percentage As Double
    Dim i As Integer
    Dim lX, lY
    
    If Xsize <= forumsize Or Ysize <= forumsize Then
        MsgBox "Can't build town - forum bigger than size."
        Error 1
    End If
    
    percentage = Rnd(Seed)
    NumberObjects = percentage * MaxNumberObjects
    For i = 1 To NumberObjects
pickX:
        lX = Rnd() * Xsize
        lY = Rnd() * Ysize
        If lY < forumsize And lX < forumsize Then GoTo pickX
        
        If Rnd() < 0.5 Then lX = -lX
        If Rnd() < 0.5 Then lY = -lY
        
        Box x, y, z, theta, sizeX, sizeY, sizeZ
        Box x + lX, y + lY, z, theta, _
            Rnd() * maxsize + 2, _
            Rnd() * maxsize + 2, _
            Rnd() * MaxZSize + MinHeight
    
    Next i
    
    
    
End Sub
