Attribute VB_Name = "Script_ContestCTF"
Sub Write_ContestCTF()
    If Not Open_Output_File("ContestCTF", True) Then
        Exit Sub
    End If

    world 400

    'Corner bases
    Base 375, 376, 0, 25, 25, 0, 0, 3 'BLUE
    Base -375, -374, 0, 25, 25, 0, 0, 4 'PURPLE
    
    'Dividers
    Const BarrierHeight = 35
    Box -100, 100, 0, 45, 200 * 1.414, 2, BarrierHeight, "Barrier1"
    Box 100, -100, 0, 45, 200 * 1.414, 2, BarrierHeight, "Barrier2"
    'Angle part of dividers
    sBox -300, -150, 0, 0, 2, 50, BarrierHeight
    sBox -150, -300, 0, 0, 50, 2, BarrierHeight
    'Towers at ends
    sBox -300, -200, 0, 60, 5, 5, BarrierHeight * 2
    sBox -200, -300, 0, 30, 5, 5, BarrierHeight * 2
    Dim radius, angle1, angle2, angle3, eangle, eangleD
    radius = 100 * Sqr(5#)
    sBox -400, -400 + radius, 0, 0, 5, 5, 40
    sBox -400 + radius, -400, 0, 0, 5, 5, 40
    
    sBox -300, -105, 0, 0, 10, 10, 50
    
    ''Towers near bases
    angle2 = 45#
    eangle = Atn(0.5)
    eangleD = 360# * eangle / (2# * 3.141592)
    angle1 = eangleD / 2#
    angle3 = 90 - angle1
    
    sBox radius * sinD(angle1) - 400, radius * cosD(angle1) - 400, 0, 90 - angle1, 3, 3, 20
    sBox radius * sinD(angle2) - 400, radius * cosD(angle2) - 400, 0, angle2, 3, 3, 20
    sBox radius * sinD(angle3) - 400, radius * cosD(angle3) - 400, 0, 90 - angle3, 3, 3, 20
    
    Const brandX = -290
    Const brandY = -345
    sBox brandX, brandY, 0, 0, 10, 20, 15
    sBox brandY, brandX, 0, 0, 20, 10, 15
    
    ''Top field ''''''''''''''''''''''''''''''''''
    ' Along axis of symmetry
    Box -180, 180, 0, 0, 25, 25, 15
    Box -180, 180, 15, 0, 12, 12, 15
    
    'Road
    sBox -244, 128.5, 13, 30, 60, 5, 2
    sBox -299, 101.5, 0, 0, 12, 12, 15
    
    'Further box on-axis
    Const FboxX = 300
    Box -FboxX, FboxX, 0, 45, 20, 20, 16
    Box -FboxX, FboxX, 16, 45, 10, 10, 14
    Box (-180 - FboxX) / 2, (180 + FboxX) / 2, 28, 45, 6, 90, 2
    
    Pyramid -365, 365, 0, 0, 15, 15, 50
    
    sBox -340, -47.5, 0, -15, 20, 15, 15
    sPyramid -259, 20, 0, 0, 15, 15, 40, False, False
    
'    sBox -173, 47, 0, 45, 12, 12, 12
    sBox -305, 200, 0, 0, 40, 10, 15
    
    Pyramid -100, 100, 0, 0, 20, 20, 80
    
    
    '' Teleporters '''''''''''''''''''''''''''''''''''''''''''
    Teleporter -330, 330, 0, 45, 0.45, 10, 10, 0.5, "Top"
    Teleporter -30, 30, 0, 45 + 90, 0.45, 10, 10, 0.5, "Center1"
    fully_connect_teleporters "Top", "Center1"
    
    Teleporter 30, -30, 0, 45 + 90, 0.45, 10, 10, 0.5, "Center2"
    Teleporter 300, -300, 0, 45 + 90, 0.45, 10, 10, 0.5, "Bottom"
    fully_connect_teleporters "Center2", "Bottom"
    
    '' Central Zone ''''''''''''''''''''''''''''''''''''''''''
    sBox -40, -40, 0, 0, 25, 25, 15
    sBox -40, -40, 15, 0, 12, 12, 15
    sPyramid -40, -40, 30, 0, 8, 8, 30, False, True
    
    sBox -80, 0, 0, 0, 8, 8, 12
    sBox 0, -80, 0, 0, 8, 8, 12
    sPyramid -123, 20, 0, 45, 15, 15, 60, False, False
    
    Box 68, -68, 0, 45, 50, 10, 15
    Box 74, -74, 0, 45, 20, 12, 10
    'Box complex linked to center by ramps
    Const bdelta = 40
    sBox -172 + bdelta, -172 + bdelta, 0, 0, 30, 30, 15
    sBox -165 + bdelta, -165 + bdelta, 15, 45, 8, 8, 10
    
    'Roads
    sBox -108 + bdelta / 2, -108 + bdelta / 2, 13, 45, 90 - bdelta / 2, 8, 2
    sBox -108 + bdelta / 2, -108 + bdelta / 2, 23, 45, 80 - bdelta / 2, 4, 2
    'pyramids by roads
    sPyramid -145 + bdelta, -104 + bdelta, 0, 45, 15, 15, 60, False, False
    sPyramid -104 + bdelta, -145 + bdelta, 0, 45, 15, 15, 60, False, False
    
    sBox -205, -108, 0, 0, 12, 12, 12
    sBox -108, -205, 0, 0, 12, 12, 12
    sPyramid -46, -172, 0, 45, 12, 12, 30, False, False
    sPyramid -172, -46, 0, 45, 12, 12, 30, False, False
    
    'central blocking box
    Box 5, -5, 33, 45, 5, 30, 25
    'lower one
    Box 5, -5, 18, 45, 5, 30, 13
    
    
    '' Lower corner '''''''''''''''''''''''''''''''''''
    Box 159, -159, 0, -45, 80, 20, 32
    
    'sBox 106, -179, 0, -45, 40, 9, 3
    sBox 106, -179, 1.5, -45, 40, 1, 28
    
    
    sPyramid -44, -330, 0, 0, 17, 17, 55, False, False
    sBox 154, -315, 0, -117.5, 40, 9, 15
    sBox 169, -280, 0, 0, 12, 12, 50
    
    Box 340, -340, 0, 45, 15, 10, 12
    sPyramid 231, -333, 0, 0, 10, 10, 40, False, False
    
    sBox 70, -378, 0, 0, 12, 23, 15
    sBox 85.5, -281.5, 0, 45, 15, 10, 12
    
    sPyramid 128, -201, 0, 45, 7, 7, 30, False, False
    sPyramid 84, -157, 0, 45, 7, 7, 30, False, False
    
    'Bug fixes
    sPyramid -284, 159, 0, 0, 8, 8, 30, False, False
    sPyramid -382, 41, 0, 0, 8, 8, 30, False, False
    sPyramid 17, -217, 0, 0, 8, 8, 30, False, False
    Pyramid 368, -368, 0, 0, 8, 8, 30, False, False
    sPyramid -287, -280, 0, 0, 8, 8, 30, False, False
    sPyramid -370, -232, 0, 0, 8, 8, 30, False, False
    sPyramid -232, -370, 0, 0, 8, 8, 30, False, False
    sPyramid 105, -317, 0, 0, 6, 6, 40, False, False
   
   
    Close_Output_File
End Sub


''''''''''''''''''''''''''
''' Symmetry Functions '''
''''''''''''''''''''''''''

'' For CTF symmetry, these functions add duplicate
'' (mirror image) entries, reflected about a line
'' from (-400, 400) to (400, -400) - which is particular
'' to this map, so the functions are local here (for now).

Sub sBox(x, y, z, rotation, sizeX, sizeY, sizeZ)
    'Regular one
    Box x, y, z, rotation, sizeX, sizeY, sizeZ
    Box -y, -x, z, (270 - rotation), sizeX, sizeY, sizeZ
End Sub

Sub sPyramid(x, y, z, rotation, sizeX, sizeY, sizeZ, ShootThrough As Boolean, DriveThrough As Boolean)
    Pyramid x, y, z, rotation, sizeX, sizeY, sizeZ, ShootThrough, DriveThrough
    Pyramid -y, -x, z, (270 - rotation), sizeX, sizeY, sizeZ, ShootThrough, DriveThrough
End Sub

Sub sTeleporter(x, y, z, rotation, sizeX, sizeY, sizeZ, sizeB, name)
    Teleporter x, y, z, rotation, sizeX, sizeY, sizeZ, sizeB, name
    Teleporter -y, -x, z, (270 - rotation), sizeX, sizeY, sizeZ, sizeB, "R" & name
End Sub
