Attribute VB_Name = "Temple"
Const TempleTexture = "water"

'Const ColumnTexture = "http://www.bentz-engineering.com/BZFlag/Textures/TravertinoGiallo"
'Const ColumnBaseTexture = "http://www.bentz-engineering.com/BZFlag/Textures/Basaltina"
'Const TempleBaseTexture = "http://www.bentz-engineering.com/BZFlag/Textures/VerdeZvezia"
'Const RoofTexture = "http://www.bentz-engineering.com/BZFlag/Textures/Perlatino"
'Const EndTexture = "http://www.bentz-engineering.com/BZFlag/Textures/Cipollino"

Const ColumnTexture = "mesh"
Const ColumnBaseTexture = "water" '"http://www.bentz-engineering.com/BZFlag/Textures/Basaltina"
Const TempleBaseTexture = "purple_basetop" '"http://www.bentz-engineering.com/BZFlag/Textures/VerdeZvezia"
Const RoofTexture = "roof" '"http://www.bentz-engineering.com/BZFlag/Textures/Perlatino"
Const EndTexture = "zone_ground" '"http://www.bentz-engineering.com/BZFlag/Textures/Cipollino"

Const ColumnBoxHeight = 1
Const ColumnHeight = 13

Dim InSet

Dim templeX, templeY, templeZ, templeSX, templeSY, templeSZ

Sub myTemple(x, y, z, scaleX, scaleY, scaleZ)
    Const templeScale = 7
    Const TempleWidth = 8 * templeScale ' golden ratio
    Const TempleHalfWidth = TempleWidth / 2#
    Const TempleLength = 13 * templeScale ' golden ratio
    Const TempleHalfLength = TempleLength / 2#
    Const TempleColSpace = templeScale
    Const Baseheight = 2

    Dim i As Integer
    Dim j As Integer
    Dim myY As Double
    Dim myX1 As Double
    Dim myX2 As Double
    Dim myX As Double
    Dim myY1 As Double
    Dim myY2 As Double
    
    Dim p1x, p1y, p2x, p2y, p3x, p3y, pz
    Dim p4x, py4y, p5x, p5y, p6x, p6y, wafer, overhang
   
    If Not V2 Then Exit Sub
   
    'First, define the material
    define_temple_materials
    
    ''Trial: temple definition
    
    
    'Next, define a column
    define_column

    raw_emit "define PPTemple" 'just do it directly.

    'Put in a base box, and a smaller step
    Const stepsize = 3
    MeshBox 0, 0, 0, 0, TempleHalfLength + InSet, TempleHalfWidth + InSet, Baseheight, "TempleBaseMaterial"
    MeshBox 0, 0, 0, 0, TempleHalfLength + InSet + stepsize, TempleHalfWidth + InSet + stepsize, Baseheight / 2#, "TempleBaseMaterial"

    'Put in the roof
    MeshBox 0, 0, 0 + ColumnHeight + 2 * ColumnBoxHeight, 0, TempleHalfLength * 1 + InSet, _
        TempleHalfWidth * 0.9 + InSet, Baseheight * 0.4, "RoofMaterial"
    'inset for metope
    MeshBox 0, 0, 0 + ColumnHeight + 2 * ColumnBoxHeight + Baseheight * 0.2, 0, TempleHalfLength * 1 + InSet * 0.6, _
        TempleHalfWidth * 0.9 + InSet * 0.6, Baseheight, "ColumnMaterial"
    MeshBox 0, 0, 0 + ColumnHeight + 2 * ColumnBoxHeight + 2 * Baseheight * 0.4, 0, TempleHalfLength * 1 + InSet, _
        TempleHalfWidth * 0.9 + InSet, Baseheight * 0.2, "ColumnMaterial"
   
    'Now, walk through spacing these out
    For j = TempleColSpace To TempleLength - TempleColSpace Step TempleColSpace
        'put a column at X = -templehalfwidth and +templehalfwidth
        myX1 = 0 - TempleHalfWidth
        myX2 = 0 + TempleHalfWidth
        myY = 0 + j - TempleHalfLength
        raw_emit ("group myColumn")
        raw_emit ("  shift " & nArg(myX1) & " " & myY & " " & nArg(0 + 2))
        raw_emit ("end")
        
        raw_emit ("group myColumn")
        raw_emit ("  shift " & nArg(myX2) & " " & myY & " " & nArg(0 + 2))
        raw_emit ("end")
     Next j
     
    'Put in columns at ends
    For i = -TempleHalfWidth To TempleHalfWidth Step TempleColSpace
        myX = 0 + i
        myY1 = 0 - TempleHalfLength
        myY2 = 0 + TempleHalfLength
        
        raw_emit ("group myColumn")
        raw_emit ("  shift " & nArg(myX) & " " & nArg(myY1) & " " & nArg(0 + 2))
        raw_emit ("end")
        
        raw_emit ("group myColumn")
        raw_emit ("  shift " & nArg(myX) & " " & nArg(myY2) & " " & nArg(0 + 2))
        raw_emit ("end")
     Next i
     
     '' Put in the triangular ends
     
     'Top end
     p1x = -TempleHalfWidth
     p1y = TempleHalfLength
     p2x = 0
     p2y = TempleHalfLength
     p3x = TempleHalfWidth
     p3y = TempleHalfLength
     pz = ColumnHeight + 2 * ColumnBoxHeight + 2 * Baseheight * 0.4 + Baseheight * 0.2
     raw_emit "mesh"
     raw_emit "  matref EndMaterial"
     vertex 0 + p1x, 0 + p1y, 0 + pz
     vertex 0 + p2x, 0 + p2y, 0 + pz + 8
     vertex 0 + p3x, 0 + p3y, 0 + pz
     face3 0, 1, 2, True
     raw_emit "end"
     
     'Bottom end
     p4x = p3x
     p4y = -p3y
     p5x = p2x
     p5y = -p2y
     p6x = p1x
     p6y = -p1y
     
     raw_emit "mesh"
     raw_emit "  matref EndMaterial"
     vertex 0 + p6x, 0 + p6y, 0 + pz
     vertex 0 + p5x, 0 + p5y, 0 + pz + 8
     vertex 0 + p4x, 0 + p4y, 0 + pz
     face3 0, 2, 1, True
     raw_emit "end"
     
     'Left roof panel  ''Original!
     
     '' Extend roof by inset; from now on, all p?x, p?y variables
     '' refer to larger roof.
     p1y = p1y + InSet
     p2y = p2y + InSet
     p3y = p3y + InSet 'should work
     p4y = -p1y
     p5y = -p2y
     p6y = -p1y
     
    wafer = 1
    overhang = 2
    
    raw_emit "mesh"
    raw_emit "  matref RoofMaterial"
    'Base plane
    vertex 0 + p1x, 0 + p1y, 0 + pz
    vertex 0 + p2x, 0 + p2y, 0 + pz + 8
    vertex 0 + p5x, 0 + p5y, 0 + pz + 8
    vertex 0 + p6x, 0 + p6y, 0 + pz
    'Top plane
    vertex 0 + p1x, 0 + p1y, 0 + pz + wafer
    vertex 0 + p2x, 0 + p2y, 0 + pz + 8 + wafer
    vertex 0 + p5x, 0 + p5y, 0 + pz + 8 + wafer
    vertex 0 + p6x, 0 + p6y, 0 + pz + wafer
   
    'Now, must do 6 faces, each of 4 points.
    'Outside top
    'face4 5, 6, 7, 8
    face4 4, 7, 6, 5, True
    'inside top
    face4 0, 1, 2, 3, True 'must face inward
    'face4 0, 3, 2, 1, True
    'one end
    face4 2, 6, 7, 3
    'face4 3, 7, 6, 2
    'other end
    'face4 4, 0, 1, 5 'Swap this end arbitrarily to test.
    face4 5, 1, 0, 4
    'long edge down
    'face4 0, 4, 7, 3
    face4 4, 0, 3, 7
    'long edge top
    face4 5, 6, 2, 1
    'face4 5, 1, 2, 6
    
    raw_emit "end"  '''Done left panel.
     
    'Right pane
    raw_emit "mesh"
    raw_emit "  matref RoofMaterial"
    'Base plane
    vertex 0 + p4x, 0 + p4y, 0 + pz
    vertex 0 + p5x, 0 + p5y, 0 + pz + 8
    vertex 0 + p2x, 0 + p2y, 0 + pz + 8
    vertex 0 + p3x, 0 + p3y, 0 + pz
    'Top plane
    vertex 0 + p4x, 0 + p4y, 0 + pz + wafer
    vertex 0 + p5x, 0 + p5y, 0 + pz + 8 + wafer
    vertex 0 + p2x, 0 + p2y, 0 + pz + 8 + wafer
    vertex 0 + p3x, 0 + p3y, 0 + pz + wafer
   
    'Now, must do 6 faces, each of 4 points.
    'Outside top
    'face4 5, 6, 7, 8
    face4 4, 7, 6, 5, True
    'inside top
    face4 0, 1, 2, 3, True 'must face inward.
    'face4 0, 3, 2, 1, True
    'one end
    face4 2, 6, 7, 3
    'face4 3, 7, 6, 2
    'other end
    'face4 4, 0, 1, 5 'Swap this end arbitrarily to test.
    face4 5, 1, 0, 4
    'long edge down
    'face4 0, 4, 7, 3
    face4 4, 0, 3, 7
    'long edge top
    face4 5, 6, 2, 1
    'face4 5, 1, 2, 6
    
    raw_emit "end"
    
     
    raw_emit "enddef"
    raw_emit "group PPTemple"
    raw_emit "shift " & nArg(x) & " " & nArg(y) & " " & nArg(z)
    raw_emit "scale " & nArg(scaleX) & " " & nArg(scaleY) & " " & nArg(scaleZ)
    raw_emit "end"
End Sub

Sub define_temple_materials()
    raw_emit ("material")
    raw_emit ("  name ColumnMaterial")
    raw_emit ("  texture " & ColumnTexture)
    raw_emit ("  notexalpha")
    raw_emit ("end")
    raw_emit ("material")
    raw_emit ("  name ColumnBaseMaterial")
    raw_emit ("  texture " & ColumnBaseTexture)
    raw_emit ("  notexalpha")
    raw_emit ("end")
    raw_emit ("material")
    raw_emit ("  name TempleBaseMaterial")
    raw_emit ("  texture " & TempleBaseTexture)
    raw_emit ("  notexalpha")
    raw_emit ("end")
    raw_emit ("material")
    raw_emit ("  name RoofMaterial")
    raw_emit ("  texture " & RoofTexture)
    raw_emit ("  notexalpha")
    raw_emit ("end")
    raw_emit ("material")
    raw_emit ("  name EndMaterial")
    raw_emit ("  texture " & EndTexture)
    raw_emit ("  notexalpha")
    raw_emit ("end")
End Sub


Sub define_column()
    Const npoints = 8
    Const PointAngle = 360# / npoints
    Const TopRadius = 1
    Const BottomRadius = 1.3
    Const BottomBoxSize = (BottomRadius * 1.1)
    Const TopBoxSize = (TopRadius * 1.1)
    Dim Height As Double
    Dim i As Integer
    Dim x As Double, y As Double, z As Double
    Dim tPoint As Point
    Dim BasePoints(npoints) As Integer
    Dim TopPoints(npoints) As Integer
    Dim iCurPoint As Integer
    Dim Vertex1 As Integer
    Dim Vertex2 As Integer
    Dim Vertex3 As Integer
    Dim Vertex4 As Integer
    Dim capitalHeight As Double
    
    Height = ColumnHeight
    InSet = BottomBoxSize * 3
    
    raw_emit ("define myColumn")
    MeshBox 0, 0, 0, 0, BottomBoxSize, BottomBoxSize, ColumnBoxHeight, "ColumnBaseMaterial"
    
    capitalHeight = ColumnBoxHeight * 0.8
    MeshBox 0, 0, Height - capitalHeight, 0, TopBoxSize, TopBoxSize, _
       capitalHeight + 0.6, "ColumnBaseMaterial"
    raw_emit "mesh"
    raw_emit "  matref ColumnMaterial"
    For i = 1 To npoints
        x = BottomRadius * cosD(i * PointAngle)
        y = BottomRadius * sinD(i * PointAngle)
        z = 0
        vertex x, y, z
        BasePoints(i) = iCurPoint
        iCurPoint = iCurPoint + 1
        x = TopRadius * cosD(i * PointAngle)
        y = TopRadius * sinD(i * PointAngle)
        z = Height
        vertex x, y, z
        TopPoints(i) = iCurPoint
        iCurPoint = iCurPoint + 1
    Next i
    For i = 1 To npoints - 1
        'Now emit faces
        Vertex1 = BasePoints(i)
        Vertex2 = BasePoints(i + 1)
        Vertex3 = TopPoints(i + 1)
        Vertex4 = TopPoints(i)
        face4 Vertex1, Vertex2, Vertex3, Vertex4
        'face4 Vertex2, Vertex1, Vertex4, Vertex3
    Next i
    'Do last one, wraparound, by hand
    Vertex1 = BasePoints(npoints)
    Vertex2 = BasePoints(1)
    Vertex3 = TopPoints(1)
    Vertex4 = TopPoints(npoints)
    face4 Vertex1, Vertex2, Vertex3, Vertex4
    'face4 Vertex2, Vertex1, Vertex4, Vertex3
    raw_emit "end"
    raw_emit ("enddef")
End Sub


Sub ntemple(x, y, z, scaleX, scaleY, scaleZ)
    templeX = x
    templeY = y
    templeZ = z
    templeSX = scaleX
    templeSY = scaleY
    templeSZ = scaleZ

  raw_emit ("material")
  raw_emit ("  name templeCol")
  raw_emit ("  texture water")
  raw_emit ("  notexalpha")
  raw_emit ("end")
  
  raw_emit ("define temple")
  
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex -17.095491 4.213891 10.459996")
  raw_emit ("  vertex -17.345491 4.395526 10.459996")
  raw_emit ("  vertex -17.654509 4.395526 10.459996")
  raw_emit ("  vertex -17.904509 4.213891 10.459996")
  raw_emit ("  vertex -18.000000 3.919998 10.459996")
  raw_emit ("  vertex -17.904509 3.626106 10.459996")
  raw_emit ("  vertex -17.654509 3.444470 10.459996")
  raw_emit ("  vertex -17.345491 3.444470 10.459996")
  raw_emit ("  vertex -17.095491 3.626106 10.459996")
  raw_emit ("  vertex -17.000000 3.919998 10.459996")
  raw_emit ("  vertex -18.114853 3.473282 2.760002")
  raw_emit ("  vertex -18.260000 3.919998 2.760001")
  raw_emit ("  vertex -18.114853 4.366715 2.760001")
  raw_emit ("  vertex -17.734854 4.642801 2.760002")
  raw_emit ("  vertex -17.265146 4.642801 2.760002")
  raw_emit ("  vertex -16.885147 4.366715 2.760001")
  raw_emit ("  vertex -16.740000 3.919998 2.760001")
  raw_emit ("  vertex -16.885147 3.473282 2.760002")
  raw_emit ("  vertex -17.265146 3.197196 2.760002")
  raw_emit ("  vertex -17.734854 3.197196 2.760002")
  raw_emit ("  texcoord 0.200186 0.708402")
  raw_emit ("  texcoord 0.195802 0.717385")
  raw_emit ("  texcoord 0.190382 0.717385")
  raw_emit ("  texcoord 0.185998 0.708402")
  raw_emit ("  texcoord 0.184323 0.693867")
  raw_emit ("  texcoord 0.185998 0.679333")
  raw_emit ("  texcoord 0.190382 0.670350")
  raw_emit ("  texcoord 0.195802 0.670350")
  raw_emit ("  texcoord 0.200186 0.679333")
  raw_emit ("  texcoord 0.201861 0.693867")
  raw_emit ("  texcoord 0.182309 0.328225")
  raw_emit ("  texcoord 0.179763 0.306133")
  raw_emit ("  texcoord 0.182309 0.284040")
  raw_emit ("  texcoord 0.188973 0.270386")
  raw_emit ("  texcoord 0.197211 0.270386")
  raw_emit ("  texcoord 0.203875 0.284040")
  raw_emit ("  texcoord 0.206421 0.306133")
  raw_emit ("  texcoord 0.203875 0.328225")
  raw_emit ("  texcoord 0.197211 0.341879")
  raw_emit ("  texcoord 0.188973 0.341879")
  raw_emit ("  texcoord 0.693867 0.769040")
  raw_emit ("  texcoord 0.679333 0.769040")
  raw_emit ("  texcoord 0.671775 0.388229")
  raw_emit ("  texcoord 0.693867 0.388229")
  raw_emit ("  texcoord 0.670350 0.769040")
  raw_emit ("  texcoord 0.658121 0.388229")
  raw_emit ("  texcoord 0.197211 0.388229")
  raw_emit ("  texcoord 0.195802 0.769040")
  raw_emit ("  texcoord 0.190382 0.769040")
  raw_emit ("  texcoord 0.188973 0.388229")
  raw_emit ("  texcoord 0.329650 0.769040")
  raw_emit ("  texcoord 0.320667 0.769040")
  raw_emit ("  texcoord 0.328225 0.388229")
  raw_emit ("  texcoord 0.341879 0.388229")
  raw_emit ("  texcoord 0.306133 0.769040")
  raw_emit ("  texcoord 0.306133 0.388229")
  raw_emit ("  texcoord 0.291598 0.769040")
  raw_emit ("  texcoord 0.284040 0.388229")
  raw_emit ("  texcoord 0.282615 0.769040")
  raw_emit ("  texcoord 0.270386 0.388229")
  raw_emit ("  texcoord 0.809618 0.769040")
  raw_emit ("  texcoord 0.804198 0.769040")
  raw_emit ("  texcoord 0.802789 0.388229")
  raw_emit ("  texcoord 0.811027 0.388229")
  raw_emit ("  texcoord 0.717385 0.769040")
  raw_emit ("  texcoord 0.708402 0.769040")
  raw_emit ("  texcoord 0.715960 0.388229")
  raw_emit ("  texcoord 0.729614 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -18.500000 4.919998 2.835002")
  raw_emit ("  vertex -16.500000 4.919998 2.835002")
  raw_emit ("  vertex -16.500000 4.919998 2.585002")
  raw_emit ("  vertex -18.500000 4.919998 2.585002")
  raw_emit ("  vertex -18.500000 2.919998 2.585002")
  raw_emit ("  vertex -16.500000 2.919998 2.585002")
  raw_emit ("  vertex -16.500000 2.919998 2.835002")
  raw_emit ("  vertex -18.500000 2.919998 2.835002")
  raw_emit ("  texcoord 0.824446 0.391939")
  raw_emit ("  texcoord 0.789370 0.391939")
  raw_emit ("  texcoord 0.789370 0.379575")
  raw_emit ("  texcoord 0.824446 0.379575")
  raw_emit ("  texcoord 0.175554 0.379575")
  raw_emit ("  texcoord 0.210630 0.379575")
  raw_emit ("  texcoord 0.210630 0.391939")
  raw_emit ("  texcoord 0.175554 0.391939")
  raw_emit ("  texcoord 0.175554 0.256677")
  raw_emit ("  texcoord 0.210630 0.256677")
  raw_emit ("  texcoord 0.210630 0.355589")
  raw_emit ("  texcoord 0.175554 0.355589")
  raw_emit ("  texcoord 0.743323 0.379575")
  raw_emit ("  texcoord 0.743323 0.391939")
  raw_emit ("  texcoord 0.644411 0.391939")
  raw_emit ("  texcoord 0.644411 0.379575")
  raw_emit ("  texcoord 0.210630 0.743323")
  raw_emit ("  texcoord 0.175554 0.743323")
  raw_emit ("  texcoord 0.175554 0.644411")
  raw_emit ("  texcoord 0.210630 0.644411")
  raw_emit ("  texcoord 0.256677 0.391939")
  raw_emit ("  texcoord 0.256677 0.379575")
  raw_emit ("  texcoord 0.355589 0.379575")
  raw_emit ("  texcoord 0.355589 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -18.250000 4.669998 10.721587")
  raw_emit ("  vertex -16.750000 4.669998 10.721587")
  raw_emit ("  vertex -16.750000 4.669998 10.471587")
  raw_emit ("  vertex -18.250000 4.669998 10.471587")
  raw_emit ("  vertex -18.250000 3.169998 10.471587")
  raw_emit ("  vertex -16.750000 3.169998 10.471587")
  raw_emit ("  vertex -16.750000 3.169998 10.721587")
  raw_emit ("  vertex -18.250000 3.169998 10.721587")
  raw_emit ("  texcoord 0.820061 0.781978")
  raw_emit ("  texcoord 0.793755 0.781978")
  raw_emit ("  texcoord 0.793755 0.769614")
  raw_emit ("  texcoord 0.820061 0.769614")
  raw_emit ("  texcoord 0.179939 0.769614")
  raw_emit ("  texcoord 0.206245 0.769614")
  raw_emit ("  texcoord 0.206245 0.781978")
  raw_emit ("  texcoord 0.179939 0.781978")
  raw_emit ("  texcoord 0.206245 0.269041")
  raw_emit ("  texcoord 0.206245 0.343225")
  raw_emit ("  texcoord 0.179939 0.343225")
  raw_emit ("  texcoord 0.179939 0.269041")
  raw_emit ("  texcoord 0.730959 0.769614")
  raw_emit ("  texcoord 0.730959 0.781978")
  raw_emit ("  texcoord 0.656775 0.781978")
  raw_emit ("  texcoord 0.656775 0.769614")
  raw_emit ("  texcoord 0.206245 0.730959")
  raw_emit ("  texcoord 0.179939 0.730959")
  raw_emit ("  texcoord 0.179939 0.656775")
  raw_emit ("  texcoord 0.206245 0.656775")
  raw_emit ("  texcoord 0.269041 0.781978")
  raw_emit ("  texcoord 0.269041 0.769614")
  raw_emit ("  texcoord 0.343225 0.769614")
  raw_emit ("  texcoord 0.343225 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex -12.095491 4.213891 10.459996")
  raw_emit ("  vertex -12.345491 4.395526 10.459996")
  raw_emit ("  vertex -12.654509 4.395526 10.459996")
  raw_emit ("  vertex -12.904509 4.213891 10.459996")
  raw_emit ("  vertex -13.000000 3.919998 10.459996")
  raw_emit ("  vertex -12.904509 3.626106 10.459996")
  raw_emit ("  vertex -12.654509 3.444470 10.459996")
  raw_emit ("  vertex -12.345491 3.444470 10.459996")
  raw_emit ("  vertex -12.095491 3.626106 10.459996")
  raw_emit ("  vertex -12.000000 3.919998 10.459996")
  raw_emit ("  vertex -13.114853 3.473282 2.760002")
  raw_emit ("  vertex -13.260000 3.919998 2.760001")
  raw_emit ("  vertex -13.114853 4.366715 2.760001")
  raw_emit ("  vertex -12.734853 4.642801 2.760002")
  raw_emit ("  vertex -12.265147 4.642801 2.760002")
  raw_emit ("  vertex -11.885147 4.366715 2.760001")
  raw_emit ("  vertex -11.740000 3.919998 2.760001")
  raw_emit ("  vertex -11.885147 3.473282 2.760002")
  raw_emit ("  vertex -12.265147 3.197196 2.760002")
  raw_emit ("  vertex -12.734853 3.197196 2.760002")
  raw_emit ("  texcoord 0.287874 0.708402")
  raw_emit ("  texcoord 0.283490 0.717385")
  raw_emit ("  texcoord 0.278070 0.717385")
  raw_emit ("  texcoord 0.273686 0.708402")
  raw_emit ("  texcoord 0.272011 0.693867")
  raw_emit ("  texcoord 0.273686 0.679333")
  raw_emit ("  texcoord 0.278070 0.670350")
  raw_emit ("  texcoord 0.283490 0.670350")
  raw_emit ("  texcoord 0.287874 0.679333")
  raw_emit ("  texcoord 0.289549 0.693867")
  raw_emit ("  texcoord 0.269997 0.328225")
  raw_emit ("  texcoord 0.267451 0.306133")
  raw_emit ("  texcoord 0.269997 0.284040")
  raw_emit ("  texcoord 0.276661 0.270386")
  raw_emit ("  texcoord 0.284899 0.270386")
  raw_emit ("  texcoord 0.291563 0.284040")
  raw_emit ("  texcoord 0.294109 0.306133")
  raw_emit ("  texcoord 0.291563 0.328225")
  raw_emit ("  texcoord 0.284899 0.341879")
  raw_emit ("  texcoord 0.276661 0.341879")
  raw_emit ("  texcoord 0.693867 0.769040")
  raw_emit ("  texcoord 0.679333 0.769040")
  raw_emit ("  texcoord 0.671775 0.388229")
  raw_emit ("  texcoord 0.693867 0.388229")
  raw_emit ("  texcoord 0.670350 0.769040")
  raw_emit ("  texcoord 0.658121 0.388229")
  raw_emit ("  texcoord 0.284899 0.388229")
  raw_emit ("  texcoord 0.283490 0.769040")
  raw_emit ("  texcoord 0.278070 0.769040")
  raw_emit ("  texcoord 0.276661 0.388229")
  raw_emit ("  texcoord 0.329650 0.769040")
  raw_emit ("  texcoord 0.320667 0.769040")
  raw_emit ("  texcoord 0.328225 0.388229")
  raw_emit ("  texcoord 0.341879 0.388229")
  raw_emit ("  texcoord 0.306133 0.769040")
  raw_emit ("  texcoord 0.306133 0.388229")
  raw_emit ("  texcoord 0.291598 0.769040")
  raw_emit ("  texcoord 0.284040 0.388229")
  raw_emit ("  texcoord 0.282615 0.769040")
  raw_emit ("  texcoord 0.270386 0.388229")
  raw_emit ("  texcoord 0.721930 0.769040")
  raw_emit ("  texcoord 0.716510 0.769040")
  raw_emit ("  texcoord 0.715101 0.388229")
  raw_emit ("  texcoord 0.723339 0.388229")
  raw_emit ("  texcoord 0.717385 0.769040")
  raw_emit ("  texcoord 0.708402 0.769040")
  raw_emit ("  texcoord 0.715960 0.388229")
  raw_emit ("  texcoord 0.729614 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -13.500000 4.919998 2.835002")
  raw_emit ("  vertex -11.500000 4.919998 2.835002")
  raw_emit ("  vertex -11.500000 4.919998 2.585002")
  raw_emit ("  vertex -13.500000 4.919998 2.585002")
  raw_emit ("  vertex -13.500000 2.919998 2.585002")
  raw_emit ("  vertex -11.500000 2.919998 2.585002")
  raw_emit ("  vertex -11.500000 2.919998 2.835002")
  raw_emit ("  vertex -13.500000 2.919998 2.835002")
  raw_emit ("  texcoord 0.736758 0.391939")
  raw_emit ("  texcoord 0.701682 0.391939")
  raw_emit ("  texcoord 0.701682 0.379575")
  raw_emit ("  texcoord 0.736758 0.379575")
  raw_emit ("  texcoord 0.263242 0.379575")
  raw_emit ("  texcoord 0.298318 0.379575")
  raw_emit ("  texcoord 0.298318 0.391939")
  raw_emit ("  texcoord 0.263242 0.391939")
  raw_emit ("  texcoord 0.263242 0.256677")
  raw_emit ("  texcoord 0.298318 0.256677")
  raw_emit ("  texcoord 0.298318 0.355589")
  raw_emit ("  texcoord 0.263242 0.355589")
  raw_emit ("  texcoord 0.743323 0.379575")
  raw_emit ("  texcoord 0.743323 0.391939")
  raw_emit ("  texcoord 0.644411 0.391939")
  raw_emit ("  texcoord 0.644411 0.379575")
  raw_emit ("  texcoord 0.298318 0.743323")
  raw_emit ("  texcoord 0.263242 0.743323")
  raw_emit ("  texcoord 0.263242 0.644411")
  raw_emit ("  texcoord 0.298318 0.644411")
  raw_emit ("  texcoord 0.256677 0.391939")
  raw_emit ("  texcoord 0.256677 0.379575")
  raw_emit ("  texcoord 0.355589 0.379575")
  raw_emit ("  texcoord 0.355589 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -13.250000 4.669998 10.721587")
  raw_emit ("  vertex -11.750000 4.669998 10.721587")
  raw_emit ("  vertex -11.750000 4.669998 10.471587")
  raw_emit ("  vertex -13.250000 4.669998 10.471587")
  raw_emit ("  vertex -13.250000 3.169998 10.471587")
  raw_emit ("  vertex -11.750000 3.169998 10.471587")
  raw_emit ("  vertex -11.750000 3.169998 10.721587")
  raw_emit ("  vertex -13.250000 3.169998 10.721587")
  raw_emit ("  texcoord 0.732373 0.781978")
  raw_emit ("  texcoord 0.706067 0.781978")
  raw_emit ("  texcoord 0.706067 0.769614")
  raw_emit ("  texcoord 0.732373 0.769614")
  raw_emit ("  texcoord 0.267627 0.769614")
  raw_emit ("  texcoord 0.293933 0.769614")
  raw_emit ("  texcoord 0.293933 0.781978")
  raw_emit ("  texcoord 0.267627 0.781978")
  raw_emit ("  texcoord 0.293933 0.269041")
  raw_emit ("  texcoord 0.293933 0.343225")
  raw_emit ("  texcoord 0.267627 0.343225")
  raw_emit ("  texcoord 0.267627 0.269041")
  raw_emit ("  texcoord 0.730959 0.769614")
  raw_emit ("  texcoord 0.730959 0.781978")
  raw_emit ("  texcoord 0.656775 0.781978")
  raw_emit ("  texcoord 0.656775 0.769614")
  raw_emit ("  texcoord 0.293933 0.730959")
  raw_emit ("  texcoord 0.267627 0.730959")
  raw_emit ("  texcoord 0.267627 0.656775")
  raw_emit ("  texcoord 0.293933 0.656775")
  raw_emit ("  texcoord 0.269041 0.781978")
  raw_emit ("  texcoord 0.269041 0.769614")
  raw_emit ("  texcoord 0.343225 0.769614")
  raw_emit ("  texcoord 0.343225 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  
  Call TempleSub2
End Sub

Sub TempleSub2()
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex -7.095491 4.213891 10.459996")
  raw_emit ("  vertex -7.345491 4.395526 10.459996")
  raw_emit ("  vertex -7.654509 4.395526 10.459996")
  raw_emit ("  vertex -7.904509 4.213891 10.459996")
  raw_emit ("  vertex -8.000000 3.919998 10.459996")
  raw_emit ("  vertex -7.904509 3.626106 10.459996")
  raw_emit ("  vertex -7.654509 3.444470 10.459996")
  raw_emit ("  vertex -7.345491 3.444470 10.459996")
  raw_emit ("  vertex -7.095491 3.626106 10.459996")
  raw_emit ("  vertex -7.000000 3.919998 10.459996")
  raw_emit ("  vertex -8.114853 3.473282 2.760002")
  raw_emit ("  vertex -8.260000 3.919998 2.760001")
  raw_emit ("  vertex -8.114853 4.366715 2.760001")
  raw_emit ("  vertex -7.734853 4.642801 2.760002")
  raw_emit ("  vertex -7.265147 4.642801 2.760002")
  raw_emit ("  vertex -6.885147 4.366715 2.760001")
  raw_emit ("  vertex -6.740000 3.919998 2.760001")
  raw_emit ("  vertex -6.885147 3.473282 2.760002")
  raw_emit ("  vertex -7.265147 3.197196 2.760002")
  raw_emit ("  vertex -7.734853 3.197196 2.760002")
  raw_emit ("  texcoord 0.375562 0.708402")
  raw_emit ("  texcoord 0.371178 0.717385")
  raw_emit ("  texcoord 0.365758 0.717385")
  raw_emit ("  texcoord 0.361374 0.708402")
  raw_emit ("  texcoord 0.359699 0.693867")
  raw_emit ("  texcoord 0.361374 0.679333")
  raw_emit ("  texcoord 0.365758 0.670350")
  raw_emit ("  texcoord 0.371178 0.670350")
  raw_emit ("  texcoord 0.375562 0.679333")
  raw_emit ("  texcoord 0.377237 0.693867")
  raw_emit ("  texcoord 0.357685 0.328225")
  raw_emit ("  texcoord 0.355139 0.306133")
  raw_emit ("  texcoord 0.357685 0.284040")
  raw_emit ("  texcoord 0.364349 0.270386")
  raw_emit ("  texcoord 0.372587 0.270386")
  raw_emit ("  texcoord 0.379251 0.284040")
  raw_emit ("  texcoord 0.381797 0.306133")
  raw_emit ("  texcoord 0.379251 0.328225")
  raw_emit ("  texcoord 0.372587 0.341879")
  raw_emit ("  texcoord 0.364349 0.341879")
  raw_emit ("  texcoord 0.693867 0.769040")
  raw_emit ("  texcoord 0.679333 0.769040")
  raw_emit ("  texcoord 0.671775 0.388229")
  raw_emit ("  texcoord 0.693867 0.388229")
  raw_emit ("  texcoord 0.670350 0.769040")
  raw_emit ("  texcoord 0.658121 0.388229")
  raw_emit ("  texcoord 0.372587 0.388229")
  raw_emit ("  texcoord 0.371178 0.769040")
  raw_emit ("  texcoord 0.365758 0.769040")
  raw_emit ("  texcoord 0.364349 0.388229")
  raw_emit ("  texcoord 0.329650 0.769040")
  raw_emit ("  texcoord 0.320667 0.769040")
  raw_emit ("  texcoord 0.328225 0.388229")
  raw_emit ("  texcoord 0.341879 0.388229")
  raw_emit ("  texcoord 0.306133 0.769040")
  raw_emit ("  texcoord 0.306133 0.388229")
  raw_emit ("  texcoord 0.291598 0.769040")
  raw_emit ("  texcoord 0.284040 0.388229")
  raw_emit ("  texcoord 0.282615 0.769040")
  raw_emit ("  texcoord 0.270386 0.388229")
  raw_emit ("  texcoord 0.634242 0.769040")
  raw_emit ("  texcoord 0.628822 0.769040")
  raw_emit ("  texcoord 0.627413 0.388229")
  raw_emit ("  texcoord 0.635651 0.388229")
  raw_emit ("  texcoord 0.717385 0.769040")
  raw_emit ("  texcoord 0.708402 0.769040")
  raw_emit ("  texcoord 0.715960 0.388229")
  raw_emit ("  texcoord 0.729614 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -8.500000 4.919998 2.835002")
  raw_emit ("  vertex -6.500000 4.919998 2.835002")
  raw_emit ("  vertex -6.500000 4.919998 2.585002")
  raw_emit ("  vertex -8.500000 4.919998 2.585002")
  raw_emit ("  vertex -8.500000 2.919998 2.585002")
  raw_emit ("  vertex -6.500000 2.919998 2.585002")
  raw_emit ("  vertex -6.500000 2.919998 2.835002")
  raw_emit ("  vertex -8.500000 2.919998 2.835002")
  raw_emit ("  texcoord 0.649070 0.391939")
  raw_emit ("  texcoord 0.613994 0.391939")
  raw_emit ("  texcoord 0.613994 0.379575")
  raw_emit ("  texcoord 0.649070 0.379575")
  raw_emit ("  texcoord 0.350930 0.379575")
  raw_emit ("  texcoord 0.386006 0.379575")
  raw_emit ("  texcoord 0.386006 0.391939")
  raw_emit ("  texcoord 0.350930 0.391939")
  raw_emit ("  texcoord 0.350930 0.256677")
  raw_emit ("  texcoord 0.386006 0.256677")
  raw_emit ("  texcoord 0.386006 0.355589")
  raw_emit ("  texcoord 0.350930 0.355589")
  raw_emit ("  texcoord 0.743323 0.379575")
  raw_emit ("  texcoord 0.743323 0.391939")
  raw_emit ("  texcoord 0.644411 0.391939")
  raw_emit ("  texcoord 0.644411 0.379575")
  raw_emit ("  texcoord 0.386006 0.743323")
  raw_emit ("  texcoord 0.350930 0.743323")
  raw_emit ("  texcoord 0.350930 0.644411")
  raw_emit ("  texcoord 0.386006 0.644411")
  raw_emit ("  texcoord 0.256677 0.391939")
  raw_emit ("  texcoord 0.256677 0.379575")
  raw_emit ("  texcoord 0.355589 0.379575")
  raw_emit ("  texcoord 0.355589 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -8.250000 4.669998 10.721587")
  raw_emit ("  vertex -6.750000 4.669998 10.721587")
  raw_emit ("  vertex -6.750000 4.669998 10.471587")
  raw_emit ("  vertex -8.250000 4.669998 10.471587")
  raw_emit ("  vertex -8.250000 3.169998 10.471587")
  raw_emit ("  vertex -6.750000 3.169998 10.471587")
  raw_emit ("  vertex -6.750000 3.169998 10.721587")
  raw_emit ("  vertex -8.250000 3.169998 10.721587")
  raw_emit ("  texcoord 0.644685 0.781978")
  raw_emit ("  texcoord 0.618379 0.781978")
  raw_emit ("  texcoord 0.618379 0.769614")
  raw_emit ("  texcoord 0.644685 0.769614")
  raw_emit ("  texcoord 0.355315 0.769614")
  raw_emit ("  texcoord 0.381621 0.769614")
  raw_emit ("  texcoord 0.381621 0.781978")
  raw_emit ("  texcoord 0.355315 0.781978")
  raw_emit ("  texcoord 0.381621 0.269041")
  raw_emit ("  texcoord 0.381621 0.343225")
  raw_emit ("  texcoord 0.355315 0.343225")
  raw_emit ("  texcoord 0.355315 0.269041")
  raw_emit ("  texcoord 0.730959 0.769614")
  raw_emit ("  texcoord 0.730959 0.781978")
  raw_emit ("  texcoord 0.656775 0.781978")
  raw_emit ("  texcoord 0.656775 0.769614")
  raw_emit ("  texcoord 0.381621 0.730959")
  raw_emit ("  texcoord 0.355315 0.730959")
  raw_emit ("  texcoord 0.355315 0.656775")
  raw_emit ("  texcoord 0.381621 0.656775")
  raw_emit ("  texcoord 0.269041 0.781978")
  raw_emit ("  texcoord 0.269041 0.769614")
  raw_emit ("  texcoord 0.343225 0.769614")
  raw_emit ("  texcoord 0.343225 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
    Call TempleSub3
End Sub

Sub TempleSub3()
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex -2.095491 4.213891 10.459996")
  raw_emit ("  vertex -2.345491 4.395526 10.459996")
  raw_emit ("  vertex -2.654509 4.395526 10.459996")
  raw_emit ("  vertex -2.904509 4.213891 10.459996")
  raw_emit ("  vertex -3.000000 3.919998 10.459996")
  raw_emit ("  vertex -2.904509 3.626106 10.459996")
  raw_emit ("  vertex -2.654509 3.444470 10.459996")
  raw_emit ("  vertex -2.345491 3.444470 10.459996")
  raw_emit ("  vertex -2.095491 3.626106 10.459996")
  raw_emit ("  vertex -2.000000 3.919998 10.459996")
  raw_emit ("  vertex -3.114853 3.473282 2.760002")
  raw_emit ("  vertex -3.260000 3.919998 2.760001")
  raw_emit ("  vertex -3.114853 4.366715 2.760001")
  raw_emit ("  vertex -2.734853 4.642801 2.760002")
  raw_emit ("  vertex -2.265147 4.642801 2.760002")
  raw_emit ("  vertex -1.885147 4.366715 2.760001")
  raw_emit ("  vertex -1.740000 3.919998 2.760001")
  raw_emit ("  vertex -1.885147 3.473282 2.760002")
  raw_emit ("  vertex -2.265147 3.197196 2.760002")
  raw_emit ("  vertex -2.734853 3.197196 2.760002")
  raw_emit ("  texcoord 0.463250 0.708402")
  raw_emit ("  texcoord 0.458866 0.717385")
  raw_emit ("  texcoord 0.453446 0.717385")
  raw_emit ("  texcoord 0.449062 0.708402")
  raw_emit ("  texcoord 0.447387 0.693867")
  raw_emit ("  texcoord 0.449062 0.679333")
  raw_emit ("  texcoord 0.453446 0.670350")
  raw_emit ("  texcoord 0.458866 0.670350")
  raw_emit ("  texcoord 0.463250 0.679333")
  raw_emit ("  texcoord 0.464925 0.693867")
  raw_emit ("  texcoord 0.445373 0.328225")
  raw_emit ("  texcoord 0.442827 0.306133")
  raw_emit ("  texcoord 0.445373 0.284040")
  raw_emit ("  texcoord 0.452037 0.270386")
  raw_emit ("  texcoord 0.460275 0.270386")
  raw_emit ("  texcoord 0.466939 0.284040")
  raw_emit ("  texcoord 0.469485 0.306133")
  raw_emit ("  texcoord 0.466939 0.328225")
  raw_emit ("  texcoord 0.460275 0.341879")
  raw_emit ("  texcoord 0.452037 0.341879")
  raw_emit ("  texcoord 0.693867 0.769040")
  raw_emit ("  texcoord 0.679333 0.769040")
  raw_emit ("  texcoord 0.671775 0.388229")
  raw_emit ("  texcoord 0.693867 0.388229")
  raw_emit ("  texcoord 0.670350 0.769040")
  raw_emit ("  texcoord 0.658121 0.388229")
  raw_emit ("  texcoord 0.460275 0.388229")
  raw_emit ("  texcoord 0.458866 0.769040")
  raw_emit ("  texcoord 0.453446 0.769040")
  raw_emit ("  texcoord 0.452037 0.388229")
  raw_emit ("  texcoord 0.329650 0.769040")
  raw_emit ("  texcoord 0.320667 0.769040")
  raw_emit ("  texcoord 0.328225 0.388229")
  raw_emit ("  texcoord 0.341879 0.388229")
  raw_emit ("  texcoord 0.306133 0.769040")
  raw_emit ("  texcoord 0.306133 0.388229")
  raw_emit ("  texcoord 0.291598 0.769040")
  raw_emit ("  texcoord 0.284040 0.388229")
  raw_emit ("  texcoord 0.282615 0.769040")
  raw_emit ("  texcoord 0.270386 0.388229")
  raw_emit ("  texcoord 0.546554 0.769040")
  raw_emit ("  texcoord 0.541134 0.769040")
  raw_emit ("  texcoord 0.539725 0.388229")
  raw_emit ("  texcoord 0.547963 0.388229")
  raw_emit ("  texcoord 0.717385 0.769040")
  raw_emit ("  texcoord 0.708402 0.769040")
  raw_emit ("  texcoord 0.715960 0.388229")
  raw_emit ("  texcoord 0.729614 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -3.500000 4.919998 2.835002")
  raw_emit ("  vertex -1.500000 4.919998 2.835002")
  raw_emit ("  vertex -1.500000 4.919998 2.585002")
  raw_emit ("  vertex -3.500000 4.919998 2.585002")
  raw_emit ("  vertex -3.500000 2.919998 2.585002")
  raw_emit ("  vertex -1.500000 2.919998 2.585002")
  raw_emit ("  vertex -1.500000 2.919998 2.835002")
  raw_emit ("  vertex -3.500000 2.919998 2.835002")
  raw_emit ("  texcoord 0.561382 0.391939")
  raw_emit ("  texcoord 0.526306 0.391939")
  raw_emit ("  texcoord 0.526306 0.379575")
  raw_emit ("  texcoord 0.561382 0.379575")
  raw_emit ("  texcoord 0.438618 0.379575")
  raw_emit ("  texcoord 0.473694 0.379575")
  raw_emit ("  texcoord 0.473694 0.391939")
  raw_emit ("  texcoord 0.438618 0.391939")
  raw_emit ("  texcoord 0.438618 0.256677")
  raw_emit ("  texcoord 0.473694 0.256677")
  raw_emit ("  texcoord 0.473694 0.355589")
  raw_emit ("  texcoord 0.438618 0.355589")
  raw_emit ("  texcoord 0.743323 0.379575")
  raw_emit ("  texcoord 0.743323 0.391939")
  raw_emit ("  texcoord 0.644411 0.391939")
  raw_emit ("  texcoord 0.644411 0.379575")
  raw_emit ("  texcoord 0.473694 0.743323")
  raw_emit ("  texcoord 0.438618 0.743323")
  raw_emit ("  texcoord 0.438618 0.644411")
  raw_emit ("  texcoord 0.473694 0.644411")
  raw_emit ("  texcoord 0.256677 0.391939")
  raw_emit ("  texcoord 0.256677 0.379575")
  raw_emit ("  texcoord 0.355589 0.379575")
  raw_emit ("  texcoord 0.355589 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -3.250000 4.669998 10.721587")
  raw_emit ("  vertex -1.750000 4.669998 10.721587")
  raw_emit ("  vertex -1.750000 4.669998 10.471587")
  raw_emit ("  vertex -3.250000 4.669998 10.471587")
  raw_emit ("  vertex -3.250000 3.169998 10.471587")
  raw_emit ("  vertex -1.750000 3.169998 10.471587")
  raw_emit ("  vertex -1.750000 3.169998 10.721587")
  raw_emit ("  vertex -3.250000 3.169998 10.721587")
  raw_emit ("  texcoord 0.556997 0.781978")
  raw_emit ("  texcoord 0.530691 0.781978")
  raw_emit ("  texcoord 0.530691 0.769614")
  raw_emit ("  texcoord 0.556997 0.769614")
  raw_emit ("  texcoord 0.443003 0.769614")
  raw_emit ("  texcoord 0.469309 0.769614")
  raw_emit ("  texcoord 0.469309 0.781978")
  raw_emit ("  texcoord 0.443003 0.781978")
  raw_emit ("  texcoord 0.469309 0.269041")
  raw_emit ("  texcoord 0.469309 0.343225")
  raw_emit ("  texcoord 0.443003 0.343225")
  raw_emit ("  texcoord 0.443003 0.269041")
  raw_emit ("  texcoord 0.730959 0.769614")
  raw_emit ("  texcoord 0.730959 0.781978")
  raw_emit ("  texcoord 0.656775 0.781978")
  raw_emit ("  texcoord 0.656775 0.769614")
  raw_emit ("  texcoord 0.469309 0.730959")
  raw_emit ("  texcoord 0.443003 0.730959")
  raw_emit ("  texcoord 0.443003 0.656775")
  raw_emit ("  texcoord 0.469309 0.656775")
  raw_emit ("  texcoord 0.269041 0.781978")
  raw_emit ("  texcoord 0.269041 0.769614")
  raw_emit ("  texcoord 0.343225 0.769614")
  raw_emit ("  texcoord 0.343225 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex 2.904509 4.213891 10.459996")
  raw_emit ("  vertex 2.654509 4.395526 10.459996")
  raw_emit ("  vertex 2.345491 4.395526 10.459996")
  raw_emit ("  vertex 2.095491 4.213891 10.459996")
  raw_emit ("  vertex 2.000000 3.919998 10.459996")
  raw_emit ("  vertex 2.095491 3.626106 10.459996")
  raw_emit ("  vertex 2.345491 3.444470 10.459996")
  raw_emit ("  vertex 2.654509 3.444470 10.459996")
  raw_emit ("  vertex 2.904509 3.626106 10.459996")
  raw_emit ("  vertex 3.000000 3.919998 10.459996")
  raw_emit ("  vertex 1.885147 3.473282 2.760002")
  raw_emit ("  vertex 1.740000 3.919998 2.760001")
  raw_emit ("  vertex 1.885147 4.366715 2.760001")
  raw_emit ("  vertex 2.265146 4.642801 2.760002")
  raw_emit ("  vertex 2.734854 4.642801 2.760002")
  raw_emit ("  vertex 3.114853 4.366715 2.760001")
  raw_emit ("  vertex 3.260000 3.919998 2.760001")
  raw_emit ("  vertex 3.114853 3.473282 2.760002")
  raw_emit ("  vertex 2.734854 3.197196 2.760002")
  raw_emit ("  vertex 2.265146 3.197196 2.760002")
  raw_emit ("  texcoord 0.550938 0.708402")
  raw_emit ("  texcoord 0.546554 0.717385")
  raw_emit ("  texcoord 0.541134 0.717385")
  raw_emit ("  texcoord 0.536750 0.708402")
  raw_emit ("  texcoord 0.535075 0.693867")
  raw_emit ("  texcoord 0.536750 0.679333")
  raw_emit ("  texcoord 0.541134 0.670350")
  raw_emit ("  texcoord 0.546554 0.670350")
  raw_emit ("  texcoord 0.550938 0.679333")
  raw_emit ("  texcoord 0.552613 0.693867")
  raw_emit ("  texcoord 0.533061 0.328225")
  raw_emit ("  texcoord 0.530515 0.306133")
  raw_emit ("  texcoord 0.533061 0.284040")
  raw_emit ("  texcoord 0.539725 0.270386")
  raw_emit ("  texcoord 0.547963 0.270386")
  raw_emit ("  texcoord 0.554627 0.284040")
  raw_emit ("  texcoord 0.557173 0.306133")
  raw_emit ("  texcoord 0.554627 0.328225")
  raw_emit ("  texcoord 0.547963 0.341879")
  raw_emit ("  texcoord 0.539725 0.341879")
  raw_emit ("  texcoord 0.693867 0.769040")
  raw_emit ("  texcoord 0.679333 0.769040")
  raw_emit ("  texcoord 0.671775 0.388229")
  raw_emit ("  texcoord 0.693867 0.388229")
  raw_emit ("  texcoord 0.670350 0.769040")
  raw_emit ("  texcoord 0.658121 0.388229")
  raw_emit ("  texcoord 0.547963 0.388229")
  raw_emit ("  texcoord 0.546554 0.769040")
  raw_emit ("  texcoord 0.541134 0.769040")
  raw_emit ("  texcoord 0.539725 0.388229")
  raw_emit ("  texcoord 0.329650 0.769040")
  raw_emit ("  texcoord 0.320667 0.769040")
  raw_emit ("  texcoord 0.328225 0.388229")
  raw_emit ("  texcoord 0.341879 0.388229")
  raw_emit ("  texcoord 0.306133 0.769040")
  raw_emit ("  texcoord 0.306133 0.388229")
  raw_emit ("  texcoord 0.291598 0.769040")
  raw_emit ("  texcoord 0.284040 0.388229")
  raw_emit ("  texcoord 0.282615 0.769040")
  raw_emit ("  texcoord 0.270386 0.388229")
  raw_emit ("  texcoord 0.458866 0.769040")
  raw_emit ("  texcoord 0.453446 0.769040")
  raw_emit ("  texcoord 0.452037 0.388229")
  raw_emit ("  texcoord 0.460275 0.388229")
  raw_emit ("  texcoord 0.717385 0.769040")
  raw_emit ("  texcoord 0.708402 0.769040")
  raw_emit ("  texcoord 0.715960 0.388229")
  raw_emit ("  texcoord 0.729614 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  Call TempleSub4
End Sub

Sub TempleSub4()
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 1.500000 4.919998 2.835002")
  raw_emit ("  vertex 3.500000 4.919998 2.835002")
  raw_emit ("  vertex 3.500000 4.919998 2.585002")
  raw_emit ("  vertex 1.500000 4.919998 2.585002")
  raw_emit ("  vertex 1.500000 2.919998 2.585002")
  raw_emit ("  vertex 3.500000 2.919998 2.585002")
  raw_emit ("  vertex 3.500000 2.919998 2.835002")
  raw_emit ("  vertex 1.500000 2.919998 2.835002")
  raw_emit ("  texcoord 0.473694 0.391939")
  raw_emit ("  texcoord 0.438618 0.391939")
  raw_emit ("  texcoord 0.438618 0.379575")
  raw_emit ("  texcoord 0.473694 0.379575")
  raw_emit ("  texcoord 0.526306 0.379575")
  raw_emit ("  texcoord 0.561382 0.379575")
  raw_emit ("  texcoord 0.561382 0.391939")
  raw_emit ("  texcoord 0.526306 0.391939")
  raw_emit ("  texcoord 0.526306 0.256677")
  raw_emit ("  texcoord 0.561382 0.256677")
  raw_emit ("  texcoord 0.561382 0.355589")
  raw_emit ("  texcoord 0.526306 0.355589")
  raw_emit ("  texcoord 0.743323 0.379575")
  raw_emit ("  texcoord 0.743323 0.391939")
  raw_emit ("  texcoord 0.644411 0.391939")
  raw_emit ("  texcoord 0.644411 0.379575")
  raw_emit ("  texcoord 0.561382 0.743323")
  raw_emit ("  texcoord 0.526306 0.743323")
  raw_emit ("  texcoord 0.526306 0.644411")
  raw_emit ("  texcoord 0.561382 0.644411")
  raw_emit ("  texcoord 0.256677 0.391939")
  raw_emit ("  texcoord 0.256677 0.379575")
  raw_emit ("  texcoord 0.355589 0.379575")
  raw_emit ("  texcoord 0.355589 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 1.750000 4.669998 10.721587")
  raw_emit ("  vertex 3.250000 4.669998 10.721587")
  raw_emit ("  vertex 3.250000 4.669998 10.471587")
  raw_emit ("  vertex 1.750000 4.669998 10.471587")
  raw_emit ("  vertex 1.750000 3.169998 10.471587")
  raw_emit ("  vertex 3.250000 3.169998 10.471587")
  raw_emit ("  vertex 3.250000 3.169998 10.721587")
  raw_emit ("  vertex 1.750000 3.169998 10.721587")
  raw_emit ("  texcoord 0.469309 0.781978")
  raw_emit ("  texcoord 0.443003 0.781978")
  raw_emit ("  texcoord 0.443003 0.769614")
  raw_emit ("  texcoord 0.469309 0.769614")
  raw_emit ("  texcoord 0.530691 0.769614")
  raw_emit ("  texcoord 0.556997 0.769614")
  raw_emit ("  texcoord 0.556997 0.781978")
  raw_emit ("  texcoord 0.530691 0.781978")
  raw_emit ("  texcoord 0.556997 0.269041")
  raw_emit ("  texcoord 0.556997 0.343225")
  raw_emit ("  texcoord 0.530691 0.343225")
  raw_emit ("  texcoord 0.530691 0.269041")
  raw_emit ("  texcoord 0.730959 0.769614")
  raw_emit ("  texcoord 0.730959 0.781978")
  raw_emit ("  texcoord 0.656775 0.781978")
  raw_emit ("  texcoord 0.656775 0.769614")
  raw_emit ("  texcoord 0.556997 0.730959")
  raw_emit ("  texcoord 0.530691 0.730959")
  raw_emit ("  texcoord 0.530691 0.656775")
  raw_emit ("  texcoord 0.556997 0.656775")
  raw_emit ("  texcoord 0.269041 0.781978")
  raw_emit ("  texcoord 0.269041 0.769614")
  raw_emit ("  texcoord 0.343225 0.769614")
  raw_emit ("  texcoord 0.343225 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex 7.904509 4.213891 10.459996")
  raw_emit ("  vertex 7.654509 4.395526 10.459996")
  raw_emit ("  vertex 7.345491 4.395526 10.459996")
  raw_emit ("  vertex 7.095491 4.213891 10.459996")
  raw_emit ("  vertex 7.000000 3.919998 10.459996")
  raw_emit ("  vertex 7.095491 3.626106 10.459996")
  raw_emit ("  vertex 7.345491 3.444470 10.459996")
  raw_emit ("  vertex 7.654509 3.444470 10.459996")
  raw_emit ("  vertex 7.904509 3.626106 10.459996")
  raw_emit ("  vertex 8.000000 3.919998 10.459996")
  raw_emit ("  vertex 6.885147 3.473282 2.760002")
  raw_emit ("  vertex 6.740000 3.919998 2.760001")
  raw_emit ("  vertex 6.885147 4.366715 2.760001")
  raw_emit ("  vertex 7.265146 4.642801 2.760002")
  raw_emit ("  vertex 7.734854 4.642801 2.760002")
  raw_emit ("  vertex 8.114853 4.366715 2.760001")
  raw_emit ("  vertex 8.260000 3.919998 2.760001")
  raw_emit ("  vertex 8.114853 3.473282 2.760002")
  raw_emit ("  vertex 7.734854 3.197196 2.760002")
  raw_emit ("  vertex 7.265146 3.197196 2.760002")
  raw_emit ("  texcoord 0.638626 0.708402")
  raw_emit ("  texcoord 0.634242 0.717385")
  raw_emit ("  texcoord 0.628822 0.717385")
  raw_emit ("  texcoord 0.624438 0.708402")
  raw_emit ("  texcoord 0.622763 0.693867")
  raw_emit ("  texcoord 0.624438 0.679333")
  raw_emit ("  texcoord 0.628822 0.670350")
  raw_emit ("  texcoord 0.634242 0.670350")
  raw_emit ("  texcoord 0.638626 0.679333")
  raw_emit ("  texcoord 0.640301 0.693867")
  raw_emit ("  texcoord 0.620749 0.328225")
  raw_emit ("  texcoord 0.618203 0.306133")
  raw_emit ("  texcoord 0.620749 0.284040")
  raw_emit ("  texcoord 0.627413 0.270386")
  raw_emit ("  texcoord 0.635651 0.270386")
  raw_emit ("  texcoord 0.642315 0.284040")
  raw_emit ("  texcoord 0.644861 0.306133")
  raw_emit ("  texcoord 0.642315 0.328225")
  raw_emit ("  texcoord 0.635651 0.341879")
  raw_emit ("  texcoord 0.627413 0.341879")
  raw_emit ("  texcoord 0.693867 0.769040")
  raw_emit ("  texcoord 0.679333 0.769040")
  raw_emit ("  texcoord 0.671775 0.388229")
  raw_emit ("  texcoord 0.693867 0.388229")
  raw_emit ("  texcoord 0.670350 0.769040")
  raw_emit ("  texcoord 0.658121 0.388229")
  raw_emit ("  texcoord 0.635651 0.388229")
  raw_emit ("  texcoord 0.634242 0.769040")
  raw_emit ("  texcoord 0.628822 0.769040")
  raw_emit ("  texcoord 0.627413 0.388229")
  raw_emit ("  texcoord 0.329650 0.769040")
  raw_emit ("  texcoord 0.320667 0.769040")
  raw_emit ("  texcoord 0.328225 0.388229")
  raw_emit ("  texcoord 0.341879 0.388229")
  raw_emit ("  texcoord 0.306133 0.769040")
  raw_emit ("  texcoord 0.306133 0.388229")
  raw_emit ("  texcoord 0.291598 0.769040")
  raw_emit ("  texcoord 0.284040 0.388229")
  raw_emit ("  texcoord 0.282615 0.769040")
  raw_emit ("  texcoord 0.270386 0.388229")
  raw_emit ("  texcoord 0.371178 0.769040")
  raw_emit ("  texcoord 0.365758 0.769040")
  raw_emit ("  texcoord 0.364349 0.388229")
  raw_emit ("  texcoord 0.372587 0.388229")
  raw_emit ("  texcoord 0.717385 0.769040")
  raw_emit ("  texcoord 0.708402 0.769040")
  raw_emit ("  texcoord 0.715960 0.388229")
  raw_emit ("  texcoord 0.729614 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 6.500000 4.919998 2.835002")
  raw_emit ("  vertex 8.500000 4.919998 2.835002")
  raw_emit ("  vertex 8.500000 4.919998 2.585002")
  raw_emit ("  vertex 6.500000 4.919998 2.585002")
  raw_emit ("  vertex 6.500000 2.919998 2.585002")
  raw_emit ("  vertex 8.500000 2.919998 2.585002")
  raw_emit ("  vertex 8.500000 2.919998 2.835002")
  raw_emit ("  vertex 6.500000 2.919998 2.835002")
  raw_emit ("  texcoord 0.386006 0.391939")
  raw_emit ("  texcoord 0.350930 0.391939")
  raw_emit ("  texcoord 0.350930 0.379575")
  raw_emit ("  texcoord 0.386006 0.379575")
  raw_emit ("  texcoord 0.613994 0.379575")
  raw_emit ("  texcoord 0.649070 0.379575")
  raw_emit ("  texcoord 0.649070 0.391939")
  raw_emit ("  texcoord 0.613994 0.391939")
  raw_emit ("  texcoord 0.613994 0.256677")
  raw_emit ("  texcoord 0.649070 0.256677")
  raw_emit ("  texcoord 0.649070 0.355589")
  raw_emit ("  texcoord 0.613994 0.355589")
  raw_emit ("  texcoord 0.743323 0.379575")
  raw_emit ("  texcoord 0.743323 0.391939")
  raw_emit ("  texcoord 0.644411 0.391939")
  raw_emit ("  texcoord 0.644411 0.379575")
  raw_emit ("  texcoord 0.649070 0.743323")
  raw_emit ("  texcoord 0.613994 0.743323")
  raw_emit ("  texcoord 0.613994 0.644411")
  raw_emit ("  texcoord 0.649070 0.644411")
  raw_emit ("  texcoord 0.256677 0.391939")
  raw_emit ("  texcoord 0.256677 0.379575")
  raw_emit ("  texcoord 0.355589 0.379575")
  raw_emit ("  texcoord 0.355589 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 6.750000 4.669998 10.721587")
  raw_emit ("  vertex 8.250000 4.669998 10.721587")
  raw_emit ("  vertex 8.250000 4.669998 10.471587")
  raw_emit ("  vertex 6.750000 4.669998 10.471587")
  raw_emit ("  vertex 6.750000 3.169998 10.471587")
  raw_emit ("  vertex 8.250000 3.169998 10.471587")
  raw_emit ("  vertex 8.250000 3.169998 10.721587")
  raw_emit ("  vertex 6.750000 3.169998 10.721587")
  raw_emit ("  texcoord 0.381621 0.781978")
  raw_emit ("  texcoord 0.355315 0.781978")
  raw_emit ("  texcoord 0.355315 0.769614")
  raw_emit ("  texcoord 0.381621 0.769614")
  raw_emit ("  texcoord 0.618379 0.769614")
  raw_emit ("  texcoord 0.644685 0.769614")
  raw_emit ("  texcoord 0.644685 0.781978")
  raw_emit ("  texcoord 0.618379 0.781978")
  raw_emit ("  texcoord 0.644685 0.269041")
  raw_emit ("  texcoord 0.644685 0.343225")
  raw_emit ("  texcoord 0.618379 0.343225")
  raw_emit ("  texcoord 0.618379 0.269041")
  raw_emit ("  texcoord 0.730959 0.769614")
  raw_emit ("  texcoord 0.730959 0.781978")
  raw_emit ("  texcoord 0.656775 0.781978")
  raw_emit ("  texcoord 0.656775 0.769614")
  raw_emit ("  texcoord 0.644685 0.730959")
  raw_emit ("  texcoord 0.618379 0.730959")
  raw_emit ("  texcoord 0.618379 0.656775")
  raw_emit ("  texcoord 0.644685 0.656775")
  raw_emit ("  texcoord 0.269041 0.781978")
  raw_emit ("  texcoord 0.269041 0.769614")
  raw_emit ("  texcoord 0.343225 0.769614")
  raw_emit ("  texcoord 0.343225 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex 12.904509 4.213891 10.459996")
  raw_emit ("  vertex 12.654509 4.395526 10.459996")
  raw_emit ("  vertex 12.345491 4.395526 10.459996")
  raw_emit ("  vertex 12.095491 4.213891 10.459996")
  raw_emit ("  vertex 12.000000 3.919998 10.459996")
  raw_emit ("  vertex 12.095491 3.626106 10.459996")
  raw_emit ("  vertex 12.345491 3.444470 10.459996")
  raw_emit ("  vertex 12.654509 3.444470 10.459996")
  raw_emit ("  vertex 12.904509 3.626106 10.459996")
  raw_emit ("  vertex 13.000000 3.919998 10.459996")
  raw_emit ("  vertex 11.885147 3.473282 2.760002")
  raw_emit ("  vertex 11.740000 3.919998 2.760001")
  raw_emit ("  vertex 11.885147 4.366715 2.760001")
  raw_emit ("  vertex 12.265146 4.642801 2.760002")
  raw_emit ("  vertex 12.734854 4.642801 2.760002")
  raw_emit ("  vertex 13.114853 4.366715 2.760001")
  raw_emit ("  vertex 13.260000 3.919998 2.760001")
  raw_emit ("  vertex 13.114853 3.473282 2.760002")
  raw_emit ("  vertex 12.734854 3.197196 2.760002")
  raw_emit ("  vertex 12.265146 3.197196 2.760002")
  raw_emit ("  texcoord 0.726314 0.708402")
  raw_emit ("  texcoord 0.721930 0.717385")
  raw_emit ("  texcoord 0.716510 0.717385")
  raw_emit ("  texcoord 0.712126 0.708402")
  raw_emit ("  texcoord 0.710451 0.693867")
  raw_emit ("  texcoord 0.712126 0.679333")
  raw_emit ("  texcoord 0.716510 0.670350")
  raw_emit ("  texcoord 0.721930 0.670350")
  raw_emit ("  texcoord 0.726314 0.679333")
  raw_emit ("  texcoord 0.727989 0.693867")
  raw_emit ("  texcoord 0.708437 0.328225")
  raw_emit ("  texcoord 0.705891 0.306133")
  raw_emit ("  texcoord 0.708437 0.284040")
  raw_emit ("  texcoord 0.715101 0.270386")
  raw_emit ("  texcoord 0.723339 0.270386")
  raw_emit ("  texcoord 0.730003 0.284040")
  raw_emit ("  texcoord 0.732549 0.306133")
  raw_emit ("  texcoord 0.730003 0.328225")
  raw_emit ("  texcoord 0.723339 0.341879")
  raw_emit ("  texcoord 0.715101 0.341879")
  raw_emit ("  texcoord 0.693867 0.769040")
  raw_emit ("  texcoord 0.679333 0.769040")
  raw_emit ("  texcoord 0.671775 0.388229")
  raw_emit ("  texcoord 0.693867 0.388229")
  raw_emit ("  texcoord 0.670350 0.769040")
  raw_emit ("  texcoord 0.658121 0.388229")
  raw_emit ("  texcoord 0.723339 0.388229")
  raw_emit ("  texcoord 0.721930 0.769040")
  raw_emit ("  texcoord 0.716510 0.769040")
  raw_emit ("  texcoord 0.715101 0.388229")
  raw_emit ("  texcoord 0.329650 0.769040")
  raw_emit ("  texcoord 0.320667 0.769040")
  raw_emit ("  texcoord 0.328225 0.388229")
  raw_emit ("  texcoord 0.341879 0.388229")
  raw_emit ("  texcoord 0.306133 0.769040")
  raw_emit ("  texcoord 0.306133 0.388229")
  raw_emit ("  texcoord 0.291598 0.769040")
  raw_emit ("  texcoord 0.284040 0.388229")
  raw_emit ("  texcoord 0.282615 0.769040")
  raw_emit ("  texcoord 0.270386 0.388229")
  raw_emit ("  texcoord 0.283490 0.769040")
  raw_emit ("  texcoord 0.278070 0.769040")
  raw_emit ("  texcoord 0.276661 0.388229")
  raw_emit ("  texcoord 0.284899 0.388229")
  raw_emit ("  texcoord 0.717385 0.769040")
  raw_emit ("  texcoord 0.708402 0.769040")
  raw_emit ("  texcoord 0.715960 0.388229")
  raw_emit ("  texcoord 0.729614 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  Call TempleSub5
End Sub
Sub TempleSub5()
  
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 11.500000 4.919998 2.835002")
  raw_emit ("  vertex 13.500000 4.919998 2.835002")
  raw_emit ("  vertex 13.500000 4.919998 2.585002")
  raw_emit ("  vertex 11.500000 4.919998 2.585002")
  raw_emit ("  vertex 11.500000 2.919998 2.585002")
  raw_emit ("  vertex 13.500000 2.919998 2.585002")
  raw_emit ("  vertex 13.500000 2.919998 2.835002")
  raw_emit ("  vertex 11.500000 2.919998 2.835002")
  raw_emit ("  texcoord 0.298318 0.391939")
  raw_emit ("  texcoord 0.263242 0.391939")
  raw_emit ("  texcoord 0.263242 0.379575")
  raw_emit ("  texcoord 0.298318 0.379575")
  raw_emit ("  texcoord 0.701682 0.379575")
  raw_emit ("  texcoord 0.736758 0.379575")
  raw_emit ("  texcoord 0.736758 0.391939")
  raw_emit ("  texcoord 0.701682 0.391939")
  raw_emit ("  texcoord 0.701682 0.256677")
  raw_emit ("  texcoord 0.736758 0.256677")
  raw_emit ("  texcoord 0.736758 0.355589")
  raw_emit ("  texcoord 0.701682 0.355589")
  raw_emit ("  texcoord 0.743323 0.379575")
  raw_emit ("  texcoord 0.743323 0.391939")
  raw_emit ("  texcoord 0.644411 0.391939")
  raw_emit ("  texcoord 0.644411 0.379575")
  raw_emit ("  texcoord 0.736758 0.743323")
  raw_emit ("  texcoord 0.701682 0.743323")
  raw_emit ("  texcoord 0.701682 0.644411")
  raw_emit ("  texcoord 0.736758 0.644411")
  raw_emit ("  texcoord 0.256677 0.391939")
  raw_emit ("  texcoord 0.256677 0.379575")
  raw_emit ("  texcoord 0.355589 0.379575")
  raw_emit ("  texcoord 0.355589 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 11.750000 4.669998 10.721587")
  raw_emit ("  vertex 13.250000 4.669998 10.721587")
  raw_emit ("  vertex 13.250000 4.669998 10.471587")
  raw_emit ("  vertex 11.750000 4.669998 10.471587")
  raw_emit ("  vertex 11.750000 3.169998 10.471587")
  raw_emit ("  vertex 13.250000 3.169998 10.471587")
  raw_emit ("  vertex 13.250000 3.169998 10.721587")
  raw_emit ("  vertex 11.750000 3.169998 10.721587")
  raw_emit ("  texcoord 0.293933 0.781978")
  raw_emit ("  texcoord 0.267627 0.781978")
  raw_emit ("  texcoord 0.267627 0.769614")
  raw_emit ("  texcoord 0.293933 0.769614")
  raw_emit ("  texcoord 0.706067 0.769614")
  raw_emit ("  texcoord 0.732373 0.769614")
  raw_emit ("  texcoord 0.732373 0.781978")
  raw_emit ("  texcoord 0.706067 0.781978")
  raw_emit ("  texcoord 0.732373 0.269041")
  raw_emit ("  texcoord 0.732373 0.343225")
  raw_emit ("  texcoord 0.706067 0.343225")
  raw_emit ("  texcoord 0.706067 0.269041")
  raw_emit ("  texcoord 0.730959 0.769614")
  raw_emit ("  texcoord 0.730959 0.781978")
  raw_emit ("  texcoord 0.656775 0.781978")
  raw_emit ("  texcoord 0.656775 0.769614")
  raw_emit ("  texcoord 0.732373 0.730959")
  raw_emit ("  texcoord 0.706067 0.730959")
  raw_emit ("  texcoord 0.706067 0.656775")
  raw_emit ("  texcoord 0.732373 0.656775")
  raw_emit ("  texcoord 0.269041 0.781978")
  raw_emit ("  texcoord 0.269041 0.769614")
  raw_emit ("  texcoord 0.343225 0.769614")
  raw_emit ("  texcoord 0.343225 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex 17.904510 4.213891 10.459996")
  raw_emit ("  vertex 17.654507 4.395526 10.459996")
  raw_emit ("  vertex 17.345493 4.395526 10.459996")
  raw_emit ("  vertex 17.095493 4.213891 10.459996")
  raw_emit ("  vertex 17.000000 3.919998 10.459996")
  raw_emit ("  vertex 17.095493 3.626106 10.459996")
  raw_emit ("  vertex 17.345493 3.444470 10.459996")
  raw_emit ("  vertex 17.654507 3.444470 10.459996")
  raw_emit ("  vertex 17.904507 3.626106 10.459996")
  raw_emit ("  vertex 18.000000 3.919998 10.459996")
  raw_emit ("  vertex 16.885147 3.473282 2.760002")
  raw_emit ("  vertex 16.740002 3.919998 2.760001")
  raw_emit ("  vertex 16.885147 4.366715 2.760001")
  raw_emit ("  vertex 17.265148 4.642801 2.760002")
  raw_emit ("  vertex 17.734852 4.642801 2.760002")
  raw_emit ("  vertex 18.114853 4.366715 2.760001")
  raw_emit ("  vertex 18.259998 3.919998 2.760001")
  raw_emit ("  vertex 18.114853 3.473282 2.760002")
  raw_emit ("  vertex 17.734852 3.197196 2.760002")
  raw_emit ("  vertex 17.265148 3.197196 2.760002")
  raw_emit ("  texcoord 0.814002 0.708402")
  raw_emit ("  texcoord 0.809618 0.717385")
  raw_emit ("  texcoord 0.804198 0.717385")
  raw_emit ("  texcoord 0.799814 0.708402")
  raw_emit ("  texcoord 0.798139 0.693867")
  raw_emit ("  texcoord 0.799814 0.679333")
  raw_emit ("  texcoord 0.804198 0.670350")
  raw_emit ("  texcoord 0.809618 0.670350")
  raw_emit ("  texcoord 0.814002 0.679333")
  raw_emit ("  texcoord 0.815677 0.693867")
  raw_emit ("  texcoord 0.796125 0.328225")
  raw_emit ("  texcoord 0.793579 0.306133")
  raw_emit ("  texcoord 0.796125 0.284040")
  raw_emit ("  texcoord 0.802789 0.270386")
  raw_emit ("  texcoord 0.811027 0.270386")
  raw_emit ("  texcoord 0.817691 0.284040")
  raw_emit ("  texcoord 0.820237 0.306133")
  raw_emit ("  texcoord 0.817691 0.328225")
  raw_emit ("  texcoord 0.811027 0.341879")
  raw_emit ("  texcoord 0.802789 0.341879")
  raw_emit ("  texcoord 0.693867 0.769040")
  raw_emit ("  texcoord 0.679333 0.769040")
  raw_emit ("  texcoord 0.671775 0.388229")
  raw_emit ("  texcoord 0.693867 0.388229")
  raw_emit ("  texcoord 0.670350 0.769040")
  raw_emit ("  texcoord 0.658121 0.388229")
  raw_emit ("  texcoord 0.811027 0.388229")
  raw_emit ("  texcoord 0.809618 0.769040")
  raw_emit ("  texcoord 0.804198 0.769040")
  raw_emit ("  texcoord 0.802789 0.388229")
  raw_emit ("  texcoord 0.329650 0.769040")
  raw_emit ("  texcoord 0.320667 0.769040")
  raw_emit ("  texcoord 0.328225 0.388229")
  raw_emit ("  texcoord 0.341879 0.388229")
  raw_emit ("  texcoord 0.306133 0.769040")
  raw_emit ("  texcoord 0.306133 0.388229")
  raw_emit ("  texcoord 0.291598 0.769040")
  raw_emit ("  texcoord 0.284040 0.388229")
  raw_emit ("  texcoord 0.282615 0.769040")
  raw_emit ("  texcoord 0.270386 0.388229")
  raw_emit ("  texcoord 0.195802 0.769040")
  raw_emit ("  texcoord 0.190382 0.769040")
  raw_emit ("  texcoord 0.188973 0.388229")
  raw_emit ("  texcoord 0.197211 0.388229")
  raw_emit ("  texcoord 0.717385 0.769040")
  raw_emit ("  texcoord 0.708402 0.769040")
  raw_emit ("  texcoord 0.715960 0.388229")
  raw_emit ("  texcoord 0.729614 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 16.500000 4.919998 2.835002")
  raw_emit ("  vertex 18.500000 4.919998 2.835002")
  raw_emit ("  vertex 18.500000 4.919998 2.585002")
  raw_emit ("  vertex 16.500000 4.919998 2.585002")
  raw_emit ("  vertex 16.500000 2.919998 2.585002")
  raw_emit ("  vertex 18.500000 2.919998 2.585002")
  raw_emit ("  vertex 18.500000 2.919998 2.835002")
  raw_emit ("  vertex 16.500000 2.919998 2.835002")
  raw_emit ("  texcoord 0.210630 0.391939")
  raw_emit ("  texcoord 0.175554 0.391939")
  raw_emit ("  texcoord 0.175554 0.379575")
  raw_emit ("  texcoord 0.210630 0.379575")
  raw_emit ("  texcoord 0.789370 0.379575")
  raw_emit ("  texcoord 0.824446 0.379575")
  raw_emit ("  texcoord 0.824446 0.391939")
  raw_emit ("  texcoord 0.789370 0.391939")
  raw_emit ("  texcoord 0.789370 0.256677")
  raw_emit ("  texcoord 0.824446 0.256677")
  raw_emit ("  texcoord 0.824446 0.355589")
  raw_emit ("  texcoord 0.789370 0.355589")
  raw_emit ("  texcoord 0.743323 0.379575")
  raw_emit ("  texcoord 0.743323 0.391939")
  raw_emit ("  texcoord 0.644411 0.391939")
  raw_emit ("  texcoord 0.644411 0.379575")
  raw_emit ("  texcoord 0.824446 0.743323")
  raw_emit ("  texcoord 0.789370 0.743323")
  raw_emit ("  texcoord 0.789370 0.644411")
  raw_emit ("  texcoord 0.824446 0.644411")
  raw_emit ("  texcoord 0.256677 0.391939")
  raw_emit ("  texcoord 0.256677 0.379575")
  raw_emit ("  texcoord 0.355589 0.379575")
  raw_emit ("  texcoord 0.355589 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 16.750000 4.669998 10.721587")
  raw_emit ("  vertex 18.250000 4.669998 10.721587")
  raw_emit ("  vertex 18.250000 4.669998 10.471587")
  raw_emit ("  vertex 16.750000 4.669998 10.471587")
  raw_emit ("  vertex 16.750000 3.169998 10.471587")
  raw_emit ("  vertex 18.250000 3.169998 10.471587")
  raw_emit ("  vertex 18.250000 3.169998 10.721587")
  raw_emit ("  vertex 16.750000 3.169998 10.721587")
  raw_emit ("  texcoord 0.206245 0.781978")
  raw_emit ("  texcoord 0.179939 0.781978")
  raw_emit ("  texcoord 0.179939 0.769614")
  raw_emit ("  texcoord 0.206245 0.769614")
  raw_emit ("  texcoord 0.793755 0.769614")
  raw_emit ("  texcoord 0.820061 0.769614")
  raw_emit ("  texcoord 0.820061 0.781978")
  raw_emit ("  texcoord 0.793755 0.781978")
  raw_emit ("  texcoord 0.820061 0.269041")
  raw_emit ("  texcoord 0.820061 0.343225")
  raw_emit ("  texcoord 0.793755 0.343225")
  raw_emit ("  texcoord 0.793755 0.269041")
  raw_emit ("  texcoord 0.730959 0.769614")
  raw_emit ("  texcoord 0.730959 0.781978")
  raw_emit ("  texcoord 0.656775 0.781978")
  raw_emit ("  texcoord 0.656775 0.769614")
  raw_emit ("  texcoord 0.820061 0.730959")
  raw_emit ("  texcoord 0.793755 0.730959")
  raw_emit ("  texcoord 0.793755 0.656775")
  raw_emit ("  texcoord 0.820061 0.656775")
  raw_emit ("  texcoord 0.269041 0.781978")
  raw_emit ("  texcoord 0.269041 0.769614")
  raw_emit ("  texcoord 0.343225 0.769614")
  raw_emit ("  texcoord 0.343225 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex -17.095491 -3.606106 10.459996")
  raw_emit ("  vertex -17.345491 -3.424470 10.459996")
  raw_emit ("  vertex -17.654509 -3.424470 10.459996")
  raw_emit ("  vertex -17.904509 -3.606105 10.459996")
  raw_emit ("  vertex -18.000000 -3.899997 10.459996")
  raw_emit ("  vertex -17.904509 -4.193891 10.459996")
  raw_emit ("  vertex -17.654509 -4.375526 10.459996")
  raw_emit ("  vertex -17.345491 -4.375526 10.459996")
  raw_emit ("  vertex -17.095491 -4.193891 10.459996")
  raw_emit ("  vertex -17.000000 -3.899997 10.459996")
  raw_emit ("  vertex -18.114853 -4.346714 2.760002")
  raw_emit ("  vertex -18.260000 -3.899997 2.760001")
  raw_emit ("  vertex -18.114853 -3.453281 2.760001")
  raw_emit ("  vertex -17.734854 -3.177194 2.760002")
  raw_emit ("  vertex -17.265146 -3.177194 2.760002")
  raw_emit ("  vertex -16.885147 -3.453281 2.760001")
  raw_emit ("  vertex -16.740000 -3.899997 2.760001")
  raw_emit ("  vertex -16.885147 -4.346714 2.760002")
  raw_emit ("  vertex -17.265146 -4.622801 2.760002")
  raw_emit ("  vertex -17.734854 -4.622801 2.760002")
  raw_emit ("  texcoord 0.200186 0.321656")
  raw_emit ("  texcoord 0.195802 0.330639")
  raw_emit ("  texcoord 0.190382 0.330639")
  raw_emit ("  texcoord 0.185998 0.321656")
  raw_emit ("  texcoord 0.184323 0.307122")
  raw_emit ("  texcoord 0.185998 0.292587")
  raw_emit ("  texcoord 0.190382 0.283604")
  raw_emit ("  texcoord 0.195802 0.283604")
  raw_emit ("  texcoord 0.200186 0.292587")
  raw_emit ("  texcoord 0.201861 0.307122")
  raw_emit ("  texcoord 0.182309 0.714971")
  raw_emit ("  texcoord 0.179763 0.692878")
  raw_emit ("  texcoord 0.182309 0.670785")
  raw_emit ("  texcoord 0.188973 0.657131")
  raw_emit ("  texcoord 0.197211 0.657131")
  raw_emit ("  texcoord 0.203875 0.670785")
  raw_emit ("  texcoord 0.206421 0.692878")
  raw_emit ("  texcoord 0.203875 0.714971")
  raw_emit ("  texcoord 0.197211 0.728625")
  raw_emit ("  texcoord 0.188973 0.728625")
  raw_emit ("  texcoord 0.307122 0.769040")
  raw_emit ("  texcoord 0.292587 0.769040")
  raw_emit ("  texcoord 0.285029 0.388229")
  raw_emit ("  texcoord 0.307122 0.388229")
  raw_emit ("  texcoord 0.283604 0.769040")
  raw_emit ("  texcoord 0.271375 0.388229")
  raw_emit ("  texcoord 0.197211 0.388229")
  raw_emit ("  texcoord 0.195802 0.769040")
  raw_emit ("  texcoord 0.190382 0.769040")
  raw_emit ("  texcoord 0.188973 0.388229")
  raw_emit ("  texcoord 0.716396 0.769040")
  raw_emit ("  texcoord 0.707413 0.769040")
  raw_emit ("  texcoord 0.714971 0.388229")
  raw_emit ("  texcoord 0.728625 0.388229")
  raw_emit ("  texcoord 0.692878 0.769040")
  raw_emit ("  texcoord 0.692878 0.388229")
  raw_emit ("  texcoord 0.678344 0.769040")
  raw_emit ("  texcoord 0.670785 0.388229")
  raw_emit ("  texcoord 0.669361 0.769040")
  raw_emit ("  texcoord 0.657131 0.388229")
  raw_emit ("  texcoord 0.809618 0.769040")
  raw_emit ("  texcoord 0.804198 0.769040")
  raw_emit ("  texcoord 0.802789 0.388229")
  raw_emit ("  texcoord 0.811027 0.388229")
  raw_emit ("  texcoord 0.330639 0.769040")
  raw_emit ("  texcoord 0.321656 0.769040")
  raw_emit ("  texcoord 0.329215 0.388229")
  raw_emit ("  texcoord 0.342869 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -18.500000 -2.899997 2.835002")
  raw_emit ("  vertex -16.500000 -2.899997 2.835002")
  raw_emit ("  vertex -16.500000 -2.899997 2.585002")
  raw_emit ("  vertex -18.500000 -2.899997 2.585002")
  raw_emit ("  vertex -18.500000 -4.899998 2.585002")
  raw_emit ("  vertex -16.500000 -4.899998 2.585002")
  raw_emit ("  vertex -16.500000 -4.899998 2.835002")
  raw_emit ("  vertex -18.500000 -4.899998 2.835002")
  raw_emit ("  texcoord 0.824446 0.391939")
  raw_emit ("  texcoord 0.789370 0.391939")
  raw_emit ("  texcoord 0.789370 0.379575")
  raw_emit ("  texcoord 0.824446 0.379575")
  raw_emit ("  texcoord 0.175554 0.379575")
  raw_emit ("  texcoord 0.210630 0.379575")
  raw_emit ("  texcoord 0.210630 0.391939")
  raw_emit ("  texcoord 0.175554 0.391939")
  raw_emit ("  texcoord 0.175554 0.643422")
  raw_emit ("  texcoord 0.210630 0.643422")
  raw_emit ("  texcoord 0.210630 0.742334")
  raw_emit ("  texcoord 0.175554 0.742334")
  raw_emit ("  texcoord 0.356578 0.379575")
  raw_emit ("  texcoord 0.356578 0.391939")
  raw_emit ("  texcoord 0.257666 0.391939")
  raw_emit ("  texcoord 0.257666 0.379575")
  raw_emit ("  texcoord 0.210630 0.356578")
  raw_emit ("  texcoord 0.175554 0.356578")
  raw_emit ("  texcoord 0.175554 0.257666")
  raw_emit ("  texcoord 0.210630 0.257666")
  raw_emit ("  texcoord 0.643422 0.391939")
  raw_emit ("  texcoord 0.643422 0.379575")
  raw_emit ("  texcoord 0.742334 0.379575")
  raw_emit ("  texcoord 0.742334 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -18.250000 -3.149997 10.721587")
  raw_emit ("  vertex -16.750000 -3.149997 10.721587")
  raw_emit ("  vertex -16.750000 -3.149997 10.471587")
  raw_emit ("  vertex -18.250000 -3.149997 10.471587")
  raw_emit ("  vertex -18.250000 -4.649998 10.471587")
  raw_emit ("  vertex -16.750000 -4.649998 10.471587")
  raw_emit ("  vertex -16.750000 -4.649998 10.721587")
  raw_emit ("  vertex -18.250000 -4.649998 10.721587")
  raw_emit ("  texcoord 0.820061 0.781978")
  raw_emit ("  texcoord 0.793755 0.781978")
  raw_emit ("  texcoord 0.793755 0.769614")
  raw_emit ("  texcoord 0.820061 0.769614")
  raw_emit ("  texcoord 0.179939 0.769614")
  raw_emit ("  texcoord 0.206245 0.769614")
  raw_emit ("  texcoord 0.206245 0.781978")
  raw_emit ("  texcoord 0.179939 0.781978")
  raw_emit ("  texcoord 0.206245 0.655786")
  raw_emit ("  texcoord 0.206245 0.729970")
  raw_emit ("  texcoord 0.179939 0.729970")
  raw_emit ("  texcoord 0.179939 0.655786")
  raw_emit ("  texcoord 0.344214 0.769614")
  raw_emit ("  texcoord 0.344214 0.781978")
  raw_emit ("  texcoord 0.270030 0.781978")
  raw_emit ("  texcoord 0.270030 0.769614")
  raw_emit ("  texcoord 0.206245 0.344214")
  raw_emit ("  texcoord 0.179939 0.344214")
  raw_emit ("  texcoord 0.179939 0.270030")
  raw_emit ("  texcoord 0.206245 0.270030")
  raw_emit ("  texcoord 0.655786 0.781978")
  raw_emit ("  texcoord 0.655786 0.769614")
  raw_emit ("  texcoord 0.729970 0.769614")
  raw_emit ("  texcoord 0.729970 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex -12.095491 -3.606106 10.459996")
  raw_emit ("  vertex -12.345491 -3.424470 10.459996")
  raw_emit ("  vertex -12.654509 -3.424470 10.459996")
  raw_emit ("  vertex -12.904509 -3.606105 10.459996")
  raw_emit ("  vertex -13.000000 -3.899997 10.459996")
  raw_emit ("  vertex -12.904509 -4.193891 10.459996")
  raw_emit ("  vertex -12.654509 -4.375526 10.459996")
  raw_emit ("  vertex -12.345491 -4.375526 10.459996")
  raw_emit ("  vertex -12.095491 -4.193891 10.459996")
  raw_emit ("  vertex -12.000000 -3.899997 10.459996")
  raw_emit ("  vertex -13.114853 -4.346714 2.760002")
  raw_emit ("  vertex -13.260000 -3.899997 2.760001")
  raw_emit ("  vertex -13.114853 -3.453281 2.760001")
  raw_emit ("  vertex -12.734853 -3.177194 2.760002")
  raw_emit ("  vertex -12.265147 -3.177194 2.760002")
  raw_emit ("  vertex -11.885147 -3.453281 2.760001")
  raw_emit ("  vertex -11.740000 -3.899997 2.760001")
  raw_emit ("  vertex -11.885147 -4.346714 2.760002")
  raw_emit ("  vertex -12.265147 -4.622801 2.760002")
  raw_emit ("  vertex -12.734853 -4.622801 2.760002")
  raw_emit ("  texcoord 0.287874 0.321656")
  raw_emit ("  texcoord 0.283490 0.330639")
  raw_emit ("  texcoord 0.278070 0.330639")
  raw_emit ("  texcoord 0.273686 0.321656")
  raw_emit ("  texcoord 0.272011 0.307122")
  raw_emit ("  texcoord 0.273686 0.292587")
  raw_emit ("  texcoord 0.278070 0.283604")
  raw_emit ("  texcoord 0.283490 0.283604")
  raw_emit ("  texcoord 0.287874 0.292587")
  raw_emit ("  texcoord 0.289549 0.307122")
  raw_emit ("  texcoord 0.269997 0.714971")
  raw_emit ("  texcoord 0.267451 0.692878")
  raw_emit ("  texcoord 0.269997 0.670785")
  raw_emit ("  texcoord 0.276661 0.657131")
  raw_emit ("  texcoord 0.284899 0.657131")
  raw_emit ("  texcoord 0.291563 0.670785")
  raw_emit ("  texcoord 0.294109 0.692878")
  raw_emit ("  texcoord 0.291563 0.714971")
  raw_emit ("  texcoord 0.284899 0.728625")
  raw_emit ("  texcoord 0.276661 0.728625")
  raw_emit ("  texcoord 0.307122 0.769040")
  raw_emit ("  texcoord 0.292587 0.769040")
  raw_emit ("  texcoord 0.285029 0.388229")
  raw_emit ("  texcoord 0.307122 0.388229")
  raw_emit ("  texcoord 0.283604 0.769040")
  raw_emit ("  texcoord 0.271375 0.388229")
  raw_emit ("  texcoord 0.284899 0.388229")
  raw_emit ("  texcoord 0.283490 0.769040")
  raw_emit ("  texcoord 0.278070 0.769040")
  raw_emit ("  texcoord 0.276661 0.388229")
  raw_emit ("  texcoord 0.716396 0.769040")
  raw_emit ("  texcoord 0.707413 0.769040")
  raw_emit ("  texcoord 0.714971 0.388229")
  raw_emit ("  texcoord 0.728625 0.388229")
  raw_emit ("  texcoord 0.692878 0.769040")
  raw_emit ("  texcoord 0.692878 0.388229")
  raw_emit ("  texcoord 0.678344 0.769040")
  raw_emit ("  texcoord 0.670785 0.388229")
  raw_emit ("  texcoord 0.669361 0.769040")
  raw_emit ("  texcoord 0.657131 0.388229")
  raw_emit ("  texcoord 0.721930 0.769040")
  raw_emit ("  texcoord 0.716510 0.769040")
  raw_emit ("  texcoord 0.715101 0.388229")
  raw_emit ("  texcoord 0.723339 0.388229")
  raw_emit ("  texcoord 0.330639 0.769040")
  raw_emit ("  texcoord 0.321656 0.769040")
  raw_emit ("  texcoord 0.329215 0.388229")
  raw_emit ("  texcoord 0.342869 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -13.500000 -2.899997 2.835002")
  raw_emit ("  vertex -11.500000 -2.899997 2.835002")
  raw_emit ("  vertex -11.500000 -2.899997 2.585002")
  raw_emit ("  vertex -13.500000 -2.899997 2.585002")
  raw_emit ("  vertex -13.500000 -4.899998 2.585002")
  raw_emit ("  vertex -11.500000 -4.899998 2.585002")
  raw_emit ("  vertex -11.500000 -4.899998 2.835002")
  raw_emit ("  vertex -13.500000 -4.899998 2.835002")
  raw_emit ("  texcoord 0.736758 0.391939")
  raw_emit ("  texcoord 0.701682 0.391939")
  raw_emit ("  texcoord 0.701682 0.379575")
  raw_emit ("  texcoord 0.736758 0.379575")
  raw_emit ("  texcoord 0.263242 0.379575")
  raw_emit ("  texcoord 0.298318 0.379575")
  raw_emit ("  texcoord 0.298318 0.391939")
  raw_emit ("  texcoord 0.263242 0.391939")
  raw_emit ("  texcoord 0.263242 0.643422")
  raw_emit ("  texcoord 0.298318 0.643422")
  raw_emit ("  texcoord 0.298318 0.742334")
  raw_emit ("  texcoord 0.263242 0.742334")
  raw_emit ("  texcoord 0.356578 0.379575")
  raw_emit ("  texcoord 0.356578 0.391939")
  raw_emit ("  texcoord 0.257666 0.391939")
  raw_emit ("  texcoord 0.257666 0.379575")
  raw_emit ("  texcoord 0.298318 0.356578")
  raw_emit ("  texcoord 0.263242 0.356578")
  raw_emit ("  texcoord 0.263242 0.257666")
  raw_emit ("  texcoord 0.298318 0.257666")
  raw_emit ("  texcoord 0.643422 0.391939")
  raw_emit ("  texcoord 0.643422 0.379575")
  raw_emit ("  texcoord 0.742334 0.379575")
  raw_emit ("  texcoord 0.742334 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -13.250000 -3.149997 10.721587")
  raw_emit ("  vertex -11.750000 -3.149997 10.721587")
  raw_emit ("  vertex -11.750000 -3.149997 10.471587")
  raw_emit ("  vertex -13.250000 -3.149997 10.471587")
  raw_emit ("  vertex -13.250000 -4.649998 10.471587")
  raw_emit ("  vertex -11.750000 -4.649998 10.471587")
  raw_emit ("  vertex -11.750000 -4.649998 10.721587")
  raw_emit ("  vertex -13.250000 -4.649998 10.721587")
  raw_emit ("  texcoord 0.732373 0.781978")
  raw_emit ("  texcoord 0.706067 0.781978")
  raw_emit ("  texcoord 0.706067 0.769614")
  raw_emit ("  texcoord 0.732373 0.769614")
  raw_emit ("  texcoord 0.267627 0.769614")
  raw_emit ("  texcoord 0.293933 0.769614")
  raw_emit ("  texcoord 0.293933 0.781978")
  raw_emit ("  texcoord 0.267627 0.781978")
  raw_emit ("  texcoord 0.293933 0.655786")
  raw_emit ("  texcoord 0.293933 0.729970")
  raw_emit ("  texcoord 0.267627 0.729970")
  raw_emit ("  texcoord 0.267627 0.655786")
  raw_emit ("  texcoord 0.344214 0.769614")
  raw_emit ("  texcoord 0.344214 0.781978")
  raw_emit ("  texcoord 0.270030 0.781978")
  raw_emit ("  texcoord 0.270030 0.769614")
  raw_emit ("  texcoord 0.293933 0.344214")
  raw_emit ("  texcoord 0.267627 0.344214")
  raw_emit ("  texcoord 0.267627 0.270030")
  raw_emit ("  texcoord 0.293933 0.270030")
  raw_emit ("  texcoord 0.655786 0.781978")
  raw_emit ("  texcoord 0.655786 0.769614")
  raw_emit ("  texcoord 0.729970 0.769614")
  raw_emit ("  texcoord 0.729970 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex -7.095491 -3.606106 10.459996")
  raw_emit ("  vertex -7.345491 -3.424470 10.459996")
  raw_emit ("  vertex -7.654509 -3.424470 10.459996")
  raw_emit ("  vertex -7.904509 -3.606105 10.459996")
  raw_emit ("  vertex -8.000000 -3.899997 10.459996")
  raw_emit ("  vertex -7.904509 -4.193891 10.459996")
  raw_emit ("  vertex -7.654509 -4.375526 10.459996")
  raw_emit ("  vertex -7.345491 -4.375526 10.459996")
  raw_emit ("  vertex -7.095491 -4.193891 10.459996")
  raw_emit ("  vertex -7.000000 -3.899997 10.459996")
  raw_emit ("  vertex -8.114853 -4.346714 2.760002")
  raw_emit ("  vertex -8.260000 -3.899997 2.760001")
  raw_emit ("  vertex -8.114853 -3.453281 2.760001")
  raw_emit ("  vertex -7.734853 -3.177194 2.760002")
  raw_emit ("  vertex -7.265147 -3.177194 2.760002")
  raw_emit ("  vertex -6.885147 -3.453281 2.760001")
  raw_emit ("  vertex -6.740000 -3.899997 2.760001")
  raw_emit ("  vertex -6.885147 -4.346714 2.760002")
  raw_emit ("  vertex -7.265147 -4.622801 2.760002")
  raw_emit ("  vertex -7.734853 -4.622801 2.760002")
  raw_emit ("  texcoord 0.375562 0.321656")
  raw_emit ("  texcoord 0.371178 0.330639")
  raw_emit ("  texcoord 0.365758 0.330639")
  raw_emit ("  texcoord 0.361374 0.321656")
  raw_emit ("  texcoord 0.359699 0.307122")
  raw_emit ("  texcoord 0.361374 0.292587")
  raw_emit ("  texcoord 0.365758 0.283604")
  raw_emit ("  texcoord 0.371178 0.283604")
  raw_emit ("  texcoord 0.375562 0.292587")
  raw_emit ("  texcoord 0.377237 0.307122")
  raw_emit ("  texcoord 0.357685 0.714971")
  raw_emit ("  texcoord 0.355139 0.692878")
  raw_emit ("  texcoord 0.357685 0.670785")
  raw_emit ("  texcoord 0.364349 0.657131")
  raw_emit ("  texcoord 0.372587 0.657131")
  raw_emit ("  texcoord 0.379251 0.670785")
  raw_emit ("  texcoord 0.381797 0.692878")
  raw_emit ("  texcoord 0.379251 0.714971")
  raw_emit ("  texcoord 0.372587 0.728625")
  raw_emit ("  texcoord 0.364349 0.728625")
  raw_emit ("  texcoord 0.307122 0.769040")
  raw_emit ("  texcoord 0.292587 0.769040")
  raw_emit ("  texcoord 0.285029 0.388229")
  raw_emit ("  texcoord 0.307122 0.388229")
  raw_emit ("  texcoord 0.283604 0.769040")
  raw_emit ("  texcoord 0.271375 0.388229")
  raw_emit ("  texcoord 0.372587 0.388229")
  raw_emit ("  texcoord 0.371178 0.769040")
  raw_emit ("  texcoord 0.365758 0.769040")
  raw_emit ("  texcoord 0.364349 0.388229")
  raw_emit ("  texcoord 0.716396 0.769040")
  raw_emit ("  texcoord 0.707413 0.769040")
  raw_emit ("  texcoord 0.714971 0.388229")
  raw_emit ("  texcoord 0.728625 0.388229")
  raw_emit ("  texcoord 0.692878 0.769040")
  raw_emit ("  texcoord 0.692878 0.388229")
  raw_emit ("  texcoord 0.678344 0.769040")
  raw_emit ("  texcoord 0.670785 0.388229")
  raw_emit ("  texcoord 0.669361 0.769040")
  raw_emit ("  texcoord 0.657131 0.388229")
  raw_emit ("  texcoord 0.634242 0.769040")
  raw_emit ("  texcoord 0.628822 0.769040")
  raw_emit ("  texcoord 0.627413 0.388229")
  raw_emit ("  texcoord 0.635651 0.388229")
  raw_emit ("  texcoord 0.330639 0.769040")
  raw_emit ("  texcoord 0.321656 0.769040")
  raw_emit ("  texcoord 0.329215 0.388229")
  raw_emit ("  texcoord 0.342869 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  Call TempleSub6
End Sub

Sub TempleSub6()
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -8.500000 -2.899997 2.835002")
  raw_emit ("  vertex -6.500000 -2.899997 2.835002")
  raw_emit ("  vertex -6.500000 -2.899997 2.585002")
  raw_emit ("  vertex -8.500000 -2.899997 2.585002")
  raw_emit ("  vertex -8.500000 -4.899998 2.585002")
  raw_emit ("  vertex -6.500000 -4.899998 2.585002")
  raw_emit ("  vertex -6.500000 -4.899998 2.835002")
  raw_emit ("  vertex -8.500000 -4.899998 2.835002")
  raw_emit ("  texcoord 0.649070 0.391939")
  raw_emit ("  texcoord 0.613994 0.391939")
  raw_emit ("  texcoord 0.613994 0.379575")
  raw_emit ("  texcoord 0.649070 0.379575")
  raw_emit ("  texcoord 0.350930 0.379575")
  raw_emit ("  texcoord 0.386006 0.379575")
  raw_emit ("  texcoord 0.386006 0.391939")
  raw_emit ("  texcoord 0.350930 0.391939")
  raw_emit ("  texcoord 0.350930 0.643422")
  raw_emit ("  texcoord 0.386006 0.643422")
  raw_emit ("  texcoord 0.386006 0.742334")
  raw_emit ("  texcoord 0.350930 0.742334")
  raw_emit ("  texcoord 0.356578 0.379575")
  raw_emit ("  texcoord 0.356578 0.391939")
  raw_emit ("  texcoord 0.257666 0.391939")
  raw_emit ("  texcoord 0.257666 0.379575")
  raw_emit ("  texcoord 0.386006 0.356578")
  raw_emit ("  texcoord 0.350930 0.356578")
  raw_emit ("  texcoord 0.350930 0.257666")
  raw_emit ("  texcoord 0.386006 0.257666")
  raw_emit ("  texcoord 0.643422 0.391939")
  raw_emit ("  texcoord 0.643422 0.379575")
  raw_emit ("  texcoord 0.742334 0.379575")
  raw_emit ("  texcoord 0.742334 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -8.250000 -3.149997 10.721587")
  raw_emit ("  vertex -6.750000 -3.149997 10.721587")
  raw_emit ("  vertex -6.750000 -3.149997 10.471587")
  raw_emit ("  vertex -8.250000 -3.149997 10.471587")
  raw_emit ("  vertex -8.250000 -4.649998 10.471587")
  raw_emit ("  vertex -6.750000 -4.649998 10.471587")
  raw_emit ("  vertex -6.750000 -4.649998 10.721587")
  raw_emit ("  vertex -8.250000 -4.649998 10.721587")
  raw_emit ("  texcoord 0.644685 0.781978")
  raw_emit ("  texcoord 0.618379 0.781978")
  raw_emit ("  texcoord 0.618379 0.769614")
  raw_emit ("  texcoord 0.644685 0.769614")
  raw_emit ("  texcoord 0.355315 0.769614")
  raw_emit ("  texcoord 0.381621 0.769614")
  raw_emit ("  texcoord 0.381621 0.781978")
  raw_emit ("  texcoord 0.355315 0.781978")
  raw_emit ("  texcoord 0.381621 0.655786")
  raw_emit ("  texcoord 0.381621 0.729970")
  raw_emit ("  texcoord 0.355315 0.729970")
  raw_emit ("  texcoord 0.355315 0.655786")
  raw_emit ("  texcoord 0.344214 0.769614")
  raw_emit ("  texcoord 0.344214 0.781978")
  raw_emit ("  texcoord 0.270030 0.781978")
  raw_emit ("  texcoord 0.270030 0.769614")
  raw_emit ("  texcoord 0.381621 0.344214")
  raw_emit ("  texcoord 0.355315 0.344214")
  raw_emit ("  texcoord 0.355315 0.270030")
  raw_emit ("  texcoord 0.381621 0.270030")
  raw_emit ("  texcoord 0.655786 0.781978")
  raw_emit ("  texcoord 0.655786 0.769614")
  raw_emit ("  texcoord 0.729970 0.769614")
  raw_emit ("  texcoord 0.729970 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex -2.095491 -3.606106 10.459996")
  raw_emit ("  vertex -2.345491 -3.424470 10.459996")
  raw_emit ("  vertex -2.654509 -3.424470 10.459996")
  raw_emit ("  vertex -2.904509 -3.606105 10.459996")
  raw_emit ("  vertex -3.000000 -3.899997 10.459996")
  raw_emit ("  vertex -2.904509 -4.193891 10.459996")
  raw_emit ("  vertex -2.654509 -4.375526 10.459996")
  raw_emit ("  vertex -2.345491 -4.375526 10.459996")
  raw_emit ("  vertex -2.095491 -4.193891 10.459996")
  raw_emit ("  vertex -2.000000 -3.899997 10.459996")
  raw_emit ("  vertex -3.114853 -4.346714 2.760002")
  raw_emit ("  vertex -3.260000 -3.899997 2.760001")
  raw_emit ("  vertex -3.114853 -3.453281 2.760001")
  raw_emit ("  vertex -2.734853 -3.177194 2.760002")
  raw_emit ("  vertex -2.265147 -3.177194 2.760002")
  raw_emit ("  vertex -1.885147 -3.453281 2.760001")
  raw_emit ("  vertex -1.740000 -3.899997 2.760001")
  raw_emit ("  vertex -1.885147 -4.346714 2.760002")
  raw_emit ("  vertex -2.265147 -4.622801 2.760002")
  raw_emit ("  vertex -2.734853 -4.622801 2.760002")
  raw_emit ("  texcoord 0.463250 0.321656")
  raw_emit ("  texcoord 0.458866 0.330639")
  raw_emit ("  texcoord 0.453446 0.330639")
  raw_emit ("  texcoord 0.449062 0.321656")
  raw_emit ("  texcoord 0.447387 0.307122")
  raw_emit ("  texcoord 0.449062 0.292587")
  raw_emit ("  texcoord 0.453446 0.283604")
  raw_emit ("  texcoord 0.458866 0.283604")
  raw_emit ("  texcoord 0.463250 0.292587")
  raw_emit ("  texcoord 0.464925 0.307122")
  raw_emit ("  texcoord 0.445373 0.714971")
  raw_emit ("  texcoord 0.442827 0.692878")
  raw_emit ("  texcoord 0.445373 0.670785")
  raw_emit ("  texcoord 0.452037 0.657131")
  raw_emit ("  texcoord 0.460275 0.657131")
  raw_emit ("  texcoord 0.466939 0.670785")
  raw_emit ("  texcoord 0.469485 0.692878")
  raw_emit ("  texcoord 0.466939 0.714971")
  raw_emit ("  texcoord 0.460275 0.728625")
  raw_emit ("  texcoord 0.452037 0.728625")
  raw_emit ("  texcoord 0.307122 0.769040")
  raw_emit ("  texcoord 0.292587 0.769040")
  raw_emit ("  texcoord 0.285029 0.388229")
  raw_emit ("  texcoord 0.307122 0.388229")
  raw_emit ("  texcoord 0.283604 0.769040")
  raw_emit ("  texcoord 0.271375 0.388229")
  raw_emit ("  texcoord 0.460275 0.388229")
  raw_emit ("  texcoord 0.458866 0.769040")
  raw_emit ("  texcoord 0.453446 0.769040")
  raw_emit ("  texcoord 0.452037 0.388229")
  raw_emit ("  texcoord 0.716396 0.769040")
  raw_emit ("  texcoord 0.707413 0.769040")
  raw_emit ("  texcoord 0.714971 0.388229")
  raw_emit ("  texcoord 0.728625 0.388229")
  raw_emit ("  texcoord 0.692878 0.769040")
  raw_emit ("  texcoord 0.692878 0.388229")
  raw_emit ("  texcoord 0.678344 0.769040")
  raw_emit ("  texcoord 0.670785 0.388229")
  raw_emit ("  texcoord 0.669361 0.769040")
  raw_emit ("  texcoord 0.657131 0.388229")
  raw_emit ("  texcoord 0.546554 0.769040")
  raw_emit ("  texcoord 0.541134 0.769040")
  raw_emit ("  texcoord 0.539725 0.388229")
  raw_emit ("  texcoord 0.547963 0.388229")
  raw_emit ("  texcoord 0.330639 0.769040")
  raw_emit ("  texcoord 0.321656 0.769040")
  raw_emit ("  texcoord 0.329215 0.388229")
  raw_emit ("  texcoord 0.342869 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -3.500000 -2.899997 2.835002")
  raw_emit ("  vertex -1.500000 -2.899997 2.835002")
  raw_emit ("  vertex -1.500000 -2.899997 2.585002")
  raw_emit ("  vertex -3.500000 -2.899997 2.585002")
  raw_emit ("  vertex -3.500000 -4.899998 2.585002")
  raw_emit ("  vertex -1.500000 -4.899998 2.585002")
  raw_emit ("  vertex -1.500000 -4.899998 2.835002")
  raw_emit ("  vertex -3.500000 -4.899998 2.835002")
  raw_emit ("  texcoord 0.561382 0.391939")
  raw_emit ("  texcoord 0.526306 0.391939")
  raw_emit ("  texcoord 0.526306 0.379575")
  raw_emit ("  texcoord 0.561382 0.379575")
  raw_emit ("  texcoord 0.438618 0.379575")
  raw_emit ("  texcoord 0.473694 0.379575")
  raw_emit ("  texcoord 0.473694 0.391939")
  raw_emit ("  texcoord 0.438618 0.391939")
  raw_emit ("  texcoord 0.438618 0.643422")
  raw_emit ("  texcoord 0.473694 0.643422")
  raw_emit ("  texcoord 0.473694 0.742334")
  raw_emit ("  texcoord 0.438618 0.742334")
  raw_emit ("  texcoord 0.356578 0.379575")
  raw_emit ("  texcoord 0.356578 0.391939")
  raw_emit ("  texcoord 0.257666 0.391939")
  raw_emit ("  texcoord 0.257666 0.379575")
  raw_emit ("  texcoord 0.473694 0.356578")
  raw_emit ("  texcoord 0.438618 0.356578")
  raw_emit ("  texcoord 0.438618 0.257666")
  raw_emit ("  texcoord 0.473694 0.257666")
  raw_emit ("  texcoord 0.643422 0.391939")
  raw_emit ("  texcoord 0.643422 0.379575")
  raw_emit ("  texcoord 0.742334 0.379575")
  raw_emit ("  texcoord 0.742334 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -3.250000 -3.149997 10.721587")
  raw_emit ("  vertex -1.750000 -3.149997 10.721587")
  raw_emit ("  vertex -1.750000 -3.149997 10.471587")
  raw_emit ("  vertex -3.250000 -3.149997 10.471587")
  raw_emit ("  vertex -3.250000 -4.649998 10.471587")
  raw_emit ("  vertex -1.750000 -4.649998 10.471587")
  raw_emit ("  vertex -1.750000 -4.649998 10.721587")
  raw_emit ("  vertex -3.250000 -4.649998 10.721587")
  raw_emit ("  texcoord 0.556997 0.781978")
  raw_emit ("  texcoord 0.530691 0.781978")
  raw_emit ("  texcoord 0.530691 0.769614")
  raw_emit ("  texcoord 0.556997 0.769614")
  raw_emit ("  texcoord 0.443003 0.769614")
  raw_emit ("  texcoord 0.469309 0.769614")
  raw_emit ("  texcoord 0.469309 0.781978")
  raw_emit ("  texcoord 0.443003 0.781978")
  raw_emit ("  texcoord 0.469309 0.655786")
  raw_emit ("  texcoord 0.469309 0.729970")
  raw_emit ("  texcoord 0.443003 0.729970")
  raw_emit ("  texcoord 0.443003 0.655786")
  raw_emit ("  texcoord 0.344214 0.769614")
  raw_emit ("  texcoord 0.344214 0.781978")
  raw_emit ("  texcoord 0.270030 0.781978")
  raw_emit ("  texcoord 0.270030 0.769614")
  raw_emit ("  texcoord 0.469309 0.344214")
  raw_emit ("  texcoord 0.443003 0.344214")
  raw_emit ("  texcoord 0.443003 0.270030")
  raw_emit ("  texcoord 0.469309 0.270030")
  raw_emit ("  texcoord 0.655786 0.781978")
  raw_emit ("  texcoord 0.655786 0.769614")
  raw_emit ("  texcoord 0.729970 0.769614")
  raw_emit ("  texcoord 0.729970 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex 2.904509 -3.606106 10.459996")
  raw_emit ("  vertex 2.654509 -3.424470 10.459996")
  raw_emit ("  vertex 2.345491 -3.424470 10.459996")
  raw_emit ("  vertex 2.095491 -3.606105 10.459996")
  raw_emit ("  vertex 2.000000 -3.899997 10.459996")
  raw_emit ("  vertex 2.095491 -4.193891 10.459996")
  raw_emit ("  vertex 2.345491 -4.375526 10.459996")
  raw_emit ("  vertex 2.654509 -4.375526 10.459996")
  raw_emit ("  vertex 2.904509 -4.193891 10.459996")
  raw_emit ("  vertex 3.000000 -3.899997 10.459996")
  raw_emit ("  vertex 1.885147 -4.346714 2.760002")
  raw_emit ("  vertex 1.740000 -3.899997 2.760001")
  raw_emit ("  vertex 1.885147 -3.453281 2.760001")
  raw_emit ("  vertex 2.265146 -3.177194 2.760002")
  raw_emit ("  vertex 2.734854 -3.177194 2.760002")
  raw_emit ("  vertex 3.114853 -3.453281 2.760001")
  raw_emit ("  vertex 3.260000 -3.899997 2.760001")
  raw_emit ("  vertex 3.114853 -4.346714 2.760002")
  raw_emit ("  vertex 2.734854 -4.622801 2.760002")
  raw_emit ("  vertex 2.265146 -4.622801 2.760002")
  raw_emit ("  texcoord 0.550938 0.321656")
  raw_emit ("  texcoord 0.546554 0.330639")
  raw_emit ("  texcoord 0.541134 0.330639")
  raw_emit ("  texcoord 0.536750 0.321656")
  raw_emit ("  texcoord 0.535075 0.307122")
  raw_emit ("  texcoord 0.536750 0.292587")
  raw_emit ("  texcoord 0.541134 0.283604")
  raw_emit ("  texcoord 0.546554 0.283604")
  raw_emit ("  texcoord 0.550938 0.292587")
  raw_emit ("  texcoord 0.552613 0.307122")
  raw_emit ("  texcoord 0.533061 0.714971")
  raw_emit ("  texcoord 0.530515 0.692878")
  raw_emit ("  texcoord 0.533061 0.670785")
  raw_emit ("  texcoord 0.539725 0.657131")
  raw_emit ("  texcoord 0.547963 0.657131")
  raw_emit ("  texcoord 0.554627 0.670785")
  raw_emit ("  texcoord 0.557173 0.692878")
  raw_emit ("  texcoord 0.554627 0.714971")
  raw_emit ("  texcoord 0.547963 0.728625")
  raw_emit ("  texcoord 0.539725 0.728625")
  raw_emit ("  texcoord 0.307122 0.769040")
  raw_emit ("  texcoord 0.292587 0.769040")
  raw_emit ("  texcoord 0.285029 0.388229")
  raw_emit ("  texcoord 0.307122 0.388229")
  raw_emit ("  texcoord 0.283604 0.769040")
  raw_emit ("  texcoord 0.271375 0.388229")
  raw_emit ("  texcoord 0.547963 0.388229")
  raw_emit ("  texcoord 0.546554 0.769040")
  raw_emit ("  texcoord 0.541134 0.769040")
  raw_emit ("  texcoord 0.539725 0.388229")
  raw_emit ("  texcoord 0.716396 0.769040")
  raw_emit ("  texcoord 0.707413 0.769040")
  raw_emit ("  texcoord 0.714971 0.388229")
  raw_emit ("  texcoord 0.728625 0.388229")
  raw_emit ("  texcoord 0.692878 0.769040")
  raw_emit ("  texcoord 0.692878 0.388229")
  raw_emit ("  texcoord 0.678344 0.769040")
  raw_emit ("  texcoord 0.670785 0.388229")
  raw_emit ("  texcoord 0.669361 0.769040")
  raw_emit ("  texcoord 0.657131 0.388229")
  raw_emit ("  texcoord 0.458866 0.769040")
  raw_emit ("  texcoord 0.453446 0.769040")
  raw_emit ("  texcoord 0.452037 0.388229")
  raw_emit ("  texcoord 0.460275 0.388229")
  raw_emit ("  texcoord 0.330639 0.769040")
  raw_emit ("  texcoord 0.321656 0.769040")
  raw_emit ("  texcoord 0.329215 0.388229")
  raw_emit ("  texcoord 0.342869 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 1.500000 -2.899997 2.835002")
  raw_emit ("  vertex 3.500000 -2.899997 2.835002")
  raw_emit ("  vertex 3.500000 -2.899997 2.585002")
  raw_emit ("  vertex 1.500000 -2.899997 2.585002")
  raw_emit ("  vertex 1.500000 -4.899998 2.585002")
  raw_emit ("  vertex 3.500000 -4.899998 2.585002")
  raw_emit ("  vertex 3.500000 -4.899998 2.835002")
  raw_emit ("  vertex 1.500000 -4.899998 2.835002")
  raw_emit ("  texcoord 0.473694 0.391939")
  raw_emit ("  texcoord 0.438618 0.391939")
  raw_emit ("  texcoord 0.438618 0.379575")
  raw_emit ("  texcoord 0.473694 0.379575")
  raw_emit ("  texcoord 0.526306 0.379575")
  raw_emit ("  texcoord 0.561382 0.379575")
  raw_emit ("  texcoord 0.561382 0.391939")
  raw_emit ("  texcoord 0.526306 0.391939")
  raw_emit ("  texcoord 0.526306 0.643422")
  raw_emit ("  texcoord 0.561382 0.643422")
  raw_emit ("  texcoord 0.561382 0.742334")
  raw_emit ("  texcoord 0.526306 0.742334")
  raw_emit ("  texcoord 0.356578 0.379575")
  raw_emit ("  texcoord 0.356578 0.391939")
  raw_emit ("  texcoord 0.257666 0.391939")
  raw_emit ("  texcoord 0.257666 0.379575")
  raw_emit ("  texcoord 0.561382 0.356578")
  raw_emit ("  texcoord 0.526306 0.356578")
  raw_emit ("  texcoord 0.526306 0.257666")
  raw_emit ("  texcoord 0.561382 0.257666")
  raw_emit ("  texcoord 0.643422 0.391939")
  raw_emit ("  texcoord 0.643422 0.379575")
  raw_emit ("  texcoord 0.742334 0.379575")
  raw_emit ("  texcoord 0.742334 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 1.750000 -3.149997 10.721587")
  raw_emit ("  vertex 3.250000 -3.149997 10.721587")
  raw_emit ("  vertex 3.250000 -3.149997 10.471587")
  raw_emit ("  vertex 1.750000 -3.149997 10.471587")
  raw_emit ("  vertex 1.750000 -4.649998 10.471587")
  raw_emit ("  vertex 3.250000 -4.649998 10.471587")
  raw_emit ("  vertex 3.250000 -4.649998 10.721587")
  raw_emit ("  vertex 1.750000 -4.649998 10.721587")
  raw_emit ("  texcoord 0.469309 0.781978")
  raw_emit ("  texcoord 0.443003 0.781978")
  raw_emit ("  texcoord 0.443003 0.769614")
  raw_emit ("  texcoord 0.469309 0.769614")
  raw_emit ("  texcoord 0.530691 0.769614")
  raw_emit ("  texcoord 0.556997 0.769614")
  raw_emit ("  texcoord 0.556997 0.781978")
  raw_emit ("  texcoord 0.530691 0.781978")
  raw_emit ("  texcoord 0.556997 0.655786")
  raw_emit ("  texcoord 0.556997 0.729970")
  raw_emit ("  texcoord 0.530691 0.729970")
  raw_emit ("  texcoord 0.530691 0.655786")
  raw_emit ("  texcoord 0.344214 0.769614")
  raw_emit ("  texcoord 0.344214 0.781978")
  raw_emit ("  texcoord 0.270030 0.781978")
  raw_emit ("  texcoord 0.270030 0.769614")
  raw_emit ("  texcoord 0.556997 0.344214")
  raw_emit ("  texcoord 0.530691 0.344214")
  raw_emit ("  texcoord 0.530691 0.270030")
  raw_emit ("  texcoord 0.556997 0.270030")
  raw_emit ("  texcoord 0.655786 0.781978")
  raw_emit ("  texcoord 0.655786 0.769614")
  raw_emit ("  texcoord 0.729970 0.769614")
  raw_emit ("  texcoord 0.729970 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex 7.904509 -3.606106 10.459996")
  raw_emit ("  vertex 7.654509 -3.424470 10.459996")
  raw_emit ("  vertex 7.345491 -3.424470 10.459996")
  raw_emit ("  vertex 7.095491 -3.606105 10.459996")
  raw_emit ("  vertex 7.000000 -3.899997 10.459996")
  raw_emit ("  vertex 7.095491 -4.193891 10.459996")
  raw_emit ("  vertex 7.345491 -4.375526 10.459996")
  raw_emit ("  vertex 7.654509 -4.375526 10.459996")
  raw_emit ("  vertex 7.904509 -4.193891 10.459996")
  raw_emit ("  vertex 8.000000 -3.899997 10.459996")
  raw_emit ("  vertex 6.885147 -4.346714 2.760002")
  raw_emit ("  vertex 6.740000 -3.899997 2.760001")
  raw_emit ("  vertex 6.885147 -3.453281 2.760001")
  raw_emit ("  vertex 7.265146 -3.177194 2.760002")
  raw_emit ("  vertex 7.734854 -3.177194 2.760002")
  raw_emit ("  vertex 8.114853 -3.453281 2.760001")
  raw_emit ("  vertex 8.260000 -3.899997 2.760001")
  raw_emit ("  vertex 8.114853 -4.346714 2.760002")
  raw_emit ("  vertex 7.734854 -4.622801 2.760002")
  raw_emit ("  vertex 7.265146 -4.622801 2.760002")
  raw_emit ("  texcoord 0.638626 0.321656")
  raw_emit ("  texcoord 0.634242 0.330639")
  raw_emit ("  texcoord 0.628822 0.330639")
  raw_emit ("  texcoord 0.624438 0.321656")
  raw_emit ("  texcoord 0.622763 0.307122")
  raw_emit ("  texcoord 0.624438 0.292587")
  raw_emit ("  texcoord 0.628822 0.283604")
  raw_emit ("  texcoord 0.634242 0.283604")
  raw_emit ("  texcoord 0.638626 0.292587")
  raw_emit ("  texcoord 0.640301 0.307122")
  raw_emit ("  texcoord 0.620749 0.714971")
  raw_emit ("  texcoord 0.618203 0.692878")
  raw_emit ("  texcoord 0.620749 0.670785")
  raw_emit ("  texcoord 0.627413 0.657131")
  raw_emit ("  texcoord 0.635651 0.657131")
  raw_emit ("  texcoord 0.642315 0.670785")
  raw_emit ("  texcoord 0.644861 0.692878")
  raw_emit ("  texcoord 0.642315 0.714971")
  raw_emit ("  texcoord 0.635651 0.728625")
  raw_emit ("  texcoord 0.627413 0.728625")
  raw_emit ("  texcoord 0.307122 0.769040")
  raw_emit ("  texcoord 0.292587 0.769040")
  raw_emit ("  texcoord 0.285029 0.388229")
  raw_emit ("  texcoord 0.307122 0.388229")
  raw_emit ("  texcoord 0.283604 0.769040")
  raw_emit ("  texcoord 0.271375 0.388229")
  raw_emit ("  texcoord 0.635651 0.388229")
  raw_emit ("  texcoord 0.634242 0.769040")
  raw_emit ("  texcoord 0.628822 0.769040")
  raw_emit ("  texcoord 0.627413 0.388229")
  raw_emit ("  texcoord 0.716396 0.769040")
  raw_emit ("  texcoord 0.707413 0.769040")
  raw_emit ("  texcoord 0.714971 0.388229")
  raw_emit ("  texcoord 0.728625 0.388229")
  raw_emit ("  texcoord 0.692878 0.769040")
  raw_emit ("  texcoord 0.692878 0.388229")
  raw_emit ("  texcoord 0.678344 0.769040")
  raw_emit ("  texcoord 0.670785 0.388229")
  raw_emit ("  texcoord 0.669361 0.769040")
  raw_emit ("  texcoord 0.657131 0.388229")
  raw_emit ("  texcoord 0.371178 0.769040")
  raw_emit ("  texcoord 0.365758 0.769040")
  raw_emit ("  texcoord 0.364349 0.388229")
  raw_emit ("  texcoord 0.372587 0.388229")
  raw_emit ("  texcoord 0.330639 0.769040")
  raw_emit ("  texcoord 0.321656 0.769040")
  raw_emit ("  texcoord 0.329215 0.388229")
  raw_emit ("  texcoord 0.342869 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 6.500000 -2.899997 2.835002")
  raw_emit ("  vertex 8.500000 -2.899997 2.835002")
  raw_emit ("  vertex 8.500000 -2.899997 2.585002")
  raw_emit ("  vertex 6.500000 -2.899997 2.585002")
  raw_emit ("  vertex 6.500000 -4.899998 2.585002")
  raw_emit ("  vertex 8.500000 -4.899998 2.585002")
  raw_emit ("  vertex 8.500000 -4.899998 2.835002")
  raw_emit ("  vertex 6.500000 -4.899998 2.835002")
  raw_emit ("  texcoord 0.386006 0.391939")
  raw_emit ("  texcoord 0.350930 0.391939")
  raw_emit ("  texcoord 0.350930 0.379575")
  raw_emit ("  texcoord 0.386006 0.379575")
  raw_emit ("  texcoord 0.613994 0.379575")
  raw_emit ("  texcoord 0.649070 0.379575")
  raw_emit ("  texcoord 0.649070 0.391939")
  raw_emit ("  texcoord 0.613994 0.391939")
  raw_emit ("  texcoord 0.613994 0.643422")
  raw_emit ("  texcoord 0.649070 0.643422")
  raw_emit ("  texcoord 0.649070 0.742334")
  raw_emit ("  texcoord 0.613994 0.742334")
  raw_emit ("  texcoord 0.356578 0.379575")
  raw_emit ("  texcoord 0.356578 0.391939")
  raw_emit ("  texcoord 0.257666 0.391939")
  raw_emit ("  texcoord 0.257666 0.379575")
  raw_emit ("  texcoord 0.649070 0.356578")
  raw_emit ("  texcoord 0.613994 0.356578")
  raw_emit ("  texcoord 0.613994 0.257666")
  raw_emit ("  texcoord 0.649070 0.257666")
  raw_emit ("  texcoord 0.643422 0.391939")
  raw_emit ("  texcoord 0.643422 0.379575")
  raw_emit ("  texcoord 0.742334 0.379575")
  raw_emit ("  texcoord 0.742334 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 6.750000 -3.149997 10.721587")
  raw_emit ("  vertex 8.250000 -3.149997 10.721587")
  raw_emit ("  vertex 8.250000 -3.149997 10.471587")
  raw_emit ("  vertex 6.750000 -3.149997 10.471587")
  raw_emit ("  vertex 6.750000 -4.649998 10.471587")
  raw_emit ("  vertex 8.250000 -4.649998 10.471587")
  raw_emit ("  vertex 8.250000 -4.649998 10.721587")
  raw_emit ("  vertex 6.750000 -4.649998 10.721587")
  raw_emit ("  texcoord 0.381621 0.781978")
  raw_emit ("  texcoord 0.355315 0.781978")
  raw_emit ("  texcoord 0.355315 0.769614")
  raw_emit ("  texcoord 0.381621 0.769614")
  raw_emit ("  texcoord 0.618379 0.769614")
  raw_emit ("  texcoord 0.644685 0.769614")
  raw_emit ("  texcoord 0.644685 0.781978")
  raw_emit ("  texcoord 0.618379 0.781978")
  raw_emit ("  texcoord 0.644685 0.655786")
  raw_emit ("  texcoord 0.644685 0.729970")
  raw_emit ("  texcoord 0.618379 0.729970")
  raw_emit ("  texcoord 0.618379 0.655786")
  raw_emit ("  texcoord 0.344214 0.769614")
  raw_emit ("  texcoord 0.344214 0.781978")
  raw_emit ("  texcoord 0.270030 0.781978")
  raw_emit ("  texcoord 0.270030 0.769614")
  raw_emit ("  texcoord 0.644685 0.344214")
  raw_emit ("  texcoord 0.618379 0.344214")
  raw_emit ("  texcoord 0.618379 0.270030")
  raw_emit ("  texcoord 0.644685 0.270030")
  raw_emit ("  texcoord 0.655786 0.781978")
  raw_emit ("  texcoord 0.655786 0.769614")
  raw_emit ("  texcoord 0.729970 0.769614")
  raw_emit ("  texcoord 0.729970 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex 12.904509 -3.606106 10.459996")
  raw_emit ("  vertex 12.654509 -3.424470 10.459996")
  raw_emit ("  vertex 12.345491 -3.424470 10.459996")
  raw_emit ("  vertex 12.095491 -3.606105 10.459996")
  raw_emit ("  vertex 12.000000 -3.899997 10.459996")
  raw_emit ("  vertex 12.095491 -4.193891 10.459996")
  raw_emit ("  vertex 12.345491 -4.375526 10.459996")
  raw_emit ("  vertex 12.654509 -4.375526 10.459996")
  raw_emit ("  vertex 12.904509 -4.193891 10.459996")
  raw_emit ("  vertex 13.000000 -3.899997 10.459996")
  raw_emit ("  vertex 11.885147 -4.346714 2.760002")
  raw_emit ("  vertex 11.740000 -3.899997 2.760001")
  raw_emit ("  vertex 11.885147 -3.453281 2.760001")
  raw_emit ("  vertex 12.265146 -3.177194 2.760002")
  raw_emit ("  vertex 12.734854 -3.177194 2.760002")
  raw_emit ("  vertex 13.114853 -3.453281 2.760001")
  raw_emit ("  vertex 13.260000 -3.899997 2.760001")
  raw_emit ("  vertex 13.114853 -4.346714 2.760002")
  raw_emit ("  vertex 12.734854 -4.622801 2.760002")
  raw_emit ("  vertex 12.265146 -4.622801 2.760002")
  raw_emit ("  texcoord 0.726314 0.321656")
  raw_emit ("  texcoord 0.721930 0.330639")
  raw_emit ("  texcoord 0.716510 0.330639")
  raw_emit ("  texcoord 0.712126 0.321656")
  raw_emit ("  texcoord 0.710451 0.307122")
  raw_emit ("  texcoord 0.712126 0.292587")
  raw_emit ("  texcoord 0.716510 0.283604")
  raw_emit ("  texcoord 0.721930 0.283604")
  raw_emit ("  texcoord 0.726314 0.292587")
  raw_emit ("  texcoord 0.727989 0.307122")
  raw_emit ("  texcoord 0.708437 0.714971")
  raw_emit ("  texcoord 0.705891 0.692878")
  raw_emit ("  texcoord 0.708437 0.670785")
  raw_emit ("  texcoord 0.715101 0.657131")
  raw_emit ("  texcoord 0.723339 0.657131")
  raw_emit ("  texcoord 0.730003 0.670785")
  raw_emit ("  texcoord 0.732549 0.692878")
  raw_emit ("  texcoord 0.730003 0.714971")
  raw_emit ("  texcoord 0.723339 0.728625")
  raw_emit ("  texcoord 0.715101 0.728625")
  raw_emit ("  texcoord 0.307122 0.769040")
  raw_emit ("  texcoord 0.292587 0.769040")
  raw_emit ("  texcoord 0.285029 0.388229")
  raw_emit ("  texcoord 0.307122 0.388229")
  raw_emit ("  texcoord 0.283604 0.769040")
  raw_emit ("  texcoord 0.271375 0.388229")
  raw_emit ("  texcoord 0.723339 0.388229")
  raw_emit ("  texcoord 0.721930 0.769040")
  raw_emit ("  texcoord 0.716510 0.769040")
  raw_emit ("  texcoord 0.715101 0.388229")
  raw_emit ("  texcoord 0.716396 0.769040")
  raw_emit ("  texcoord 0.707413 0.769040")
  raw_emit ("  texcoord 0.714971 0.388229")
  raw_emit ("  texcoord 0.728625 0.388229")
  raw_emit ("  texcoord 0.692878 0.769040")
  raw_emit ("  texcoord 0.692878 0.388229")
  raw_emit ("  texcoord 0.678344 0.769040")
  raw_emit ("  texcoord 0.670785 0.388229")
  raw_emit ("  texcoord 0.669361 0.769040")
  raw_emit ("  texcoord 0.657131 0.388229")
  raw_emit ("  texcoord 0.283490 0.769040")
  raw_emit ("  texcoord 0.278070 0.769040")
  raw_emit ("  texcoord 0.276661 0.388229")
  raw_emit ("  texcoord 0.284899 0.388229")
  raw_emit ("  texcoord 0.330639 0.769040")
  raw_emit ("  texcoord 0.321656 0.769040")
  raw_emit ("  texcoord 0.329215 0.388229")
  raw_emit ("  texcoord 0.342869 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 11.500000 -2.899997 2.835002")
  raw_emit ("  vertex 13.500000 -2.899997 2.835002")
  raw_emit ("  vertex 13.500000 -2.899997 2.585002")
  raw_emit ("  vertex 11.500000 -2.899997 2.585002")
  raw_emit ("  vertex 11.500000 -4.899998 2.585002")
  raw_emit ("  vertex 13.500000 -4.899998 2.585002")
  raw_emit ("  vertex 13.500000 -4.899998 2.835002")
  raw_emit ("  vertex 11.500000 -4.899998 2.835002")
  raw_emit ("  texcoord 0.298318 0.391939")
  raw_emit ("  texcoord 0.263242 0.391939")
  raw_emit ("  texcoord 0.263242 0.379575")
  raw_emit ("  texcoord 0.298318 0.379575")
  raw_emit ("  texcoord 0.701682 0.379575")
  raw_emit ("  texcoord 0.736758 0.379575")
  raw_emit ("  texcoord 0.736758 0.391939")
  raw_emit ("  texcoord 0.701682 0.391939")
  raw_emit ("  texcoord 0.701682 0.643422")
  raw_emit ("  texcoord 0.736758 0.643422")
  raw_emit ("  texcoord 0.736758 0.742334")
  raw_emit ("  texcoord 0.701682 0.742334")
  raw_emit ("  texcoord 0.356578 0.379575")
  raw_emit ("  texcoord 0.356578 0.391939")
  raw_emit ("  texcoord 0.257666 0.391939")
  raw_emit ("  texcoord 0.257666 0.379575")
  raw_emit ("  texcoord 0.736758 0.356578")
  raw_emit ("  texcoord 0.701682 0.356578")
  raw_emit ("  texcoord 0.701682 0.257666")
  raw_emit ("  texcoord 0.736758 0.257666")
  raw_emit ("  texcoord 0.643422 0.391939")
  raw_emit ("  texcoord 0.643422 0.379575")
  raw_emit ("  texcoord 0.742334 0.379575")
  raw_emit ("  texcoord 0.742334 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  Call TempleSub7
End Sub

Sub TempleSub7()
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 11.750000 -3.149997 10.721587")
  raw_emit ("  vertex 13.250000 -3.149997 10.721587")
  raw_emit ("  vertex 13.250000 -3.149997 10.471587")
  raw_emit ("  vertex 11.750000 -3.149997 10.471587")
  raw_emit ("  vertex 11.750000 -4.649998 10.471587")
  raw_emit ("  vertex 13.250000 -4.649998 10.471587")
  raw_emit ("  vertex 13.250000 -4.649998 10.721587")
  raw_emit ("  vertex 11.750000 -4.649998 10.721587")
  raw_emit ("  texcoord 0.293933 0.781978")
  raw_emit ("  texcoord 0.267627 0.781978")
  raw_emit ("  texcoord 0.267627 0.769614")
  raw_emit ("  texcoord 0.293933 0.769614")
  raw_emit ("  texcoord 0.706067 0.769614")
  raw_emit ("  texcoord 0.732373 0.769614")
  raw_emit ("  texcoord 0.732373 0.781978")
  raw_emit ("  texcoord 0.706067 0.781978")
  raw_emit ("  texcoord 0.732373 0.655786")
  raw_emit ("  texcoord 0.732373 0.729970")
  raw_emit ("  texcoord 0.706067 0.729970")
  raw_emit ("  texcoord 0.706067 0.655786")
  raw_emit ("  texcoord 0.344214 0.769614")
  raw_emit ("  texcoord 0.344214 0.781978")
  raw_emit ("  texcoord 0.270030 0.781978")
  raw_emit ("  texcoord 0.270030 0.769614")
  raw_emit ("  texcoord 0.732373 0.344214")
  raw_emit ("  texcoord 0.706067 0.344214")
  raw_emit ("  texcoord 0.706067 0.270030")
  raw_emit ("  texcoord 0.732373 0.270030")
  raw_emit ("  texcoord 0.655786 0.781978")
  raw_emit ("  texcoord 0.655786 0.769614")
  raw_emit ("  texcoord 0.729970 0.769614")
  raw_emit ("  texcoord 0.729970 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # pillar")
  raw_emit ("# vertices: 20")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 12")
  raw_emit ("")
  raw_emit ("  vertex 17.904510 -3.606106 10.459996")
  raw_emit ("  vertex 17.654507 -3.424470 10.459996")
  raw_emit ("  vertex 17.345493 -3.424470 10.459996")
  raw_emit ("  vertex 17.095493 -3.606105 10.459996")
  raw_emit ("  vertex 17.000000 -3.899997 10.459996")
  raw_emit ("  vertex 17.095493 -4.193891 10.459996")
  raw_emit ("  vertex 17.345493 -4.375526 10.459996")
  raw_emit ("  vertex 17.654507 -4.375526 10.459996")
  raw_emit ("  vertex 17.904507 -4.193891 10.459996")
  raw_emit ("  vertex 18.000000 -3.899997 10.459996")
  raw_emit ("  vertex 16.885147 -4.346714 2.760002")
  raw_emit ("  vertex 16.740002 -3.899997 2.760001")
  raw_emit ("  vertex 16.885147 -3.453281 2.760001")
  raw_emit ("  vertex 17.265148 -3.177194 2.760002")
  raw_emit ("  vertex 17.734852 -3.177194 2.760002")
  raw_emit ("  vertex 18.114853 -3.453281 2.760001")
  raw_emit ("  vertex 18.259998 -3.899997 2.760001")
  raw_emit ("  vertex 18.114853 -4.346714 2.760002")
  raw_emit ("  vertex 17.734852 -4.622801 2.760002")
  raw_emit ("  vertex 17.265148 -4.622801 2.760002")
  raw_emit ("  texcoord 0.814002 0.321656")
  raw_emit ("  texcoord 0.809618 0.330639")
  raw_emit ("  texcoord 0.804198 0.330639")
  raw_emit ("  texcoord 0.799814 0.321656")
  raw_emit ("  texcoord 0.798139 0.307122")
  raw_emit ("  texcoord 0.799814 0.292587")
  raw_emit ("  texcoord 0.804198 0.283604")
  raw_emit ("  texcoord 0.809618 0.283604")
  raw_emit ("  texcoord 0.814002 0.292587")
  raw_emit ("  texcoord 0.815677 0.307122")
  raw_emit ("  texcoord 0.796125 0.714971")
  raw_emit ("  texcoord 0.793579 0.692878")
  raw_emit ("  texcoord 0.796125 0.670785")
  raw_emit ("  texcoord 0.802789 0.657131")
  raw_emit ("  texcoord 0.811027 0.657131")
  raw_emit ("  texcoord 0.817691 0.670785")
  raw_emit ("  texcoord 0.820237 0.692878")
  raw_emit ("  texcoord 0.817691 0.714971")
  raw_emit ("  texcoord 0.811027 0.728625")
  raw_emit ("  texcoord 0.802789 0.728625")
  raw_emit ("  texcoord 0.307122 0.769040")
  raw_emit ("  texcoord 0.292587 0.769040")
  raw_emit ("  texcoord 0.285029 0.388229")
  raw_emit ("  texcoord 0.307122 0.388229")
  raw_emit ("  texcoord 0.283604 0.769040")
  raw_emit ("  texcoord 0.271375 0.388229")
  raw_emit ("  texcoord 0.811027 0.388229")
  raw_emit ("  texcoord 0.809618 0.769040")
  raw_emit ("  texcoord 0.804198 0.769040")
  raw_emit ("  texcoord 0.802789 0.388229")
  raw_emit ("  texcoord 0.716396 0.769040")
  raw_emit ("  texcoord 0.707413 0.769040")
  raw_emit ("  texcoord 0.714971 0.388229")
  raw_emit ("  texcoord 0.728625 0.388229")
  raw_emit ("  texcoord 0.692878 0.769040")
  raw_emit ("  texcoord 0.692878 0.388229")
  raw_emit ("  texcoord 0.678344 0.769040")
  raw_emit ("  texcoord 0.670785 0.388229")
  raw_emit ("  texcoord 0.669361 0.769040")
  raw_emit ("  texcoord 0.657131 0.388229")
  raw_emit ("  texcoord 0.195802 0.769040")
  raw_emit ("  texcoord 0.190382 0.769040")
  raw_emit ("  texcoord 0.188973 0.388229")
  raw_emit ("  texcoord 0.197211 0.388229")
  raw_emit ("  texcoord 0.330639 0.769040")
  raw_emit ("  texcoord 0.321656 0.769040")
  raw_emit ("  texcoord 0.329215 0.388229")
  raw_emit ("  texcoord 0.342869 0.388229")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    texcoords 0 1 2 3 4 5 6 7 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    texcoords 10 11 12 13 14 15 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 17 16")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 7 18 17")
  raw_emit ("    texcoords 21 24 25 22")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 7 6 19")
  raw_emit ("    texcoords 26 27 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 6 5 10 19")
  raw_emit ("    texcoords 30 31 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 5 4 11 10")
  raw_emit ("    texcoords 31 34 35 32")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 3 12 11")
  raw_emit ("    texcoords 34 36 37 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 13 12")
  raw_emit ("    texcoords 36 38 39 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 14 13")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 15 14")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 9 16 15")
  raw_emit ("    texcoords 45 20 23 46")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # bottom")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 16.500000 -2.899997 2.835002")
  raw_emit ("  vertex 18.500000 -2.899997 2.835002")
  raw_emit ("  vertex 18.500000 -2.899997 2.585002")
  raw_emit ("  vertex 16.500000 -2.899997 2.585002")
  raw_emit ("  vertex 16.500000 -4.899998 2.585002")
  raw_emit ("  vertex 18.500000 -4.899998 2.585002")
  raw_emit ("  vertex 18.500000 -4.899998 2.835002")
  raw_emit ("  vertex 16.500000 -4.899998 2.835002")
  raw_emit ("  texcoord 0.210630 0.391939")
  raw_emit ("  texcoord 0.175554 0.391939")
  raw_emit ("  texcoord 0.175554 0.379575")
  raw_emit ("  texcoord 0.210630 0.379575")
  raw_emit ("  texcoord 0.789370 0.379575")
  raw_emit ("  texcoord 0.824446 0.379575")
  raw_emit ("  texcoord 0.824446 0.391939")
  raw_emit ("  texcoord 0.789370 0.391939")
  raw_emit ("  texcoord 0.789370 0.643422")
  raw_emit ("  texcoord 0.824446 0.643422")
  raw_emit ("  texcoord 0.824446 0.742334")
  raw_emit ("  texcoord 0.789370 0.742334")
  raw_emit ("  texcoord 0.356578 0.379575")
  raw_emit ("  texcoord 0.356578 0.391939")
  raw_emit ("  texcoord 0.257666 0.391939")
  raw_emit ("  texcoord 0.257666 0.379575")
  raw_emit ("  texcoord 0.824446 0.356578")
  raw_emit ("  texcoord 0.789370 0.356578")
  raw_emit ("  texcoord 0.789370 0.257666")
  raw_emit ("  texcoord 0.824446 0.257666")
  raw_emit ("  texcoord 0.643422 0.391939")
  raw_emit ("  texcoord 0.643422 0.379575")
  raw_emit ("  texcoord 0.742334 0.379575")
  raw_emit ("  texcoord 0.742334 0.391939")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # top")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 24")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex 16.750000 -3.149997 10.721587")
  raw_emit ("  vertex 18.250000 -3.149997 10.721587")
  raw_emit ("  vertex 18.250000 -3.149997 10.471587")
  raw_emit ("  vertex 16.750000 -3.149997 10.471587")
  raw_emit ("  vertex 16.750000 -4.649998 10.471587")
  raw_emit ("  vertex 18.250000 -4.649998 10.471587")
  raw_emit ("  vertex 18.250000 -4.649998 10.721587")
  raw_emit ("  vertex 16.750000 -4.649998 10.721587")
  raw_emit ("  texcoord 0.206245 0.781978")
  raw_emit ("  texcoord 0.179939 0.781978")
  raw_emit ("  texcoord 0.179939 0.769614")
  raw_emit ("  texcoord 0.206245 0.769614")
  raw_emit ("  texcoord 0.793755 0.769614")
  raw_emit ("  texcoord 0.820061 0.769614")
  raw_emit ("  texcoord 0.820061 0.781978")
  raw_emit ("  texcoord 0.793755 0.781978")
  raw_emit ("  texcoord 0.820061 0.655786")
  raw_emit ("  texcoord 0.820061 0.729970")
  raw_emit ("  texcoord 0.793755 0.729970")
  raw_emit ("  texcoord 0.793755 0.655786")
  raw_emit ("  texcoord 0.344214 0.769614")
  raw_emit ("  texcoord 0.344214 0.781978")
  raw_emit ("  texcoord 0.270030 0.781978")
  raw_emit ("  texcoord 0.270030 0.769614")
  raw_emit ("  texcoord 0.820061 0.344214")
  raw_emit ("  texcoord 0.793755 0.344214")
  raw_emit ("  texcoord 0.793755 0.270030")
  raw_emit ("  texcoord 0.820061 0.270030")
  raw_emit ("  texcoord 0.655786 0.781978")
  raw_emit ("  texcoord 0.655786 0.769614")
  raw_emit ("  texcoord 0.729970 0.769614")
  raw_emit ("  texcoord 0.729970 0.781978")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 5 4 3")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # _private_")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 12")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -20.070013 6.499998 2.600000")
  raw_emit ("  vertex 20.070013 6.499998 2.600000")
  raw_emit ("  vertex 20.070013 6.499998 2.000000")
  raw_emit ("  vertex -20.070013 6.499998 2.000000")
  raw_emit ("  vertex -20.070013 -6.499998 2.000000")
  raw_emit ("  vertex 20.070013 -6.499998 2.000000")
  raw_emit ("  vertex 20.070013 -6.499998 2.600000")
  raw_emit ("  vertex -20.070013 -6.499998 2.600000")
  raw_emit ("  texcoord 0.851980 0.380316")
  raw_emit ("  texcoord 0.148020 0.380316")
  raw_emit ("  texcoord 0.148020 0.350643")
  raw_emit ("  texcoord 0.851980 0.350643")
  raw_emit ("  texcoord 0.148020 0.178536")
  raw_emit ("  texcoord 0.851980 0.178536")
  raw_emit ("  texcoord 0.851980 0.821464")
  raw_emit ("  texcoord 0.148020 0.821464")
  raw_emit ("  texcoord 0.821464 0.350643")
  raw_emit ("  texcoord 0.821464 0.380316")
  raw_emit ("  texcoord 0.178536 0.380316")
  raw_emit ("  texcoord 0.178536 0.350643")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 2 3 0 1")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 6 7 4 5")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 10 11 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # base")
  raw_emit ("# vertices: 32")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 48")
  raw_emit ("# faces: 24")
  raw_emit ("")
  raw_emit ("  vertex -21.474915 6.954998 2.100000")
  raw_emit ("  vertex 21.474915 6.954998 2.100000")
  raw_emit ("  vertex 21.474915 6.954998 1.500000")
  raw_emit ("  vertex -21.474915 6.954998 1.500000")
  raw_emit ("  vertex -21.474915 -6.954998 1.500000")
  raw_emit ("  vertex 21.474915 -6.954998 1.500000")
  raw_emit ("  vertex 21.474915 -6.954998 2.100000")
  raw_emit ("  vertex -21.474915 -6.954998 2.100000")
  raw_emit ("  vertex -22.879816 7.409998 1.600000")
  raw_emit ("  vertex 22.879816 7.409998 1.600000")
  raw_emit ("  vertex 22.879816 7.409998 1.000000")
  raw_emit ("  vertex -22.879816 7.409998 1.000000")
  raw_emit ("  vertex -22.879816 -7.409998 1.000000")
  raw_emit ("  vertex 22.879816 -7.409998 1.000000")
  raw_emit ("  vertex 22.879816 -7.409998 1.600000")
  raw_emit ("  vertex -22.879816 -7.409998 1.600000")
  raw_emit ("  vertex -24.284719 7.864998 1.100000")
  raw_emit ("  vertex 24.284719 7.864998 1.100000")
  raw_emit ("  vertex 24.284719 7.864998 0.500000")
  raw_emit ("  vertex -24.284719 7.864998 0.500000")
  raw_emit ("  vertex -24.284719 -7.864998 0.500000")
  raw_emit ("  vertex 24.284719 -7.864998 0.500000")
  raw_emit ("  vertex 24.284719 -7.864998 1.100000")
  raw_emit ("  vertex -24.284719 -7.864998 1.100000")
  raw_emit ("  vertex -25.689621 8.319999 0.600000")
  raw_emit ("  vertex 25.689621 8.319999 0.600000")
  raw_emit ("  vertex 25.689621 8.319999 0.000000")
  raw_emit ("  vertex -25.689621 8.319999 0.000000")
  raw_emit ("  vertex -25.689621 -8.319999 0.000000")
  raw_emit ("  vertex 25.689621 -8.319999 0.000000")
  raw_emit ("  vertex 25.689621 -8.319999 0.600000")
  raw_emit ("  vertex -25.689621 -8.319999 0.600000")
  raw_emit ("  texcoord 0.876618 0.355588")
  raw_emit ("  texcoord 0.123382 0.355588")
  raw_emit ("  texcoord 0.123382 0.325915")
  raw_emit ("  texcoord 0.876618 0.325915")
  raw_emit ("  texcoord 0.123382 0.156034")
  raw_emit ("  texcoord 0.876618 0.156034")
  raw_emit ("  texcoord 0.876618 0.843966")
  raw_emit ("  texcoord 0.123382 0.843966")
  raw_emit ("  texcoord 0.843966 0.325915")
  raw_emit ("  texcoord 0.843966 0.355588")
  raw_emit ("  texcoord 0.156034 0.355588")
  raw_emit ("  texcoord 0.156034 0.325915")
  raw_emit ("  texcoord 0.901257 0.330860")
  raw_emit ("  texcoord 0.098743 0.330860")
  raw_emit ("  texcoord 0.098743 0.301187")
  raw_emit ("  texcoord 0.901257 0.301187")
  raw_emit ("  texcoord 0.098743 0.133531")
  raw_emit ("  texcoord 0.901257 0.133531")
  raw_emit ("  texcoord 0.901257 0.866469")
  raw_emit ("  texcoord 0.098743 0.866469")
  raw_emit ("  texcoord 0.866469 0.301187")
  raw_emit ("  texcoord 0.866469 0.330860")
  raw_emit ("  texcoord 0.133531 0.330860")
  raw_emit ("  texcoord 0.133531 0.301187")
  raw_emit ("  texcoord 0.925896 0.306132")
  raw_emit ("  texcoord 0.074104 0.306132")
  raw_emit ("  texcoord 0.074104 0.276459")
  raw_emit ("  texcoord 0.925896 0.276459")
  raw_emit ("  texcoord 0.074104 0.111029")
  raw_emit ("  texcoord 0.925896 0.111029")
  raw_emit ("  texcoord 0.925896 0.888971")
  raw_emit ("  texcoord 0.074104 0.888971")
  raw_emit ("  texcoord 0.888971 0.276459")
  raw_emit ("  texcoord 0.888971 0.306132")
  raw_emit ("  texcoord 0.111029 0.306132")
  raw_emit ("  texcoord 0.111029 0.276459")
  raw_emit ("  texcoord 0.950534 0.281404")
  raw_emit ("  texcoord 0.049466 0.281404")
  raw_emit ("  texcoord 0.049466 0.251731")
  raw_emit ("  texcoord 0.950534 0.251731")
  raw_emit ("  texcoord 0.049466 0.088526")
  raw_emit ("  texcoord 0.950534 0.088526")
  raw_emit ("  texcoord 0.950534 0.911474")
  raw_emit ("  texcoord 0.049466 0.911474")
  raw_emit ("  texcoord 0.911474 0.251731")
  raw_emit ("  texcoord 0.911474 0.281404")
  raw_emit ("  texcoord 0.088526 0.281404")
  raw_emit ("  texcoord 0.088526 0.251731")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 2 3 0 1")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 6 7 4 5")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 10 11 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 9 10 11")
  raw_emit ("    texcoords 12 13 14 15")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 12 13 14 15")
  raw_emit ("    texcoords 14 15 12 13")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 11 10 13 12")
  raw_emit ("    texcoords 16 17 18 19")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 10 9 14 13")
  raw_emit ("    texcoords 20 21 22 23")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 9 8 15 14")
  raw_emit ("    texcoords 18 19 16 17")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 8 11 12 15")
  raw_emit ("    texcoords 22 23 20 21")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 16 17 18 19")
  raw_emit ("    texcoords 24 25 26 27")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 20 21 22 23")
  raw_emit ("    texcoords 26 27 24 25")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 19 18 21 20")
  raw_emit ("    texcoords 28 29 30 31")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 18 17 22 21")
  raw_emit ("    texcoords 32 33 34 35")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 17 16 23 22")
  raw_emit ("    texcoords 30 31 28 29")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 16 19 20 23")
  raw_emit ("    texcoords 34 35 32 33")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 24 25 26 27")
  raw_emit ("    texcoords 36 37 38 39")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 28 29 30 31")
  raw_emit ("    texcoords 38 39 36 37")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 27 26 29 28")
  raw_emit ("    texcoords 40 41 42 43")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 26 25 30 29")
  raw_emit ("    texcoords 44 45 46 47")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 25 24 31 30")
  raw_emit ("    texcoords 42 43 40 41")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 24 27 28 31")
  raw_emit ("    texcoords 46 47 44 45")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  raw_emit ("")
  raw_emit ("mesh # _private_")
  raw_emit ("# vertices: 8")
  raw_emit ("# normals: 0")
  raw_emit ("# texcoords: 12")
  raw_emit ("# faces: 6")
  raw_emit ("")
  raw_emit ("  vertex -20.070013 6.499998 11.379993")
  raw_emit ("  vertex 20.070013 6.499998 11.379993")
  raw_emit ("  vertex 20.070013 6.499998 10.779993")
  raw_emit ("  vertex -20.070013 6.499998 10.779993")
  raw_emit ("  vertex -20.070013 -6.499998 10.779993")
  raw_emit ("  vertex 20.070013 -6.499998 10.779993")
  raw_emit ("  vertex 20.070013 -6.499998 11.379993")
  raw_emit ("  vertex -20.070013 -6.499998 11.379993")
  raw_emit ("  texcoord 0.851980 0.814540")
  raw_emit ("  texcoord 0.148020 0.814540")
  raw_emit ("  texcoord 0.148020 0.784866")
  raw_emit ("  texcoord 0.851980 0.784866")
  raw_emit ("  texcoord 0.148020 0.178536")
  raw_emit ("  texcoord 0.851980 0.178536")
  raw_emit ("  texcoord 0.851980 0.821464")
  raw_emit ("  texcoord 0.148020 0.821464")
  raw_emit ("  texcoord 0.821464 0.784866")
  raw_emit ("  texcoord 0.821464 0.814540")
  raw_emit ("  texcoord 0.178536 0.814540")
  raw_emit ("  texcoord 0.178536 0.784866")
  raw_emit ("  face")
  raw_emit ("    vertices 0 1 2 3")
  raw_emit ("    texcoords 0 1 2 3")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 4 5 6 7")
  raw_emit ("    texcoords 2 3 0 1")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 3 2 5 4")
  raw_emit ("    texcoords 4 5 6 7")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 2 1 6 5")
  raw_emit ("    texcoords 8 9 10 11")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 1 0 7 6")
  raw_emit ("    texcoords 6 7 4 5")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("  face")
  raw_emit ("    vertices 0 3 4 7")
  raw_emit ("    texcoords 10 11 8 9")
  raw_emit ("    matref templeCol")
  raw_emit ("  endface")
  raw_emit ("end")
  
  raw_emit ("enddef")
  raw_emit ("group temple")
  raw_emit ("  shift " & nArg(templeX) & " " & nArg(templeY) & " " & nArg(templeZ))
  raw_emit ("  scale " & nArg(templeSX) & " " & nArg(templeSY) & " " & nArg(templeSZ))
  raw_emit ("end")
End Sub

